CHANGES
=======

* Fix regression in ramdisk deploy kernel parameters
* Fixes missing argument for log format string
* Configure CI for bugfix/18.1
* Update .gitreview for bugfix/18.1

18.1.0
------

* Update vendor\_passthru subscriptions releasenote
* Prepare 18.1 and clean up release notes
* Add vendor\_passthru method for subscriptions
* Set glance limit for baremetal friendly images
* Scoped RBAC Devstack Plugin support
* Burn-in: Add documentation
* Add a section to redfish doc for BIOS registry fields
* Fix iPXE docs: snponly is not always available
* Update requirements
* Sanity check object version changes
* Allow reboot to hard disk following iso ramdisk deploy
* Add ipxe ramdisk kernel append param test
* Update iDRAC virtual media boot known issue
* Add \`boot\_mode\` and \`secure\_boot\` to node object and expose in api
* Add missing BIOSSettings version mapping for older releases
* Fix typos in API sanitization change notes
* Bring boot\_iso/deploy\_iso handling in iLO closer to Redfish
* Use selectinload for all list queries
* Clean up images when ejecting an ISO with Redfish
* Allow node\_sanitize function to be provided overrides
* Avoid double file removal in create\_boot\_iso
* Add note regarding configuration drives to tuning docs
* Support "swift" for ramdisk\_image\_download\_source
* Defer checking image size until instance info is built
* Fix oslo policy DeprecatedRule warnings
* Add support for configdrive in anaconda interface
* Add reno and reset legacy policy deprecation expectation
* [doc] Bootloader reinstallations on Software RAID
* [doc] Update section on ESP consistency
* Fix Redfish RAID interface\_type physical disk hint
* Suppress policy deprecation and default change warnings
* Skip port create if MAC is blank
* Ramdisk: do not require image\_source
* Refactor deploy\_utils.validate\_image\_properties
* Redfish: Skip non-RAID controllers for RAID
* Deprecate [pxe]ip\_version parameter
* Upgrade oslo.db version
* Update the clear job id's constant
* API to pass fields to node object list
* Set stage for objects to handle selected field lists
* Only return the requested fields from the DB
* Cache AgentClient on Task, not globally
* Change UEFI ipxe bootloader default
* Refactor: untie IloVendor from validate\_image\_properties
* Fix handling driver\_info[agent\_verify\_ca] == False
* Fix ramdisk boot option handling
* Allow ramdisk\_image\_download\_source in instance\_info for ramdisk deploy
* Nicer error message when a deploy step fails
* Don't run the inspector job on changes to inspector tests
* CI: change ilo\_deploy\_iso to deploy\_iso
* Fix node detail instance\_uuid request handling
* Clean up vendor prefixes for iRMC boot
* Add documentation for anaconda deploy interface
* Fix typos in inspection docs
* Remove redundant/legacy is\_admin logic
* Split a community page out of the contributor docs
* Document managed inspection
* dhcp-less: mention how to provide network\_data to instance
* Use env to find python3
* Rename ilo\_boot\_iso -> boot\_iso
* Clean up vendor prefixes for iLO boot
* Handle non-key-value params in [inspector]extra\_kernel\_params
* Fix ironic-status db index check
* Changes made to enrollment documentation
* Update Redfish RAID disk\_type unit test
* Redfish: Get only RAID controller's physical disks

18.0.0
------

* Changes made to release documentation:
* Prepare 18.0 and clean up release note
* Trivial: Fix version number in comment
* Improve agent\_client logging
* Add bifrost-benchmark-ironic job
* Trivial: fix an outdated link
* Move provision states documentation to the user guide
* Follow-up to  Include bios registry fields in bios API
* Include bios registry fields in bios API
* Update project conundrum related docs
* Add basic tools for benchmarking
* Secure RBAC - Efficent node santiziation
* Add missing bios\_interface to api-ref for validate API
* Trivial: comment why we don't check retired in allocations
* Refactor iDRAC OEM extension manager calls
* Retrieve BIOS registry from sushy
* Delay rendering configdrive
* Remove inventory time workaround for WS-man BIOS
* Rename redfish\_deploy\_iso -> deploy\_iso
* Add additional node indexes
* Update min version of tox to use allowlist
* Clean up kernel\_append\_params for iRMC
* Clean up kernel\_append\_params for Redfish and iLO
* Clean up kernel\_append\_params for PXE/iPXE
* Add bios\_interface to api-ref spec
* Expand the deployment guide
* setup.cfg: Replace dashes with underscores
* [doc] Update documentation about force\_persistent\_boot\_device
* Rework the user guide
* Upgrade guide: remove ancient versions and group with Installation
* Delete unavailable py2 package
* Fix deployment when executing a command fails after the command starts
* Document the custom-agent deploy interface
* Provide an option to not cache bootable iso ramdisks
* Avoid unnecessary validation in boot interfaces
* Inherit InvalidImageRef from InvalidParameterValue
* Bye-bye iSCSI deploy, you served us well
* Update refarch with information about image\_download\_source
* Clean up deprecated features of the agent deploy
* Stop testing the iscsi deploy interface
* Deploy interface that fully relies on custom deploy steps
* Do not mask configdrive when executing in-band deploy steps
* Docs: dhcp-less works with Glean 1.19.0
* Follow up to add iDRAC management via Redfish
* Remove temporary cleaning information on starting cleaning
* Update CI jobs list and description in docs
* [doc][trivial] Fix diagram in agent token admin docs
* [doc][trivial] Fix typo in agent token admin docs
* Update basic local.conf for quickstart
* Read default cirros version from stackrc
* Aliases for a few unfortunately named state transitions
* Process in-band deploy steps on fast-track
* Followup patch for security dashboard clean steps
* Remove a pause before cleaning when fast-tracking
* Fix fast track with redfish-virtual-media
* Update to not use deprecated \`get\_task\_monitor\`
* Do not use pregenerated tokens with a pre-built ISO
* Wipe agent tokens on inspection start and abort
* Fix idrac-wsman BIOS factory\_reset result finding
* Update python-dracclient version
* Add security dashboard clean steps to ilo drivers
* Imported Translations from Zanata
* Update release note version header for wallaby
* Add Python3 xena unit tests
* Update master for stable/wallaby
* Followup idrac configuration mold steps

17.0.0
------

* Add agent\_status and agent\_status\_message params to heartbeat
* Restrict syncing of boot mode to Supermicro
* Follow-up Automaticaly set cipher suite
* Add iDRAC management via Redfish to idrac HW type
* Generic way to configure clean step priorites
* Fix typo in security docs around is\_admin rule
* Fix configuration generation for ironic doc pages
* Fix Bandit check
* Always add 'boot\_method' vmedia in redfish/ilo vmedia boot
* Add import, export configuration to idrac-redfish
* Move configuration mold utilities
* [doc] Warning about out-of-sync ESPs for UEFI software RAID
* [doc] Update available software RAID levels
* Automaticaly set cipher suite
* Fix webserver\_verify\_ca config documentation
* Allow using per-site network\_data schema
* Add configuration mold storage
* DRAC : idrac-redfish inspect updates pxe port
* update grub2 file name
* redfish boot\_interfaces, ipmitool -> pxe
* redfish-virtual-media: allow USB devices instead of floppies
* Allow overriding an external URL for virtual media
* Fix idrac-wsman BIOS step async error handling
* Follow up of Use OOB inspection to fetch MACs for IB inspection
* Validate the kickstart template and file before use
* Add anaconda support in the pxe boot driver
* Allow running RAID cleaning steps with in-band cleaning
* Support pre-built deploy/rescue ISO in Redfish
* Version 17.0 mapping/doc updates
* Add prelude for Ironic 17.0
* Add known iDRAC virtual media boot issue
* Update idrac-redfish RAID release note
* Remove extra/vif\_port\_id
* Revise release notes for 17.0 release
* Allow unsupported redfish set\_boot\_mode
* Add anaconda configuration and template
* Add Redfish RAID interface to idrac HW type
* Follow-up to RBAC allocation changes
* Increment API version for Secure RBAC
* Add runtime gpu capabilities to ilo inspection
* Deprecate legacy policies, update project scoped docs
* Enable Reuse of Zuul Job in 3rd Party CI Environment
* Add iRMC Driver Support to DevStack Code
* API to force manual cleaning without booting IPA
* Allow ansible deploys to be fast-tracked
* Trivial: add a missing argument to an exception
* Allocation support for project scoped RBAC
* Mark multinode non-voting due to high failure rate
* Don't try to use attempts=None with tenacity
* [doc] Add initial system-scoped text to secure-rbac
* Switch to JSON RPC from ironic-lib
* Update dev quickstart docs
* Update Redfish RAID release note
* Allow users to configure priority for {create,delete}\_configuration
* Add CentOS7 for supported ramdisk for dhcpless deploy
* RBAC Follow-up: Review follow-up
* Enforce autospec in test\_console\_utils
* Rework the standalone guide
* docs: move overriding interfaces to the standalone documentation
* Update iDRAC doc with idrac-redfish-virtual-media
* Update iDRAC doc on Redfish vendor passthru interface
* Allow instance\_info to override node interface
* Allow support for multipath volumes
* Enforce autospec in test\_portgroup
* Revert "Update iDRAC doc with missing interfaces"
* Follow-up on project scoped trait tests
* Project scope driver vendor pass-through
* Volume targets/connectors Project Scoped RBAC
* Enforce autospec in test\_port
* Enforce autospec in test\_volume\_connector
* Enforce autospec in test\_volume\_target
* Add Redfish RAID management to Ironic
* Port/Portgroup project scoped access
* Project Scoping Node endpoint
* Add support for using NVMe specific cleaning
* Prepare to use tinycore 12 for tinyipa
* Lazy-load node details from the DB
* Adds config parameter kernel\_append\_param for iLO
* secure-rbac - minor follow-up for project scoped tests
* Add both IPv4 and IPv6 DHCP options if interface has both
* [Trivial] Fix testing of volume connector exception
* Switch iLO and iRMC to the new secure boot framework
* devstack: a safeguard for disabled tempurls
* Enable swift temporary URLs in grenade and provide a good error message
* [trivial] Remove default parameter from execute
* Initial Project scoped tests
* RBAC System Scope: observer -> reader
* Implement system scoped RBAC for the deploy templates APIs
* Implement system scoped RBAC for the event APIs
* [trivial] fix typos in conductor
* Enforce autospec in test\_driver
* Review feedback follow-up on Node System Scoped RBAC
* Implement system scoped RBAC for the allocation APIs
* Implement system scoped RBAC for conductor APIs
* Implement system scoped RBAC for volume APIs
* Implement system scoped RBAC for utility APIs
* Implement system scoped RBAC for node and driver passthru
* Implement system scoped RBAC for baremetal drivers
* Implement system scoped RBAC for chassis
* Implement system scoped RBAC for port groups
* Implement "system" scoped RBAC for ports
* Implement "system" scoped RBAC for the node endpoint
* Add support for using NVMe specific cleaning
* Trivial: fix incorrect ordering in iLO tests
* Enforce autospec in test\_notification\_utils module
* Enforce autospec in test\_node
* Correct release mappings for 16.2
* Fix broken configdrive\_use\_object\_store
* Replace pysendfile with os.sendfile
* Validate configdrive string format
* Enforce autospec in test\_chassis
* Replace retrying with tenacity
* Switch multinode jobs to 512M RAM
* Add some tuning documentation

16.2.0
------

* Move the IPv6 job to the experimental pipeline
* Trivial: update version for deploy steps
* Address some rbac review feedback in merged patches
* Introduce common personas for secure RBAC
* Duplicate testing for system scoped ACL testing
* Populate existing policy tests
* devstack: support installing ironic-lib from source in DIB IPA
* Prepare 16.2 and clean up release note
* Report the slowest tests after a test run
* Use OOB inspection to fetch MACs for IB inspection
* Generate policy.yaml.sample
* Add support to manage certificates in iLO
* Update oslo.policy requirement to version 3.6.2
* Prevent redfish-virtual-media from being used with Dell nodes
* Don't mark an agent as alive if rebooted
* Add 'deploy steps' parameter for provisioning API
* Trivial: log the newly detected vendor
* Swap Metalsmith job out for centos8-uefi
* More GPU support in idrac-wsman inspect interface
* Make boot\_mode more consistent with other capabilities
* ilo: do not change deploy\_boot\_mode in instance\_info
* Apply force\_persistent\_boot\_device to all boot interfaces
* Add release version to release notes
* Fix Mis-Ordering of Bash Variable Definition in DevStack
* Fixes issue of redfish firmware update
* Update python packages to python3 in quickstart.rst
* Set default to prevent out of memory conditions
* Guard conductor from consuming all of the ram
* For Supermicro BMCs set enable when changing boot device
* Refactor vendor detection and add Redfish implementation
* Add a few words about UEFI user images
* Redfish secure boot management
* Add centralized secure boot documentation
* Pass context objects directly to policy enforcement
* redfish-virtual-media: allow a link to raw configdrive image
* Update minversion of tox
* Attempt to slim down protection test base class
* Write stub ACL test for every existing API call
* Update iDRAC doc with missing interfaces
* Raw image size estimation improved
* Bump oslo.log requirement to 4.3.0
* Common framework for configuring secure boot
* redfish-virtual-media: make fewer calls when preparing boot
* Add a delay/retry is vmedia insert fails
* Fix redfish-virtual-media boot mode handling ordering
* Enable testing to dynamicly leverage ACL roles
* CI: Collect a snapshot of network connections
* Follow-up for ramdisk deploy configdrive support
* Register all hardware\_interfaces together
* Do not enter maintenance if cleaning fails before running the 1st step
* Policy json to yaml migration
* Add troubleshooting on changing ironic.conf default interfaces
* Modify port group document for ironic
* add openstack-python3-wallaby-jobs-arm64 job
* Mark the iSCSI deploy as deprecated in the docs
* update python packages to python3 in quickstart.rst
* Support configdrive when doing ramdisk deploy with redfish-virtual-media

16.1.0
------

* Update outdated descripton for \`default\_boot\_option\`
* remove lower-constraints in tox
* Rewrite existing ACL tests with ddt, yaml
* Consistently use utils functions for policy auth
* Document that DHCP-less deploy does work with debian-minimal
* Document using ramdisks with the ramdisk deploy interface
* Include HeartbeatMixin in the ramdisk deploy
* Remove detect\_vendor decorator
* Complete the REST API POST documentation
* [doc-only] Add BFV basic flow and networking context
* Remove lower-constraints job
* Revert "devstack: build DIB images with CentOS Stream by default"
* Document the current status of the DHCP-less deploy
* Rewrite DHCP-less documentation
* Inject TLS certificate when using virtual media
* Fix release guide and include intermediate branches
* Avoid a full install in tox environments that do not need it
* Prepare release 16.1
* IPMI: Handle vendor set boot device differences
* CI: switch the multinode job to tempest-multinode-full-base
* Do not pin Python version in tox config
* Use ddt for existing policy tests
* Fix lower-constraints with the new pip resolver
* devstack: build DIB images with CentOS Stream by default
* Add TLS troubleshooting guide entry
* Support port name
* Use openstack-tox for ironic-tox-unit-with-driver-libs
* Test patching booleans with string values
* Improve object\_to\_dict arguments
* CI: add a non-voting bifrost-vmedia-uefi job
* Add secure boot support to ilo-uefi-https
* JSON conversion followup change
* Allow disabling automated\_clean per node
* Always retry locking when performing task handoff
* Add vendor\_passthru method for virtual media
* Make standalone jobs voting again
* Expunge the internal version of WSME
* Convert volume/targets endpoint to plain JSON
* Convert volume/connectors endpoint to plain JSON
* Don't allow patching port internal\_info
* [doc][trivial] Fix spelling error
* Fix disk label to account for UEFI
* Minor follow-up doc change
* Remove from\_dict function from context
* Update .rst files
* Convert volume endpoint to plain JSON
* Convert ramdisk endpoint to plain JSON
* Convert portgroups endpoint to plain JSON
* Convert ports endpoint to plain JSON
* Convert nodes endpoint to plain JSON
* Convert event endpoint to plain JSON
* Convert drivers endpoint to plain JSON
* Convert deploy\_templates endpoint to plain JSON
* Convert conductors endpoint to plain JSON
* Convert chassis endpoint to plain JSON
* Convert bios endpoint to plain JSON
* Convert allocations endpoint to plain JSON
* Utility functions for REST API JSON handling
* Duplicate trait validation with jsonschema
* Add expose body decorator, status\_code argument
* New argument validate decorator
* Update \`cleaning\_error\_handler\`
* Convert last bionic jobs to focal
* Simplify injecting network data into an ISO image
* Fix incorrect network\_data.json location
* Retrieve BIOS configuration when moving node to \`\`manageable\`\`
* Document how to build an ESP image for redfish-virtual-media
* Fix DHCP-less operations with the noop network interface
* Make driver documentation more prominent on the landing page
* Fixes the issue that instance bond port can't get IP address
* Docs: a more complete example of ramdisk boot with redfish-virtual-media
* Limit the default value of [api]api\_workers to 4
* Enforce autospec in some api controllers modules
* Update TOX\_CONSTRAINTS\_FILE
* Fix idrac-wsman RAID step async error handling
* Fix redfish BIOS apply config error handling
* Enforce autospec in some api controllers modules
* Fix typo in ipxe\_config.template
* Prevent timeouts when using fast-track with redfish-virtual-media
* Handle agent still doing the prior command
* Make redfish-virtual-media respect default\_boot\_mode
* devstack: log all requests to sushy-emulator
* Remove the support to create port in API
* Mark standalone job non-voting/remove from gate
* json-rpc: surround IPv6 address with [] in conductor URL
* Changes to add exception in "default\_interface()" function
* Move the multinode grenade job to the experimental pipeline
* CI: increase cleaning timeout and tie it to PXE boot timeout
* devstack: remove no longer required UEFI hacks
* Fixes empty physical\_network is not guarded
* Add node name to ironic-conductor ramdisk log filename
* Add timeout to image operations in the direct deploy
* Allow passing rootfs\_uuid for the standalone case
* Sync boot mode when changing the boot device via Redfish
* Revert patching \_syscmd\_uname
* Python 3.9: base64.{en,de}codestring function is removed
* Document by\_path root device hint
* Change auth type to none in dev-quickstart
* Update test requirements
* Update .rst files
* Fix ipmitool timing argument calculation
* Run bifrost integration job on focal
* Use centos as base element for dib images
* Do not pass BOOTIF=None if no BOOTIF can be guessed
* Remove obsolete trusted boot doc
* Update checking reno script to use python3
* Remove root device hint after delete\_configuration
* docs: Add information on post-branch release tasks for bifrost
* Log the ports we bind in flat
* Updates ironic documentation
* Refactoring: split away continue\_node\_deploy/clean
* Trivial: use the correct error handler for do\_next\_clean\_step
* Wiping agent tokens on reboot via API - take 2
* migrate testing to ubuntu focal
* CI: update bindep for centos-8 py36 job changes
* Imported Translations from Zanata
* Fix inspection for idrac
* Clarify power state logging
* Add Python3 wallaby unit tests
* Update master for stable/victoria

16.0.0
------

* Add GPU reporting to idrac-wsman inspect interface
* Don't migrate away from iscsi if it is the default
* Minor agent version code cleanup
* Support iRMC hardware type again
* devstack: do not default to swift if SWIFT\_ENABLE\_TEMPURLS is False
* Trivial: fix formatting in the prelude
* Fix handling OctetString for pysnmp
* Handle patching node /protected value with None
* Remove compatibility with conductors that do not support groups
* Handle conductor\_affinity earlier in the deployment process
* Update 'idrac' driver requirements for Victoria
* Redfish driver firmware update
* Release notes prelude for the Victoria release
* Do not silently ignore exceptions when running next steps
* Fix a race condition in the hash ring code
* Follow-up patch for iso less vmedia support
* Route conductor notification RPC to the same conductor
* Fix invalid assert\_has\_calls
* Adding changes for iso less vmedia support
* Use correct error handler instead of calling process\_event('fail')
* Fix deprecated 'idrac' interface '\_\_init\_\_'s
* Amend the agent\_verify\_ca release note to mention the configuration option
* Add documentation for ISO boot
* Update release mappings and API history for 16.0
* autospec for classmethods and staticmethods for Python < 3.7.4
* Release note updates for Victoria release
* Update tests for Redfish BIOS apply\_configuration
* Add Redfish BIOS interface to idrac HW type
* Expose agent\_verify\_ca in configuration and correctly handle booleans
* Use tempdirs for /tftpboot, /httpboot creation tests
* Fix redfish BIOS to use @Redfish.SettingsApplyTime
* Make the standalone-redfish job voting
* Deprecate the iscsi deploy interface
* Reduce VMs for multinode and standalone jobs
* Reduce grenade node count
* Limit inspector jobs to 1 testing VM
* CI: Remove the build check for pre-build ramdisks only
* Do not retry locking when heartbeating
* Adds ilo-uefi-https boot interface to ilo5
* Native zuulv3 grenade multinode multitenant
* Allow configuring IPMI cipher suite
* Clarify HPE Edgeline support
* Add redfish options to the generated docs
* Also wipe agent token on manual power off or reboot
* Remove install unnecessary packages
* Fix lower-constraints for Ubuntu Focal
* Add release note for dhcp-less deploy
* Handle default\_boot\_mode during cleaning/inspection with PXE/iPXE
* Add 'agent\_token' to heartbeat request
* Follow-up patch for One Button Secure Erase clean step
* Accept and use a TLS certificate from the agent
* clean up mac address with the pxe configuration files
* Change [agent]image\_download\_source=http
* Add an option to require TLS for agent callback\_url
* Allow HttpImageService to accept custom certificate
* Adds few of the security dashboard parameters to capabilities
* Remove token-less agent support
* Detail iPXE + LACP troubleshooting information
* Do not assume that prepare\_image is the last command to run
* OOB one button secure erase for iLO5 based HPE Proliant servers
* Add missing log for clean failed
* Trivial: fix minor typo on RFC number
* Update deploy steps documentation
* documentation: follow-up to file:// support in direct deploy
* Enhance certificate verification for ilo harware type
* Add L3 boot section to the docs
* Allow setting image\_download\_source per node
* Support caching http:// images locally in the direct deploy
* Support file:/// images for the direct deploy
* Explicitely do not allocate initial space for virtual volumes
* Feat: add ibmc hardware info support for devstack
* [trivial] remove emacs config from devstack script
* Remove absolute path with iptables when L3 enabled
* Update nodes in notifications documentation
* Suffix the ISO names with '.iso'
* Remove the unused coding style modules
* driver\_internal\_info in provision notifications
* Enforce autospec in ilo tests
* Enforce autospec in common tests
* Decouple the ISO creation logic from redfish
* Ansible deploy - Ignore invalid devices
* Move redfish-virtual-media to the back of supported\_boot\_interfaces
* Increase memory of tinyipa vms
* Ensure in-band deploy steps are present in time for fast-track deployments
* Fix network\_data path for dhcpless deployments
* Switch Ironic to openstacksdk for Neutron
* Fix: port attribute name propagate\_uplink\_status
* Remove qemu-img rootwrap filter
* ISO ramdisk virtual media test enablement
* Documentation update for ilo hardware type

15.2.0
------

* Fix time usage in unit tests for agent power interface
* Enforce autospec in irmc tests
* Pass global-request-id to ironic-python-agent
* [Trivial]Fix some typos in docs
* Handle an older agent with agent\_token
* Follow up to I44336423194eed99f026c44b6390030a94ed0522
* Adds support SUM based firmware update as deploy step
* Enforce autospec in xclarity tests
* Enforce autospec in test\_cinder
* agent\_client: support custom TLS certificates
* Use property plus abstractmethod for abstractproperty
* Fix console auto port allocation under IPv6
* Fix iscsi deploy steps priorities
* Wipe agent token and URL on rescue and unrescue
* Fix error word presistent in docs
* Prevents power sync with ADOPTFAIL nodes
* Change UEFI PXE job to use tinyipa
* Enable deploy-time software RAID in standalone jobs
* Use TLS for json\_rpc when configured
* Log the traceback of unexpected errors when verifying power credentials
* Add cirros-specific FAQ item for troubleshooting
* Fix idrac-wsman RAID apply\_configuration
* Break out collection functions for json usage
* Convert v1 controller to plain, return JSON
* Convert root controller to plain controller
* Enforce autospec in test\_iscsi\_deploy
* Fix invalid assertTrue which should be assertEqual
* Trivial: fix a minor issue in standalone docs and improve formatting
* AgentRAID: Account for empty results in post-configuration checks
* Remove locks before RPC bus is started
* Mark IPv6 job as non-voting to unblock the gate
* Reset power state upon adoption failure
* Make the final deploy step validation actually fail deploy
* Enforce autospec in some api tests
* Add subsections to the standalone documentation
* Deprecate http\_basic\_username and http\_basic\_password in [json\_rpc]
* Adds raid validation for in-band AgentRAID deploy step
* Allow node lessee to see node's ports
* Force RAX hosts to run tinyipa
* Update how to release section
* Extend PXE boot retry timeout for RAX hosts
* Add an option to choose the hash ring algorithm
* Extend base build timeouts
* Stop running test\_schedule\_to\_all\_nodes in the multinode job
* Document fast-track and the agent power interface
* Add agent power interface
* Account for power interfaces that cannot power on
* Convert root path / to use plain JSON
* Rename Response to PassthruResponse
* Remove Link type
* Remove File type
* Update number of VM on ironic-base
* Replace oslo\_utils.netutils type compares with ipaddress
* Auto extend the timeout for RAX hosts
* Allow disabling retries in AgentClient.get\_command\_statuses
* Explicitly set jobs to ML2/OVS
* Enforce autospec in test\_notification\_utils
* Enforce autospec in test\_deployments
* iPXE ISO Ramdisk booting
* Follow-up on blocking port deletions
* Remove old driver name from cross-gating job
* Stop wiping driver\_internal\_info on node.driver updates
* Ironic to use DevStack's neutron"-legacy" module
* Fixes to skip validation of in-band deploy steps before agent boot
* Implement get\_deploy\_steps for AgentRAID
* Set min version of tox to 3.2.1
* Use default timeout for all jobs
* Wipe agent token during reboot or power off
* Add missing agent RAID compatibility for ilo5 and idrac
* Add wsme core types, remove WSME
* Add json and param parsing to args
* Change non-tinyipa jobs to use multiple cores
* Add knob for read-only and "erase\_devices"
* Decompose the core deploy step on iscsi and ansible deploy
* Iso booting via redfish virtual media
* Use min\_command\_interval when ironic does IPMI retries
* fix error word presistent in docs
* Remove non-inclusive language
* fix error word confiuration to configuration in docs
* add tempest boot\_mode config

15.1.0
------

* Decompose the core deploy step of the direct deploy
* agent\_base: support inserting in-band deploy steps
* Add documentation on how to propose a release
* Provide a path to set explicit ipxe bootloaders
* Do not verify error messages from jsonpatch in unit tests
* Use assertCountEqual instead of assertItemsEqual, part 2
* Enforce autospec in test\_task\_manager
* Stop using md5 for \_\_repr\_\_ of objects
* Follow up of enforce autospec in test\_manager
* CI: Make ipv6 job to voting
* Allow deleting nodes with a broken driver
* Do not validate driver on changing non-driver fields
* Follow up of fix uefi jobs with ovmf native ubuntu package
* Fix missing print format in log message
* Use native oslo.concurrency execution timeout in ipmitool
* [doc] Describe how to extract an fs UUID from an image
* Do not put the whole JSON error from the agent in last\_error
* Use unittest mock instead of 3rd party mock in test\_raid
* Correct Redfish boot once fallback conditional
* Fix the error message when reached max number of traits
* Software RAID: don't try to set local\_gb to MAX
* Clean up nodes in DELETING on conductor restart
* Log when a node should be fast-track-able but it's not
* Fix uefi jobs with native ubuntu ovmf package
* Enforce autospec in test\_manager
* Prepare release notes and docs for release 15.1
* Add ironic 15.1 release mapping
* Use getfullargspec to inspect functions
* Fix fast track following managed inspection
* Add \`get\_node\_network\_data\` to Neutron NetworkInterface
* Adds boot mode support to iLO management interface
* Explicitly use python3 for ironic\_lib\_prefix
* Fix hacking min version to 3.0.1
* devstack: get rid of python3\_enabled
* Use IRONIC\_VM\_SPECS\_RAM from ironic-base in ipv6 job
* Update git URLs
* Minor agent token log handling
* DRAC: Fix a failure to create virtual disk
* Use virtio bus with uefi
* Untie the ramdisk deploy from AgentDeploy
* Enforce autospec in test\_utils
* Enforce autospec in test\_flat
* Enforce autospec in test\_common
* Update [console]kill\_timeout description
* Trivial: clarify usage of AgentCommandTimeout in \_wait\_for\_command
* Add a bug reporting and triaging guide
* Make test-setup.sh compatible with mysql8
* agent: poll long-running commands till completion
* Networking boot fallback for local boot
* Fix fast-track with the direct deploy interface
* Add api-ref for indicators API
* ironic-standalone, use http basic auth for json-rpc
* Use configure\_keystone\_authtoken\_middleware
* Stop allocating double space for raw images
* Enforce autospec in test\_neutron
* Enforce autospec in test\_base\_manager
* Enable HTTP Basic authentication for JSON-RPC
* Enforce autospec in test\_rpc\_api and test\_steps
* Fix mock callable for Python 3.6 and precedent
* Fix: review from dtantsur of 728123
* Fix internal server error on deleting nodes with allocations
* Fix agent token and URL handling during fast-track deployment
* Fix Redfish handle no continuous override boot src
* Allow node vif attach to specify port\_uuid or portgroup\_uuid
* CI: make grenade voting again
* devstack: Use uwsgi binary from path; temporary disable grenade
* Document http\_basic auth strategy
* doc: fix endpoint\_override for inspector
* Use assertCountEqual instead of assertItemsEqual
* Use unittest.mock instead of mock
* Fix requirements check
* Add virtualbmc as an extra dependency
* [doc] Fix indentation in admin/troubleshooting
* Feature: Add raid configuration support for ibmc driver
* [doc] Extend trouble shooting docs for node stuck in wait states
* devstack: increase concurrency and worker timeout for sushy-tools
* Enforce autospec in test\_snmp
* Enforce autospec in test\_ipxe and test\_pxe
* Use the new extension call for getting partition UUIDs
* Enforce autospec in test\_deploy\_utils module
* Follow-up patch for ilo out-of-band \`erase\_devices\`
* Add troubleshooting docs on -ing state failures
* Enable Basic HTTP authentication middleware
* [doc] Harmonize the prompt for bash commands
* [doc] Check placement in case of "No valid host found"
* Fix fast track when exiting cleaning
* Block port deletions where vif is present
* Enforce autospec in test\_agent\_base module
* Enforce autospec in test\_agent module
* Move introspection timeout option to base job
* Add function definition handling
* Add validate decorator to expose
* Remove ironic-grenade-dsvm
* Fix redfish-virtual-media file permission
* Enforce autospec in ansible tests
* Change default to \`\`False\`\` for \`\`use\_ipmitool\_retries\`\`
* Enforce autospec in drac tests
* Extend vmedia job timeout
* agent: do not hard power off if soft power off actually succeeds
* New configuration parameter to use ipmitool retries
* Add IPv6 ci Job
* Increase callback timeout
* Set default tempest\_test\_timeout for ironic-base
* CI: use the default devstack cirros version
* Cap jsonschema 3.2.0 as the minimal version
* change devstack ipa-builder default to BRANCHLESS\_TARGET\_BRANCH
* Add the noop management interface to the redfish hardware type
* Add agent\_token param to docstrings
* Make redfish boot interface to use \`network\_data\`
* Add \`get\_node\_network\_data\` to non-Neutron NetworkInterface
* Add \`get\_node\_network\_data\` method to NetworkInterface
* Change IRONIC\_VM\_SPECS\_RAM default
* Do not fail when raw image is larger than memory for http
* Add py38 package metadata
* [Trivial]Add missing white space between words
* Fix pygments style
* Remove iDRAC Redfish boot device known issue
* Revert "Deprecate ibmc"
* Increase timeout for introspection in ironic-inspector-tempest
* Collect tftpd info from journald
* Switch to newer openstackdocstheme and reno versions
* Fix image type reference
* rm duplicate word 'that'
* RAID docs: fix an invalid json example
* Change ibmcclient compatible version
* Raise the JSON RPC connection timeout to 2 minutes and disable retries
* CI: add test-requirements to irrelevant-files
* Encapsulate auth\_token middleware
* Pin the python-ibmcclient upper bounds due to six usage
* Collect ramdisk logs also during cleaning
* Doc building: Silence automated\_steps
* Remove deprecated [cinder]url
* Remove deprecated [DEFAULT]fatal\_exception\_format\_errors
* Remove translation sections from setup.cfg
* Add ussuri release notes version
* Fix the wrong description
* Cap pycodestyle explicitly to be < 2.6.0
* Update lower-constraints.txt
* Fix pep8
* Increase timeout value for ironic-base job
* CI: raise DIB jobs memory to 3 GiB
* If the "[conductor]XXX\_timeout" is less than 0，disable periodic task
* [Trivial] Fix awkward mocking in redfish boot tests
* redfish: handle hardware that is unable to set persistent boot
* Change the name of the inspector job
* redfish: split reboot into power off followed by power on
* Enforce autospec in some unit tests modules
* Add timeout and retries to JSON RPC client
* Fix 3rd party driver mocks and related tests
* Temporary add per-file-ignores to flake8 tests
* Mark more configuration options as reloadable
* Silence debug messages from oslo\_messaging
* Do all serialization in the expose decorator
* Use tempest\_plugins Zuul CI role
* Add \`network\_data\` field to ironic node object
* Fix tempest plugin location
* Update grenade job
* Remove testscenarios, testrepository and Babel from test-requirements
* Monkey patch original current\_thread \_active
* Native zuulv3 grenade job for ironic
* Remove [conductor]api\_url
* Imported Translations from Zanata
* Switch to unittest mock
* Refactor RedfishVirtualMediaBoot
* Add RPC objects for deployment API
* Add Python3 victoria unit tests
* Update master for stable/ussuri

15.0.0
------

* CI: exclude the inspection abort tests from the inspector-redfish-vmedia job
* CI: repair the SNMP job and make it voting
* Add ironic-python-agent-builder to grenade projects and use netboot
* Update python-dracclient version
* Fix configure-vm.py and xml file for centos8
* Add PXE reset known issue to the docs
* Don't break UEFI install with older IPAs
* Fix supported sushy-oem-idrac version
* Implements: Reactive HUAWEI ibmc driver
* Fix agent\_client handling of embedded errors
* In-band deploy steps: correctly wipe driver\_internal\_info
* Add ironic-standalone-redfish
* CI: migrate UEFI jobs to Cirros 0.5.1
* Restore missing node.save() in agent\_base.py
* Add link to other Redfish parms to iDRAC doc
* Log when IPA fallback occurs on bootloader install
* Delay validating deploy templates until we get all steps
* Support executing in-band deploy steps
* Upgrade flake8-import-order version to 0.17.1
* Stop configuring install\_command in tox
* Prepare release notes/docs for 15.0 release
* Ironic 15.0 prelude
* DRAC: Added redfish management interface issue
* Fix SpanLength calculation for DRAC RAID configuration
* Fix RAID configuration with idrac-wsman interface
* Revert "Generalize ISO building for virtual media driver"
* Add ironic 15.0 release mapping
* Fixes unusable Guru meditation report
* Don't use wsme test webapp for patch tests
* Centralise imports of wsme types
* Update iDRAC doc about soft power off timeout
* Implement the bios-interface for idrac-wsman driver
* Improve the command status checks in the agent's process\_next\_step
* Change [deploy]/default\_boot\_option to local
* Update iDRAC doc about vendor passthru timeout
* Use trailing slash in the agent command URL
* Fix missing print format in log messages
* Extend timeout on CI job with automated cleaning
* Fix issue where server fails to reboot
* Add my new address to .mailmap
* "dual stack" support for PXE/iPXE
* Generalize ISO building for virtual media driver
* Remove six minions
* Increase VM RAM value in local.conf example
* Release reservation when stoping the ironic-conductor service
* Update jobs description
* Change default ram value
* Added node multitenancy doc
* Support burning configdrive into boot ISO
* [doc] Remove the device selection limitation for Software RAID
* Add sushy-cli to client libraries release list
* Fix AttributeError in check allowed port fields
* Fix gunicorn name on Py3@CentOS7 in devstack
* Add node lessee field
* Software RAID: Pass the boot mode to the IPA
* Refactor AgentBase.heartbeat and process\_next\_step
* [doc] Images need some metadata for software RAID
* Drop netaddr - use netutils.is\_valid\_ipv6()
* Allow INSPECTWAIT state for lookup
* Improve \`redfish\` set-boot-device behaviour
* Improve \`redfish\` set-boot-mode implementation
* Change multinode job to voting
* Cleanup Python 2.7 support
* Use auth values from neutron conf when managing Neutron ports
* Fetch netmiko session log
* Doc - IPv6 Provisioning
* Additional IP addresses to IPv6 stateful ports
* Add network\_type to port local\_link\_connection
* Make oslo.i18n an optional dependency
* Make oslo.reports an optional dependency
* Do not autoescape all Jinja2 templates
* Make deploy step failure logging indicate the error
* Fix the remaining hacking issues
* Bump hacking to 3.0.0
* Extend install\_bootloader command timeout
* Document deploy\_boot\_mode and boot\_option for standalone deployments
* Remove future usage
* Fix enabled\_hardware\_types from idrac-wsman to idrac
* Document our policies for stable branches
* Retry agent get\_command\_status upon failures
* Add troubleshooting on IPMI section
* Default IRONIC\_RAMDISK\_TYPE to dib
* Generalize clean step functions to support deploy steps
* Raise human-friendly messages on attempt to use pre-deploy steps drivers
* Hash the rescue\_password
* DRAC: Fix a failure to create virtual disk bug
* [doc] Add documentation for retirement support
* Add info on how to enable ironic-tempest-plugin
* Follow-up releasenote use\_secrets
* Add indicators REST API endpoints
* Do not use random to generate token
* Signal agent token is required
* Support centos 7 rootwrap data directory
* Refactoring: split out wrap\_ipv6
* Refactoring: move iSCSI deploy code to iscsi\_deploy.py
* Clean up nits from adding additional node update policies
* Allow specifying target devices for software RAID
* Documentation clarifications for software RAID
* Drop rootwrap.d/ironic-lib.filters file
* Expand user-image doc
* Move ipmi logging to a separate option
* Change readfp to read\_file
* Make image\_checksum optional if other checksum is present
* Remove compatibility with pre-deploy steps drivers
* Extend power sync timeout for Ericsson SDI
* Skip clean steps from 'fake' interfaces in the documentation
* Rename ironic-tox-unit-with-driver-libs-python3
* Send our token back to the agent
* Enable agent\_token for virtual media boot
* Add separate policies for updating node instance\_info and extra
* Follow up to console port allocation
* Change force\_raw\_images to use sha256 if md5 is selected
* Make reservation checks caseless
* [doc] Missing --name option
* Bump minimum supported ansible version to 2.7
* Set abstract for ironic-base
* Refactoring: move generic agent clean step functions to agent\_base
* Docs: split away user image building and highlight whole disk images
* Redfish: Add root\_prefix to Sushy
* Cleanup docs building
* Rename \`create\_isolinux\_image\_for\_uefi\` function as misleading
* Finalize removal of ipxe\_enabled option
* Start removing ipxe support from the pxe interface
* Pre-shared agent token
* DRAC: Fix RAID create\_config clean step
* Expose allocation owner to additional policy checks
* Project Contributing updates for Goal
* Refactoring: rename agent\_base\_vendor to agent\_base
* Use FIPS-compatible SHA256 for comparing files
* Revert "Move ironic-standalone to non-voting"
* Move ironic-standalone to non-voting
* Make \`redfish\_system\_id\` property optional
* Lower tempest concurrency
* Refactoring: finish splitting do\_node\_deploy

14.0.0
------

* Fix up release notes for 14.0.0
* Actually use ironic-python-agent from source in source builds
* Update release mappings for Ussuri
* Automatic port allocation for the serial console
* Remove the [pxe]ipxe\_enabled configuration option
* tell reno to ignore the kilo branch
* Update API version history for v1.61
* [Trivial] Remove redundant brackets
* Split cleaning-related functions from manager.py into a new module
* Split deployment-related functions from manager.py into a new module
* Disable debug output in doc building
* Fix bash comparisons for grenade multinode switch
* Fix jsonpatch related tests
* Fix ipxe interface to perform ipxe boot without ipxe\_enabled enabled
* Fix typo in setup-network.sh script
* Support node retirement
* Make ironic-api compatible with WSGI containers other than mod\_wsgi
* Don't require root partition when installing a whole disk image
* Clean up api controller base classes
* Deprecate irmc hardware type
* Subclass wsme.exc.ClientSideError
* Use str type instead of wsme.types.text
* Use bionic job for bifrost integration
* Follow up to root device hints in instance\_info
* Deprecate ibmc
* Fix incorrect ibmc\_address parsing on Python 3.8
* Fix entry paths for cleaning and deployment
* Nodes in maintenance didn't fail, when they should have
* Fix API docs for target\_power\_state response
* Document using CentOS 8 DIB IPA images for Ussuri and newer
* Lower RAM for DIB jobs to 2 GiB
* Remove reference to deprecated [disk\_utils]iscsi\_verify\_attempts
* Add node info and exc name when getting rootfs info from Glance
* Fix fast\_track + agent\_url update fix
* CI: make the metalsmith job voting and gating
* devstack: install bindep for diskimage-builder
* Allow reading root\_device from instance\_info
* Implement managed in-band inspection boot for ilo-virtual-media
* Add a missing versionadded for configdrive[vendor\_data]
* Make qemu hook running with python3
* Refactor glance retry code to use retrying lib
* Fix duplicated words issue like "are are placed"
* devstack: switch to using CentOS 8 DIB ramdisks by default
* Remove the deprecated [glance]glance\_num\_retries
* Fix missing job\_id parameter in the log message
* Fix get\_boot\_option logic for software raid
* Allow node owners to administer associated ports
* Explicitly use ipxe as boot interface for iPXE testing
* Replace disk-image-create with ironic-python-agent-builder
* Remove those switches for python2
* Fix invalid assertIsNone statements
* Add librsvg2\* to bindep
* Stop using six library
* Add notes on the pxe template for aarch64
* Enforce running tox with correct python version based on env
* Tell the multinode subnode and grenade to use /opt
* Disable automated clean on newer jobs
* Extend service timeout
* Tune down multinode concurrency
* Restrict ability to change owner on provisioned or allocated node
* Correct power state handling for managed in-band inspection
* Implement managed in-band inspection boot for redfish-virtual-media
* redfish-vmedia: correctly pass ipa-debug
* Add a CI job to UEFI boot over Redfish virtual media
* Fix use of urlparse.urljoin
* Import importlib directly
* Increasing BUILD\_TIMEOUT value for multinode job
* Remove deprecated ironic-agent element
* Add owner to allocations and create relevant policies
* CI: do not enable rescue on indirect jobs
* Update nova os-server-external-events response logic
* DRAC: Drives conversion from raid to jbod
* Changed to bug fix to follow-on idrac job patch
* Fixes issue with checking whether ISO is passed
* docs: add a missing heading
* Add a CI job to legacy boot over Redfish virtual media
* Fix UEFI NVRAM collision in devstack
* Remove references to 'firewall\_driver'
* Make redfish CI jobs pulling sushy-tools from git
* Prevent localhost from being used as ironic-inspector callback URL
* Add an ironic-inspector job with managed boot
* Add timeout when querying agent's command statuses
* docs: update the local development quickstart to use JSON RPC
* Drop python 2.7 support and testing
* Remove unused migration tests
* Wire in in-band inspection for PXE boot and neutron-based networking
* Foundation for boot/network management for in-band inspection
* Add \`instance\_info/kernel\_append\_params\` to \`redfish\`
* Add indicator management to redfish hw type
* Mock out the correct greenthread sleep method
* Don't install syslinux-nonlinux on rhel7
* Ensure text-only console in devstack
* Pass correct flags during PXE cleanup in iPXEBoot
* Drop [agent]heartbeat\_timeout
* Remove old online migration codes
* Block ability update callback\_url
* Stop supporting incompatible heartbeat interfaces
* Allow node owners to administer nodes
* Fix variable name in cleanup\_baremetal\_basic\_ops func
* Switch legacy jobs to Py3
* Ensure \`isolinux.bin\` is present and configured in devstack
* Fix \`snmp\` unit test
* Backward compatibility for the ramdisk\_params change
* Allow vendor\_data to be included in a configdrive dict
* Improve iDrac Documentation
* Correct handling of ramdisk\_params in (i)PXE boot
* Software RAID: Identify the root fs via its UUID from image metadata
* Change integration jobs to run under Python3
* Using loop instead of with\_X
* CI: add ironic-python-agent-builder to the multinode job
* Update release with information about zuul job
* Add virtual media boot section to the docs
* CI: limit rescue testing to only two jobs
* Mask secrets when logging in json\_rpc
* Use new shiny Devices class instead of old ugly Device
* Switch to ussuri job
* Do not ignore 'fields' query parameter when building next url
* Update sushy library version
* Minor string formatting follow-up to idrac jbod patch
* Document systemd-nspawn as a nice trick for patching a ramdisk
* DRAC: Drives conversion from JBOD to RAID
* Setup ipa-builder before building ramdisk
* Fix EFIBOOT image upload in devstack
* Fix drive sensors collection in \`redfish\` mgmt interface
* Add Redfish vmedia boot interface to idrac HW type
* Change MTU logic to allow for lower MTUs automatically
* DRAC: Fix a bug for clear\_job\_queue clean step with non-BIOS pending job
* Documentation for iLO hardware type deploy steps
* ironic-tempest-functional-python3 unused variables
* docs: use openstackdocstheme extlink extension
* grub configuration should use user kernel & ramdisk
* Raising minimum version of oslo.db
* DRAC: Fix a bug for delete\_config with multiple controllers
* Use correct function to stop service
* Fix devstack installation failure
* DRAC: Fix a bug for job creation when only required
* Add a CI job with a DIB-built ramdisk
* Remove old online migrations and new models
* Remove earliest version from releasing docs, update examples
* Change log level based on node status
* enable\_python3\_package should not be necessary anymore
* Update doc for CI
* Add versions to release notes series
* Document pre-built ramdisk images (including DIB)
* Run DIB with tracing enabled and increase the DHCP timeout
* Improve documentation about releasing deliverables
* Update master for stable/train

13.0.0
------

* Update release mappings for Train
* Release notes cleanup for 13.0.0 (mk2)
* Document PXE retries
* Update env. variables in the documentation
* Add iDRAC RAID deploy steps
* Don't resume deployment or cleaning on heartbeat when polling
* Make multinode jobs non-voting
* devstack: wait for conductor to start and register itself
* Allow retrying PXE boot if it takes too long
* Lower MTU override
* Devstack: Fix iPXE apache log location bug
* Serve virtual media boot images from ironic conductor
* Add Redfish inspect interface to idrac HW type
* Add deploy steps for iLO Management interface
* Do not log an error on heartbeat in deploying/cleaning/rescuing
* Add an option to abort cleaning and deployment if node is in maintenance
* CI: move libvirt images to /opt for standalone and multinode jobs
* Add first idrac HW type Redfish interface support
* Remove cisco references and add release note
* Add \`FLOPPY\` boot device constant
* Combined gate fixes
* Read in non-blocking fashion when starting console
* Release notes cleanup for 13.0.0
* CI: move the fast-track job to the experimental pipeline
* Remove support for CoreOS images
* Fix gate failure related to jsonschema
* Minor: change a misleading InvalidState error message
* Build pdf doc
* iLO driver doc update
* Use openstack cli in image creation guide
* iLO driver doc update
* devstack: save iPXE httpd logs
* Prelude for 13.0.0
* Add a release note for iscsi\_verify\_attempts deprecation
* Fix typo in handling of exception FailedToGetIPAddressOnPort
* Add iLO RAID deploy steps
* add table of available cleaning steps to documentation
* Prepare for deprecation of iscsi\_verify\_attempts in ironic-lib
* Add software raid release note to ironic
* Add ironic-specs link to readme.rst
* Fixed problem with UEFI iSCSI boot for nic adapters
* DRAC : clear\_job\_queue clean step to fix pending bios config jobs
* Add deploy steps for iLO BIOS interface
* Follow-up for deploy steps for Redfish BIOS interface
* Adding file uri support for ipa image location
* Adjust placement query for reserved nodes
* Add indicator management harness to ManagementInterface
* Adds dhcp-all-interfaces element
* Do not wait for console being started on timeout
* Out-of-band \`erase\_devices\` clean step for Proliant Servers
* Pass target\_raid\_config field to ironic variable
* Allow deleting unbound ports on active node
* Follow up to Option to send all portgroup data
* Lower standalone concurrency to 3 from 4
* Make ironic\_log Ansible callback Python 3 ready
* Remove ironic command bash completion
* devstack: Fix libvirtd/libvirt-bin detection
* Add iPXE boot interface to 'ilo' hardware type
* Move to unsafe caching
* Allow to configure additional ipmitool retriable errors
* Fix exception on provisioning with idrac hw type
* Add logic to determine Ironic node is HW or not into configure\_ironic\_dirs
* Install sushy if redfish is a hardware type
* Add \`filename\` parameter to Redfish virtual media boot URL
* Add set\_boot\_device hook in \`redfish\` boot interface
* Add Redfish Virtual Media Boot support
* Follow-up to power sync reno
* Add new method 'apply\_configuration' to RAIDInterface
* Do not tear down node upon cleaning failure
* Switch non-multinode jobs to new-style neutron services
* Add deploy steps for Redfish BIOS interface
* Ansible: fix partition\_configdrive for logical root\_devices
* Support power state change callbacks to nova using ksa\_adapter
* Docu: Fix broken link
* Fixing broken links
* DRAC : Fix issue for RAID-0 creation for multiple disks for PERC H740P
* Uses IPA-B to build in addition to CoreOS
* Asynchronous out of band deploy steps fails to execute
* Clean up RAID documentation
* Enable testing software RAID in the standalone job
* devstack: allow creating more than one volume for a VM
* Allow configuring global deploy and rescue kernel/ramdisk
* Fix missing print format error
* Update software RAID configuration documentation
* Use HTTPProxyToWSGI middleware from oslo
* RAID creation fails with 'ilo5' RAID interface
* RAID create fails if 'controller' is missing in 'target\_raid\_config'
* Use openstacksdk for accessing ironic-inspector
* CI Documentation
* Enable no IP address to be returned
* Change debug to error for heartbeats
* CI: stop using pyghmi from git master
* Fixes power-on failure for 'ilo' hardware type
* Creation of UEFI ISO fails with efiboot.img
* Remove deprecated Neutron authentication options
* Follow-up to the IntelIPMIHardware patch
* Ansible driver: fix deployment with serial specified as root device hint
* Enable testing adoption in the CI
* Fix serial/wwn gathering for ansible+python3
* Update api-ref location
* IPA does not boot up after cleaning reboot for 'redfish' bios interface
* Revert "Add logic to determine Ironic node is HW or not into configure\_ironic\_dirs"
* Filter security group list on the ID's we expect
* Clean lower-constraints.txt
* [Trivial] Fix is\_fast\_track parameter doc string
* Failure in get\_sensor\_data() of 'redfish' management interface
* Abstract away pecan.request/response
* Fix potential race condition on node power on and reboot
* iLO firmware update fails with 'update\_firmware\_sum' clean step
* Bump keystonauth and warlock versions
* Don't install ubuntu efi debs on cent
* Remove the PXE driver page
* Ansible module: fix deployment for private and/or shared images
* Add logic to determine Ironic node is HW or not into install\_ironic
* Add logic to determine Ironic node is HW or not into configure\_ironic\_dirs
* Deal with iPXE boot interface incompatibility in Train
* Bump openstackdocstheme to 1.20.0
* Remove deprecated app.wsgi script
* devstack: Install arch specific debs only when deploying to that arch
* DRAC: Upgraded RAID delete\_config cleaning step
* Fix invalid assert state
* CI: remove quotation marks from TEMPEST\_PLUGINS variable
* Remove CIMC/UCS drivers
* Add IntelIPMIHardware
* Collect sensor data in \`\`redfish\`\` hardware type
* [Trivial] Software RAID: Documentation edits
* Software RAID: Add documentation
* Blacklist sphinx 2.1.0 (autodoc bug)
* Follow-up on UEFI/Grub2 job
* Adds bandit template and exclude some of tests
* Add documentation for IntelIPMI hardware
* Add check on get\_endpoint returning None
* Option to send all portgroup data

12.2.0
------

* Replace deprecated with\_lockmode with with\_for\_update
* Spruce up release notes for 12.2.0 release
* Update API history and release mapping for 12.2.0
* Refactoring: flatten the glance service module
* Remove the deprecated glance authentication options
* DRAC: Adding reset\_idrac and known\_good\_state cleaning steps
* devstack: add missing variables for ironic-python-agent-builder
* Remove ipxe tags when ipx6 is in use
* Update qemu hook to facilitate Multicast
* redfish: handle missing Bios attribute
* Fix :param: in docstring
* Updates ironic for using ironic-python-agent-builder
* Do not log an exception if Allocation is deleted during handling
* Add release note updating status of smartnics
* Switch to use exception from ironic-lib
* Change constraints opendev.org to release.openstack.org
* Incorporate bandit support in CI
* Remove elilo support
* Ansible module: fix configdrive partition creation step
* Remove deprecated option [DEFAULT]enabled\_drivers
* Fix regex string in the hacking check
* Add api-ref for allocation update
* Add a pxe/uefi/grub2 CI job
* Bump lower mock version to 3.0.0
* Start using importlib for Python 3.x
* Remove XML support in parsable\_error middleware
* Fix binary file upload to Swift
* fix typo in code comment
* Software RAID: Trigger grub installation on the holder disks
* Move stray reno file
* Trivial: correct configuration option copy-pased from inspector
* Remove commit\_required in iDRAC hardware type
* Make the multinode grenade job voting again
* devstack: configure rabbit outside of API configuration
* Blacklist python-cinderclient 4.0.0
* Publish baremetal endpoint via mdns
* Fix inaccurate url links
* Update sphinx requirements
* Allocation API: correct setting name to None
* Allocation API: backfilling allocations
* Fix GRUB config path when building EFI ISO
* Add DHCP server part to make the document more detail
* Do not try to return mock as JSON in unit tests
* Remove deprecated option [ilo]power\_retry
* Add API to allow update allocation name and extra field
* Update Python 3 test runtimes for Train
* Replace hardcoded "stack" user to $STACK\_USER
* Run vbmcd as stack user in devstack
* Adding enabled\_boot\_interface attribute in tempest config
* Add openstack commands in node deployment guide
* Add a high level vision reflection document
* Add iDRAC driver realtime RAID creation and deletion
* Correct spelling errors
* Replace git.openstack.org URLs with opendev.org URLs
* Direct bridge to be setup
* Fix pyghmi path
* OpenDev Migration Patch
* Removes \`hash\_distribution\_replicas\` configuration option
* Truncate node text fields when too long
* Add note for alternative checksums
* Make the JSON RPC server work with both IPv4 and IPv6
* Jsonschema 3.0.1: Binding the schema to draft-04
* Place upper bound on python-dracclient version
* devstack: Remove syslinux dependency
* Do not try to create temporary URLs with zero lifetime
* Ansible module: fix partition\_configdrive.sh file
* Use the PUBLIC\_BRIDGE for vxlan
* Move devstack emulators configs under /etc/ironic
* Uncap jsonschema in requirements
* Split ibmc power/reboot classes
* Temporarily mark grenade multinode as non-voting
* Improve VirtualBMC use in Devstack
* Run IPMI, SNMP and Redfish BMC emulators as stack
* Add UEFI firmware to Redfish emulator config
* Add systemd unit for sushy emulator in devstack
* Ansible module: fix clean error handling
* [Trivial] Fix typo in agent\_base\_vendor unit test
* Fix exception generation errors
* Add a request\_timeout to neutron
* doc: update ibmc driver support servers document
* Ansible module fix: stream\_url
* Make it possible to send sensor data for all nodes
* Slightly rephrase note in tenant networking docs
* Bump sphinxcontrib-pecanwsme to 0.10.0
* ipmi: Ignore sensor debug data
* Make 'noop' the explicit default of default\_storage\_interface
* Docs: correct expected host format for drac\_address
* Check for deploy.deploy deploy step in heartbeat
* Workaround for sendfile size limit
* Workaround for uefi job with ubuntu bionic
* Replace openstack.org git:// URLs with https://
* Remove vbmc log file in devstack
* Add versions to release notes series
* Imported Translations from Zanata
* Update master for stable/stein

12.1.0
------

* Fix capabilities passed as string in agent prepare
* Respect $USE\_PYTHON3 settings for gunicorn
* Add systemd unit for vbmcd in devstack
* Workaround for postgres job with ubuntu bionic
* Add release note on conntrack issue on bionic
* Update release-mappings and api version data for Stein release
* Pass kwargs to exception to get better formatted error message
* Advance python-dracclient version requirement
* Add prelude and update release notes for 12.1.0
* Optimize: HUAWEI iBMC driver utils
* Set boot\_mode in node properties during OOB Introspection
* Fix idrac driver unit test backwards compat issue
* Deploy Templates: factor out ironic.conductor.steps
* Make metrics usable
* Kg key for IPMIv2 authentication
* Add fast-track testing
* fast tracked deployment support
* Update doc for UEFI first
* Fix lower-constraints job
* Fix idrac Job.state renamed to Job.status
* Deprecates \`hash\_distribution\_replicas\` config option
* Add Huawei iBMC driver support
* Fix misuse of assertTrue
* Allow methods to be both deploy and clean steps
* Adding ansible python interpreter as driver\_info
* Return 405 for old versions in allocation and deploy template APIs
* honor ipmi\_port in serial console drivers
* Follow up to available node protection
* Migrate ironic-grenade-dsvm-multinode-multitenant job to Ubuntu Bionic
* Deploy templates: conductor and API nits
* Deploy Templates: documentation
* Fixing a bash test in devstack ironic lib
* Deploy Templates: API reference
* Fix formatting issue in doc
* Update dist filter for devstack ubuntu
* Add a non-voting metalsmith job for local boot coverage
* Document building configdrive on the server side
* Check microversions before validations for allocations and deploy templates
* Add python3 unit test with drivers installed
* Fix missing print format error
* Fix typo and docstring in pxe/ipxe
* Stop requiring root\_gb for whole-disk images
* driver-requirements: mark UcsSdk as Python 2 only
* Set boot\_mode in node properties during Redfish introspection
* Add option to set python interpreter for ansible
* Document using a URL for image\_checksum
* [docs] IPv6 support for iLO
* Temporary marking ironic-standalone non-voting
* Allow building configdrive from JSON in the API
* Allocation API: optimize check on candidate nodes
* Fix TypeError: \_\_str\_\_ returned non-string (type ImageRefValidationFailed)
* Deploy templates: API & notifications
* Deploy templates: conductor
* Drop installing python-libvirt system package
* Test API max version is in RELEASE\_MAPPINGS
* Update the log message for ilo drivers
* Deploy templates: fix updating steps in Python 3
* Fix pysendfile requirement marker
* Add option to protect available nodes from accidental deletion
* Deploy Templates: add 'extra' field to DB & object
* Trivial: Fix error message when waiting for power state
* Allocation API: fix minor issues in the API reference
* Allocation API: reference documentation
* Adding bios\_interface reference to api docs
* Set available\_nodes in tempest conf
* Update the proliantutils version in documentation
* [trivial] Removing python 3.5 template jobs
* Deploy Templates: Fix DB & object nits
* Add check for object versions
* [Trivial] Fix incorrect logging in destroy\_allocation
* Allocation API: taking over allocations of offline conductors
* Allocation API: resume allocations on conductor restart
* Devstack - run vbmc as sudo
* Documentation update for iLO Drivers
* Follow up - API - Implement /events endpoint
* Follow up to node description
* ensure that socat serial proxy keeps running
* Deprecate Cisco drivers
* Follow up to ISO image build patch
* API - Implement /events endpoint
* Add a requisite for metadata with BFV
* [Follow Up] Add support for Smart NICs
* Support using JSON-RPC instead of oslo.messaging
* Deploy templates: data model, DB API & objects
* [Follow Up] Expose is\_smartnic in port API
* Prioritize sloppy nodes for power sync
* Expose conductors: api-ref
* Remove duplicated jobs and refactor jobs
* Allocation API: fix a small inconsistency
* Expose is\_smartnic in port API
* [Trivial] Allocation API: correct syntax in API version history docs
* Allocation API: REST API implementation
* Make power sync unit test operational
* Allow case-insensitivity when setting conductor\_group via API
* Optionally preserve original system boot order upon instance deployment
* Add support for Smart NICs
* Add a voting CI job running unit tests with driver-requirements
* [Refactor] Make caching BIOS settings explicit
* [docs] OOB RAID implementation for ilo5 based HPE Proliant servers
* Make iLO BIOS interface clean steps asynchronous
* Provides mount point as cinder requires it to attach volume
* Add description field to node: api-ref
* Add description field to node
* Fix test for 'force\_persistent\_boot\_device' (i)PXE driver\_info option
* Fix iPXE boot interface with ipxe\_enabled=False
* Allocation API: conductor API (without HA and take over)
* Removing deprecated drac\_host property
* Add is\_smartnic to Port data model
* Remove uses of logger name "oslo\_messaging"
* [Trivial] Fix typo in noop interface comment
* Remove duplicated fault code
* Fix listing nodes with conductor could raise
* Parallelize periodic power sync calls follow up
* Build ISO out of EFI system partition image
* Make versioned notifications topics configurable
* Build UEFI-only ISO for UEFI boot
* Parallelize periodic power sync calls
* Limit the timeout value of heartbeat\_timeout
* Replace use of Q\_USE\_PROVIDERNET\_FOR\_PUBLIC
* Make ipmi\_force\_boot\_device more user friendly
* Follow-up logging change
* Remove dsvm from zuulv3 jobs
* Allocation API: allow picking random conductor for RPC topic
* Fix updating nodes with removed or broken drivers
* Fix ironic port creation after Redfish inspection
* Allocation API: minor fixes to DB and RPC
* Allocation API: allow skipping retries in TaskManager
* Allocation API: database and RPC
* Allow missing \`\`local\_gb\`\` property
* Fix typo in release note
* Fix IPv6 iPXE support
* OOB RAID implementation for ilo5 based HPE Proliant servers
* Fix SushyError namespacing in Redfish inspection
* Allow disabling TFTP image cache
* Add pxe template per node
* Fix the misspelling of "configuration"
* Switch to cirros 0.4.0
* Update tox version to 2.0
* Disable metadata\_csum when creating ext4 filesystems
* Switch the default NIC driver to e1000
* Change openstack-dev to openstack-discuss
* Fix XClarity driver management defect
* Ignore newly introduced tables in pre-upgrade versions check
* Switch CI back to xenial

12.0.0
------

* Add "owner" information field
* Introduce configuration option [ipmi]ipmi\_disable\_timeout
* Enroll XClarity machines in Ironic's devstack setting
* spelling error
* api-ref: update node.resource\_class description
* Add a note regarding IPA multidevice fix
* Allow disabling instance image cache
* Add a prelude for ironic 12.0
* Set proper version numbering
* Change multinode jobs to default to local boot
* Follow-up Retries and timeout for IPA command
* Fix "import xxx as xxx" grammar
* Kill misbehaving \`ipmitool\` process
* Fix OOB introspection to use pxe\_enabled flag in idrac driver
* Add configurable Redfish client authentication
* Expose conductors: api
* Fix node exclusive lock not released on console start/restart
* Fix IPv6 Option Passing
* Let neutron regenerate mac on port unbind
* Slim down grenade jobs
* Extend job build timeout
* Mark several tests to not test cleaning
* Add BIOS interface to Redfish hardware type
* Avoid cpu\_arch None values in iscsi deployments
* Expose conductors: db and rpc
* Fix Chinese quotes
* Add ipmi\_disable\_timeout to avoid problematic IPMI command
* Correct author email address
* Ensure we unbind flat network ports and clear BM mac addresses
* Retries and timeout for IPA command
* Support for protecting nodes from undeploying and rebuilding
* Add download link apache configuration with mod\_wsgi
* spelling error
* Add Redfish inspect interface follow up
* Add the noop management interface to the manual-management hardware type
* Add missing ws separator between words
* Switch ironic-tempest-...-tinyipa-multinode to zuulv3
* Add a non-voting bifrost job to ironic
* Increase RAM for the ironic node in UEFI job
* Reuse Redfish sessions follow up
* Improve logs when hard linking images fails
* Don't fail when node is in CLEANFAIL state
* Fix ipv6 URL formatting for pxe/iPXE
* Fix redfish test\_get\_system\_resource\_not\_found test
* Improve sushy mocks
* Recommend to set boot mode explicitly
* Add Redfish inspect interface
* Fix CPU count returned by introspection in Ironic iDRAC driver
* Add ironic-status upgrade check command framework
* Passing thread pool size to IPA for parallel erasure
* Change BFV job to use ipxe interface
* [devstack] Allow setting TFTP max blocksize
* Reuse Redfish sessions
* Migration step to update objects to latest version
* Cleanup of remaining pxe focused is\_ipxe\_enabled
* Remove the xclarity deprecation
* Follow-up to fix not exist deploy image of patch 592247
* Remove pywsman reference
* Fix DHCPv6 support
* Revert "Add openstack/placement as a required project for ironic-grenade\*"
* Add api-ref for conductor group
* Follow-up patch for I71feefa3d0593fd185a286bec4ce38607203641d
* Fix ironic developer quickstart document
* Add note to pxe configuration doc
* Create base pxe class
* Wrap up PXE private method to pxe\_utils move
* Enhanced checksum support
* Enable configuration of conversion flags for iscsi
* Document how to implement a new deploy step
* Refactor API code for checking microversions
* Allow streaming raw partition images
* Remove Vagrant
* ipxe boot interface
* Remove oneview drivers
* Completely remove support for deprecated Glance V1
* Avoid race with nova on power sync and rescue
* Log a warning for Gen8 Inspection
* Doc: Adds cinder as a service requires creds
* Fix unit test run on OS X
* Fixes a race condition in the hash ring code
* Add automated\_clean field to the API
* Stop console at tearing down without unsetting console\_enabled
* Add functionality for individual cleaning on nodes
* Documentation for 'ramdisk' deploy with 'ilo-virtual-media' boot
* Add documentation for soft power for ilo hardware type
* Add documentation for 'inject nmi' for ilo hardware type
* Remove unnecessary checks in periodic task methods
* Remove token expiration
* Adds support for soft power operations to 'ilo' power interface
* Add openstack/placement as a required project for ironic-grenade\*
* Remove tox checkconfig
* Add admin documentation for rescue mode in iLO driver
* Correct headings in README.rst
* Minor fixes for docs on changing hardware types
* Add admin documentation for rescue interface
* pxe/ipxe: Move common calls out pxe.py
* Switch ironic-tempest-dsvm-functional-python3 to zuulv3
* Switch ironic-tempest-dsvm-functional-python2 to zuulv3
* Switch grenade nic driver to e1000
* Remove ironic experimental jobs
* Restore the nova-api redirect
* Update docs to portgroup with creating windows images
* Use templates for cover and lower-constraints
* Remove wrong install-guide-jobs in zuul setup
* Fix grenade tests
* Add a more detailed release note for Dell BOSS RAID1 fix
* Honors return value from BIOS interface cleansteps
* Reuse checksum calculation from oslo
* Adds support for 'ramdisk' deploy with 'ilo-virtual-media' boot
* Remove inspecting state support from inspect\_hardware
* Adds support for 'Inject NMI' to 'ilo' management interface
* Docs for agent http provisioning
* Ensure pagination marker is always set
* Direct deploy serve HTTP images from conductor
* Fix doc builds for ironic
* Fix async keyword for Python 3.7
* Add vendor step placement suggestion
* Prevent HTML from appearing in API error messages
* Replace assertRaisesRegexp with assertRaisesRegex
* Add version discovery information to the /v1 endpoint
* Replace assertRaisesRegexp with assertRaisesRegex
* Fix provisioning failure with \`ramdisk\` deploy interface
* Minor fixes to contributor vision
* Add automated\_clean field
* Use HostAddressOpt for opts that accept IP and hostnames
* Remove the duplicated word
* add python 3.6 unit test job
* switch documentation job to new PTI
* import zuul job settings from project-config
* Prevents deletion of ports for active nodes
* Disable periodic tasks if interval set to 0
* Reformat instructions related with various OS
* Imported Translations from Zanata
* Add conductor\_group docs
* Switch ironic-tempest-dsvm-ironic-inspector too zuulv3
* Switch ironic-tempest-dsvm-bfv too zuulv3
* A minor update to documentation of \`ilo\` hardware type
* Imported Translations from Zanata
* Update reno for stable/rocky
* Fix not exist deploy image within irmc-virtual-media booting

11.1.0
------

* Switch the "snmp" hardware type to "noop" management
* Add "noop" management and use it in the "ipmi" hardware type
* Update docs on ironic boot mode management
* Follow-up to always link MAC address files
* Simplify subclasses for PXERamdiskDeploy
* Node gets stuck in ING state when conductor goes down
* Add notes on Redfish boot mode management
* Prepare for Rocky release
* Update the reno for the reset\_interfaces feature
* Use max version of an object
* A vision
* Improve the "Ironic behind mod wsgi" documentation
* Deploy steps documentation
* Mark the ZeroMQ driver deprecated
* Remove rabbit\_max\_retries option
* Fix iDRAC hardware type does not work with UEFI
* Pass prep\_boot\_part\_uuid to install\_bootloader for ppc64\* partition images
* Remove redundant swift vars
* Document locale requirement for local testing
* Switch ironic-tempest-dsvm-ipa-partition-pxe\_ipmitool-tinyipa-python3
* Improve doc of Node serial console
* Follow-up patch to ramdisk interface
* Ramdisk deploy driver doc
* Change PXE logic to always link macs with UEFI
* Add documentation for BIOS settings
* Fix for failure of cleaning for iRMC restore\_bios\_config
* Refactor RAID configuration via iRMC driver
* Adds ramdisk deploy driver
* Follow-up patch for 7c5a04c1149f14900f504f32e000a7b4e69e661f
* Switch ironic-tempest-dsvm-ipa-partition-uefi-pxe\_ipmitool-tinyipa
* Switch ironic-tempest-dsvm-ipa-wholedisk-bios-pxe\_snmp-tinyipa
* Switch ironic-tempest-dsvm-ipa-wholedisk-bios-agent\_ipmitool-tinyipa
* Switch ironic-tempest-dsvm-pxe\_ipmitool-postgres
* Documentation update of iLO BIOS settings
* Follow-up to improve pep8 checking with hacking
* Fix for failure in cleaning in iRMC driver
* Add deploy\_step to NodePayload.SCHEMA
* Add conductor\_group to node notifications
* Deprecate xclarity hardware type
* Be more precise with conductor group API tests
* Simplify hash ring tests
* Add documentation for changing node's hardware type
* Fix the list of irrelevant-files
* snmp: Keep get\_next method backward-compatible
* Fix for failure in cleaning
* Expose node.conductor\_group in the REST API
* Use conductor group for hash ring calculations
* Expose BIOS interface
* Ignore bashate E044
* Remove deprecated option [ipmi]retry\_timeout
* iLO BIOS interface implementation
* Make pxelinux.cfg folder configurable
* Use openstack client instead of neutron client
* Replace port 35357 with 5000 for "auth\_url"
* Add conductor\_group field to config, node and conductor objects
* Add reset\_interfaces parameter to node's PATCH
* Don't handle warnings as errors
* Follow up Add CUSTOM\_CPU\_FPGA Traits value to ironic inspection
* Follow-up changes to iRMC bios interface
* Minor changes for deploy\_steps framework
* Caching of PDU autodiscovery
* Migrate ironic \`snmp\` driver to the latest pysnmp API
* Add conductor\_group field to nodes and conductors tables
* Add mock object for get\_bios\_settings
* Fix bug to doc:configdrive
* Add notes for future job migrations
* Assert a build timeout for zuul templated CI jobs
* Fixed link to Storyboard instead of launchpad
* Update CI jobs for rescue mode
* Fix bug to doc:kernel-boot-parameters
* Deploy steps - API & notifications
* Deploy steps - conductor & drivers
* Add CUSTOM\_CPU\_FPGA Traits value to ironic inspection
* Implement iRMC BIOS configuration
* Deploy steps - versioned objects
* Deploy steps - DB model
* Follow-up to RAID configuration via iRMC driver patch
* Poweroff server after 10 tries
* Make the lower-constraints tox env actually use lower-constraints
* Fix typo of function naming conventions in test\_deploy\_utils.py
* Update the doc regarding the removal of calssic drivers
* Update boot-from-volume feature docs
* [doc] Use openstack client commands to replace neutron client
* Detect skip version upgrades from version earlier than Pike
* Update API version history with release 11.0.0
* Bump osprofiler minimum requirement to 1.5.0
* Add 11.0 to release mapping
* Add read&write SNMP community names to \`snmp\` driver
* Add unit tests that "remove" is acceptable on /XXX\_interface node fields
* Fix 11.0 prelude formatting
* Change docs bug link to storyboard

11.0.0
------

* Support RAID configuration for BM via iRMC driver
* Fix list node vifs api error
* Remove support for creating and loading classic drivers
* Ensure we allow Ironic API traffic from baremetal network
* Add a prelude for version 11
* iDRAC RAID10 creation with greater than 16 drives
* Remove doc of classic drivers from the admin guide
* Modifying 'whole\_disk\_image\_url' and 'whole\_disk\_image\_checksum' variable
* Follow-up to update doc for oneview driver
* Small change of doc title for the drivers
* Fix wrong in apidoc\_excluded\_paths
* Switch ironic-tempest-dsvm-ipa-partition-redfish-tinyipa
* Switch ironic-dsvm-standalone to zuulv3 native
* Follow-up to update doc for ilo driver
* Add BayTech MRP27 snmp driver type
* Improve pep8 checking along with hacking
* Follow-up to update doc for irmc driver
* DevStack: Tiny changes following iRMC classic driver removal
* include all versions of Node in release\_mappings
* Deprecate [inspector]enabled option
* Do not disable inspector periodic tasks if [inspector]enabled is False
* Remove the ipmitool classic drivers
* Add snmp driver auto discovery
* During cleaning, use current node.driver\_internal\_info
* Rename test class
* Remove the iRMC classic drivers
* Remove the OneView classic drivers
* Remove the deprecated pxe\_snmp driver
* Remove the deprecated classic drivers for Cisco UCS hardware
* Remove the iDRAC classic drivers
* Separate unit tests into different classes
* Add helper method for testing node fields
* Fix conductor manager unit tests
* Remove the ilo classic drivers
* Move parse\_instance\_info\_capabilities() to common utils.py
* Fix error when deleting a non-existent port
* BIOS Settings: update admin doc
* BIOS Settings: add bios\_interface field in NodePayload
* BIOS Settings: update default BIOS setting version in db utils
* Add documentation for XClarity Driver
* Release note clean-ups for ironic release
* Move boot-related code to boot\_mode\_utils.py
* Raise TemporaryFailure if no conductors are online
* BIOS Settings: add sync\_node\_setting
* Fix for Unable to create RAID1 on Dell BOSS card
* Add an external storage interface
* fix typos
* fix typos
* Add detail=[True, False] query string to API list endpoints
* Adds enable\_ata\_secure\_erase option
* Remove the remaining fake drivers
* Document that nova-compute attaches VIF to active nodes on start up
* Added Redfish boot mode management
* iRMC: Support ipmitool power interface with irmc hardware
* Doc: Remove -r option for running a specific unit test
* Fix stestr has no lower bound in test-requirements
* Adds boot mode support to ManagementInterface
* Modify the Ironic api-ref's parameters in parameters.yaml
* rectify 'a image ID' to 'an image ID'
* change 'a ordinary file ' to 'an ordinary file'
* Validating fault value when querying with fault field
* change 'a optional path' to 'an optional path'
* Update links in README
* Remove the fake\_ipmitool, fake\_ipmitool\_socat and fake\_snmp drivers
* Add release notes link to README
* BIOS Settings: add admin doc
* Remove deprecated [keystone] config section
* Make method public to support out-of-band cleaning
* Remove the fake\_agent, fake\_pxe and fake\_inspector drivers
* Consolidate the setting of ironic-extra-vars
* Remove deprecated ansible driver options
* Remove dulicate uses for zuul-cloner
* Comply with PTI for Python testing
* fix tox python3 overrides
* Remove the "fake" and "fake\_soft\_power" classic drivers
* Completely stop using the "fake" classic driver in unit tests
* Power fault recovery follow up
* Adds more \`ipmitool\` errors as retryable
* Stop using pxe\_ipmitool in grenade
* Fix FakeBIOS to allow tempest testing
* Power fault recovery: Notification objects
* Power fault recovery: API implementation
* Add mock to doc requirements to fix doc build
* Fix task\_manager process\_event docstring
* Implements baremetal inspect abort
* Add the ability to setup enabled bios interfaces in devstack
* [Doc] Scheduling needs validated 'management' interface
* Fix authentication issues along with add multi extra volumes
* Stop passing IP address to IPA by PXE
* Add Node BIOS support - REST API
* Follow up to power fault recovery db tests
* Power fault recovery: apply fault
* Reraise exception with converting node ID
* Gracefully handle NodeLocked exceptions during heartbeat
* SNMPv3 security features added to the \`snmp\` driver
* Allow customizing libvirt NIC driver
* Convert conductor manager unit tests to hardware types
* Remove excessive usage of mock\_the\_extension\_manager in unit tests - part 2
* Improve exception handling in agent\_base\_vendor
* Check pep8 without ignoring D000
* Missing import of "\_"
* Remove endpoint\_type from configuration
* Power fault recovery: db and rpc implementation
* Change exception msg of BIOS caching
* Remove excessive usage of mock\_the\_extension\_manager in unit tests - part 1
* Mark xclarity password as secret
* Fix E501 errors
* Fix tenant DeprecationWarning from oslo\_context
* update "auth\_url" in documents
* Fix tenant DeprecationWarning from oslo\_context
* Tear down console during unprovisioning
* Fix XClarity parameters discrepancy
* Follow up to inspect wait implementation
* Silence F405 errors
* Fix W605 Errors
* Fix E305 Errors
* Fix W504 errors
* Gate fix: Cap hacking to avoid gate failure
* Preserve env when running vbmc
* Make validation failure on node deploy a 4XX code
* Install OSC during quickstart
* Ignore new errors until we're able to fix them
* BIOS Settings: Add BIOS caching
* BIOS Settings: Add BIOSInterface
* Remove ip parameter from ipxe command line
* Clarify image\_source with BFV
* Update install guide to require resource classes
* Fix error thrown by logging in common/neutron.py
* Add note to oneview docs re: derprecation
* Deprecate Oneview
* Switch to the fake-hardware hardware type for API tests
* Remove the Keystone API V2.0 endpoint registration
* Move API (functional) tests to separate jobs
* Add unit test for check of glance image status
* Devstack plugin support for Redfish and Hardware
* Collect periodic tasks from all enabled hardware interfaces
* Stop verifying updated driver in creating task
* BIOS Settings: Add RPC object
* fix a typo
* Trivial: Update pypi url to new url
* Add more parameter explanation when create a node
* Fix test\_get\_nodeinfo\_list\_with\_filters
* Install reno to venv for creating release note
* Stop removing root uuid in vendor interfaces
* Fix \`\`agent\`\` deploy interface to call \`\`boot.prepare\_instance\`\`
* Update wording used in removal of VIFs
* [devstack] Switch ironic to uWSGI
* Make ansible error message clearer
* BIOS Settings: Add DB API
* BIOS Settings: Add bios\_interface db field
* BIOS Settings: Add DB model
* Clean up driver\_internal\_info after tear\_down
* Run jobs if requirements change
* Remove vifs upon teardown
* uncap eventlet
* Update auth\_uri option to www\_authenticate\_uri
* Resolve pep8 E402 errors and no longer ignore E402
* Remove pycodestyle version pin. Add E402 and W503 to ignore
* Pin pycodestyle to <=2.3.1
* Check for PXE-enabled ports when creating neutron ports
* Implementation of inspect wait state
* Update Launchpad references to Storyboard
* Add reno for new config [disk\_utils]partprobe\_attempts
* Implement a function to check the image status
* Fix callback plugin for Ansible 2.5 compatability
* Follow the new PTI for document build
* Clarify deprecation of "async" parameter
* Fix incompatible requirement in lower-constraints
* Reference architecture: small cloud with trusted tenants
* Update and replace http with https for doc links
* Assume node traits in instance trait validation
* Adding grub2 bootloader support to devstack plugin
* Describe unmasking fields in security document
* Copy port[group] VIF info from extra to internal\_info
* DevStack: Enroll node with iRMC hardware
* Stop overriding tempdir in unit test
* Uniformly capitalize parameter description
* Gate: run ironic tests in the regular multinode job
* Do not use async parameter
* Remove the link to the old drivers wiki page
* add lower-constraints job
* Test driver-requirements changes on standalone job
* Updated from global requirements
* Exclude Ansible 2.5 from driver-reqs
* Fix typos There are two 'the', delete one of them
* fix typos in documentation
* Fix nits in the XClarity Driver codebase
* Validate instance\_info.traits against node traits
* Prevent overwriting of last\_error on cleaning failures
* Infiniband Port Configuration update[1]
* Rework Bare Metal service overview in the install guide
* Gate: stop setting IRONIC\_ENABLED\_INSPECT\_INTEFACES=inspector
* Follow-up patch for rescue mode devstack change
* devstack: enabled fake-hardware and fake interfaces
* Updated from global requirements
* Add descriptions for config option choices
* devstack: add support for rescue mode
* Updated from global requirements
* Implements validate\_rescue() for IRMCVirtualMediaBoot
* Updated from global requirements
* Update config option for collecting sensor data
* Use node traits during upgrade
* multinode, multitenant grenade votes in gate
* zuul: Remove duplicated TEMPEST\_PLUGIN entry
* Use more granular mocking in test\_utils
* change python-libguestfs to python-guestfs for ubuntu
* Update links in README
* Updated from global requirements
* Remove useless variable
* Don't validate local\_link\_connection when port has client-id
* Updated from global requirements
* Update docstring to agent client related codes
* Move execution of 'tools/check-releasenotes.py' to pep8
* reloads mutable config values on SIGHUP
* Make grenade-mulinode voting again
* tox.ini: flake8: Remove I202 from ignore list
* fix a typo in driver-property-response.json: s/doman/domain/
* Trivial: Remove the non ascii codes in tox.ini
* Register traits on nodes in devstack
* [devstack] block iPXE boot from HTTPS TempURLs
* Fix issue with double mocking of utils.execute functions
* Updates boot mode on the baremetal as per \`boot\_mode\`
* Support nested objects and object lists in as\_dict
* Revert "Don't try to lock for vif detach"
* Rework logic handling reserved orphaned nodes in the conductor
* Set 'initrd' to 'rescue\_ramdisk' for rescue with iPXE
* Update iLO documentation for deprecating classical drivers
* Increase the instance\_info column size to LONGTEXT on MySQL/MariaDB
* Update release instructions wrt grenade
* [ansible] use manual-mgmt hw type in unit tests
* Use oslo\_db.sqlalchemy.test\_fixtures
* Disable .pyc files for grenade multinode
* Add docs for ansible deploy interface
* Update comment and mock about autospec not working on staticmethods
* Build instance PXE options for unrescue
* Updated from global requirements
* Fix default object versioning for Rocky
* Allow sqalchemy filtering by id and uuid
* Fix rare HTTP 400 from port list API
* Clean nodes stuck in CLEANING state when ir-cond restarts
* Imported Translations from Zanata
* tox: stop validating locale files
* Switch contributor documentation to hardware types
* Stop using --os-baremetal-api-version in devstack by default
* Conductor version cannot be null in Rocky
* Add 'Other considerations' to security doc
* Updated from global requirements
* Implements validate\_rescue() for IloVirtualMediaBoot
* Update to standalone ironic doc
* Remove too large configdrive for handling error
* Added known issue to iDRAC driver docs
* Add missing noop implementations to fake-hardware
* Stop running standalone tests for classic drivers
* Stop running non-voting jobs in gate
* Add optional healthcheck middleware
* releasing docs: document stable jobs for the tempest plugin
* Add meaningful exception in Neutron port show
* Clean up CI playbooks
* Fix broken log message
* Add validate\_rescue() method to boot interface
* Empty commit to bump minor pre-detected version
* Remove test\_contains\_current\_release\_entry
* Fix grammar errors
* Clean up RPC versions and database migrations for Rocky
* Remove validate\_boot\_option\_for\_trusted\_boot metric
* Update reno for stable/queens

10.1.0
------

* Add some missed test cases in node object tests
* [reno] timeout parameter worked
* Remove unnecessary lines from sample local.conf
* Stop guessing mime types based on URLs
* Clean up release notes before a release
* Don't try to lock for vif detach
* Revert grenade jobs to classic drivers
* Handle case when a glance image contains no data
* Add 10.1 and queens to the release mapping
* Do not pass credentials to the ramdisk on cleaning
* correct grammar, duplicate the found
* Update iRMC document for classic driver deprecation
* correct grammar, duplicate the found
* Correct grammar, duplicate the found
* Only set default network interface flat if enabled in config
* Fix handling of 'timeout' parameter to power methods
* Fixed some typos in test code
* Replace chinese quotes to English quotes
* Zuul: Remove project name
* Modify error quotation marks
* cleanup: Remove usage of some\_dict.keys()
* Use zuul.override\_checkout  instead of custom branch\_override var
* Add validate\_rescue() method to network interface
* [docs] Firmware based boot from volume for iLO drivers
* Follow-up patch for api-ref documentation for rescue
* Remove sample policy and config files
* correct referenced url in comments
* Remove unused code in unittest
* Fix configure-networking docs
* Migrate the remaining classic drivers to hardware types
* Remove mode argument from boot.(prepare|clean\_up)\_ramdisk
* Do not use asserts with business logic
* Add option to specify mac adress in devstack/.../create-node.sh
* Updated from global requirements
* [api-ref] clarify what /v1/lookup returns
* Update FAQ about updates of release notes
* Add documentation for baremetal mech
* Flat networks use node.uuid when binding ports
* Add missing ilo vendor to the ilo hardware types
* Follow-up for Switch OneView driver to hpOneView and ilorest libraries
* Soft power operations for OneView hardware type
* Deprecate classic drivers
* Declare support for Python 3.5 in setup.cfg
* Add api-ref and ironic state documentation for rescue
* Mock check\_dir in ansible interface tests
* Add documentation for node traits
* Fix nits found in node traits
* Follow-up for Implementation for UEFI iSCSI boot for ILO
* Explicitly mark earliest-version for release notes
* Remove unused code in common/neutron.py
* Correct link address
* Wait for ironic-neutron-agent to report state
* Devstack - use neutron segments (routed provider networks)
* Zuul: Remove project name
* Add traits field to node notifications
* Update description for config params of 'rescue' interface
* Add rescue interface field to node-related notifications
* Follow-up for API methods for rescue implementation
* Add support for preparing rescue ramdisk in iLO PXE
* Automatically migrate nodes to hardware types
* Add API methods for [un]rescue
* Fix unit tests for UEFI iSCSI boot for ILO
* Follow-up for agent rescue implementation
* iRMC:Support preparing rescue ramdisk in iRMC PXE
* Redundant alias in import statement
* Agent rescue implementation
* Allow data migrations to accept options
* Resolve race in validating neutron networks due to caching
* Update api-ref for port group create
* Implementation for UEFI iSCSI boot for ILO
* Add node traits to API reference
* Add a timeout for powering on/off a node on oneview
* Fix persistent information when getting boot device
* Remove python-oneviewclient from oneview hardware type
* API: Node Traits API
* Add RPC API and conductor manager for traits
* Be more sane about cleaning
* Fix node update with PostgreSQL
* Switch the CI to hardware types
* Migrate python-oneviewclient validations to oneview hardware type
* Updated from global requirements
* Add RPC object for traits
* Allow setting {provisioning,cleaning,rescuing}\_network in driver\_info
* Migrate oneview hardware type to use python-hpOneView
* remeber spelling error
* Add rescuewait timeout periodic task
* Add rescue related methods to network interface
* Add XClarity Driver
* [docs] mention new nova scheduler option
* Add a version argument to traits DB API
* Mark multinode job as non-voting
* Updated from global requirements
* Fix docs for Sphinx 1.6.6
* fix a typo in ilo.rst: s/fimware/firmware/
* Do not send sensors data for nodes in maintenance mode

10.0.0
------

* Adds RPC calls for rescue interface
* Make the Python 3 job voting
* Add additional context to contribution guide
* node\_tag\_exists(): raise exception if bad node
* Setup ansible interface in devstack
* Remove the deprecated "giturl" option
* Join nodes with traits
* Update links
* Node traits: Add DB API & model
* Add release 10.0 to release mappings
* Remove ironic\_tempest\_plugin/ directory
* Do not validate root partition size for whole disk images in iscsi deploy
* Switch non-vendor parts admin guide to hardware types
* Clean up release notes before a release
* Add Error Codes
* Remove ironic\_tempest\_plugin/ directory
* Fix initialization of auth token AuthProtocol
* Rework exception handling on deploy failures in conductor
* Add a provisioning target:adopt
* Devstack: install qemu-system-x86 on RHEL
* Add uWSGI support
* Fix ironic node create cli
* zuul: Update TLSPROXY based on branch
* Run in superconductor cellsv2 mode for non-grenade jobs
* Updated from global requirements
* Add documentation covering storage multi-attach
* Adds rescue\_interface to base driver class
* Document the check done in "ironic-dbsync upgrade"
* zuul: Add ability to specify a 'branch\_override' value
* zuul: Remove some redundancy by consolidating the 'post.yaml' files
* Use openstack port create instead of neutron port-create
* ansible: handle mount of /sys the same way IPA does it
* [ansible] add defaults to config
* Prevent changes to the ironic\_tempest\_plugin/ directory
* Finalize migration to keystoneauth adapters
* Updated from global requirements
* Follow up Add additional capabilities discovery for iRMC driver
* Use NamedExtensionManager for drivers
* Use the tempest plugin from openstack/ironic-tempest-plugin
* Switch emphasis to hardware types in the installation guide
* Use adapters for neutronclient
* Remove deprecated ironic.common.policy.enforce()
* Introduce hpOneView and ilorest to OneView
* Auto-detect the defaults for [glance]swift\_{account,temp\_url\_key,endpoint\_url}
* Add 'nova hypervisor-list' in example set of commands to compare the resources in Compute service and Bare Metal service
* Receive and store agent version on heartbeat
* tox: Use the default version of Python 3 for tox tests
* Remove unused methond \_get\_connect\_string
* Update comment on location of webapi-version-history.rst
* Updated from global requirements
* Do not access dbapi attributes on dbsync import
* Fix swiftclient creation
* Update docs to include API version pinning
* Add networking-fujitsu ML2 driver to multitenacy doc
* Updated from global requirements
* 9.2.0 is the ironic version with rebuild configdrive
* Pin API version during rolling upgrade
* devstack to \`git pull sushy-tools\` if required
* Add spec & priorities links to contributor doc
* Fix HPE headers for oneview
* Updated from global requirements
* Fix the format command-line
* Add information about neutron ML2 drivers to multitenancy docs
* Apply pep8 check to app.wsgi
* ironic.conf.sample includes default\_resource\_class
* Add a configuration option for the default resource class
* Rework drivers page in the admin documentation
* Update bindep.txt for doc builds
* Don't collect logs from powered off nodes
* Add additional capabilities discovery for iRMC driver
* Use adapters for inspectorclient
* Use adapters for cinderclient
* Imported Translations from Zanata
* Followup to I07fb8115d254e877d8781207eaec203e3fdf8ad6
* Add missing gzip call to FAQ item on how to repack IPA
* Rework keystone auth for glance
* Remove setting of version/release from releasenotes
* zuul.d: Remove unneeded required-projects
* Updated from global requirements
* Add 9.2 to release mappings
* Remove provisioning network ports during tear down
* Fix image type for partition-pxe\_ipmitool-tinyipa-python3 job

9.2.0
-----

* update description for Change Node Power State
* Add no-vendor interface to the idrac hardware types
* Updated from global requirements
* Fail deploy if agent returns >= 400
* Don't run multinode jobs for changes to driver-requirements.txt
* Revert "Introduce hpOneView and ilorest to OneView"
* Revert "Migrate oneview driver to use python-hpOneView"
* Revert "Fix persistent information when getting boot device"
* Revert "Add a timeout for powering on/off a node on HPE OneView Driver"
* Revert "Migrate python-oneviewclient validations to Ironic OneView drivers"
* Revert "Remove python-oneviewclient from Ironic OneView drivers"
* Revert "Get a new OneView client when needed"
* Revert "Update python-ilorest-library to hardware type OneView"
* Add missing 'autospec' to unit tests - /unit/objects/
* Add ansible deploy interface
* Clean up release notes from the upcoming release
* Fix misplaced reno note
* Make the api format correctly
* [devstack] stop setting or relying on standard properties
* Remove some deprecated glance options
* zuul.d/projects.yaml: Sort the job list
* project.yaml: Remove 'branches:' & jobs that don't run on master
* Miss node\_id in devstack lib
* Update idrac hardware type documentation
* Update Zuul 'gate' job
* Rolling upgrades related dev documentation
* Update python-ilorest-library to hardware type OneView
* Add rescue\_interface to node DB table
* Get a new OneView client when needed
* Run tempest jobs when update requirements
* Updated from global requirements
* Remove unused IronicObjectIndirectionAPI from ironic-api
* Add release note for fix to port 0 being valid
* Simplify the logic of validate\_network\_port
* Follow up Secure boot support for irmc-virtual-media driver
* devstack: Clean up some of the devstack code
* Remove python-oneviewclient from Ironic OneView drivers
* Allow to set default ifaces in DevStack
* Reword interface information in multitenancy docs
* Ensure ping actually succed
* Fix minor documentation missing dependency
* Small fixes in the common reference architecture docs
* [reno] Update ironic-dbsync's check object version
* Migrate python-oneviewclient validations to Ironic OneView drivers
* Remove unnesessary description for config parameters in cinder group
* Update ironic.sample.conf
* Fix the format issues of User guide
* Zuul: add file extension to playbook path
* Add I202 to flake ignore list
* Revise deploy process documentation
* Add a timeout for powering on/off a node on HPE OneView Driver
* ironic-dbsync: check object versions
* Update validating node information docs
* Use jinja rendering from utils module
* Add ability to provide configdrive when rebuilding
* Finish the guide on upgrading to hardware types
* Move ironic legacy jobs into the ironic tree
* Fix missing logging format error
* Add missing 'autospec' to unit tests - /unit/common/
* [bfv] Set the correct iqn for pxe
* Fix "import xx as xx" grammer
* Secure boot support for irmc-virtual-media driver
* Change pxe dhcp options name to codes
* Updated from global requirements
* [docs] describe vendor passthru in hw types
* Add bindep.txt file
* Fix some mis-formatted log messages in oneview driver
* Disallow rolling upgrade from Ocata to Queens
* Add online data migrations for conductor version
* [Devstack] Replace tap with veth
* Support SUM based firmware update as clean step for iLO drivers
* Add missing 'autospec' to unit tests - /unit/dhcp/
* Fix mis-formatted log messages
* Use oslotest for base test case
* Update tests to do not use deprecated test.services()
* Follow-up patch 'Cleanup unit tests for ipmittool'
* Makes ironic build reproducible
* Remove 'next' for GET /nodes?limit=1&instance\_uuid=
* ListType preserves the order of the input
* Stop passing raw Exceptions as the reasons for ironic Image exceptions
* Update after recent removal of cred manager aliases
* ipmitool: reboot: Don't power off node if already off
* Reduce complexity of node\_power\_action() function
* Add default configuration files to data\_files
* Documentation for 'oneview' hardware type
* Cleanup unit tests for ipmittool
* Use DocumentedRuleDefault instead of RuleDefault
* main page: add links to docs on Upgrade to HW Types
* Add documentation describing each Ironic state
* Cleanup test-requirements
* Fix API VIF tests when using flat network
* Updated from global requirements
* Migrate to stestr as unit tests runner
* [reno] update for MAC address update fix
* Revert "Change pxe dhcp options name to codes."
* Drop neutron masking exception in vif\_attach
* Rework update\_port\_address logic
* api-ref portgroup\_id should be portgroup\_ident
* Document setting discover\_hosts\_in\_cells\_interval in nova.conf
* Adds more exception handling for ironic-conductor heartbeat
* Updated from global requirements
* Change pxe dhcp options name to codes
* Updated from global requirements
* Updated from global requirements
* Reference architecture: common bits
* Stop using Q\_PLUGIN\_EXTRA\_CONF\_{PATH|FILES} variables
* Put unit test file in correct directory
* Update vif\_attach from NeutronVIFPortIDMixin
* Replace http with https for doc links
* flake8: Enable some off-by-default checks
* Update upgrade guide to use new pike release
* [install docs] ironic -> openstack baremetal CLI
* Using devstack configure\_rootwrap to configure ironic rootwrap
* Use newer location for iso8601 UTC
* reformat REST API Version History page
* Fix persistent information when getting boot device
* Migrate oneview driver to use python-hpOneView
* [reno] Clarify fix for missing boot.prepare\_instance
* [doc] Non-word updates to releasing doc
* Introduce hpOneView and ilorest to OneView
* Fix race condition in backfill\_version\_column()
* Switch API ref to use versionadded syntax throughout
* Replace DbMigrationError with DBMigrationError
* [reno] Clarify fix for BFV & image\_source
* Fix unit test for new fields in invaid API version
* Put tests in correct location for ironic/api/controllers/v1/
* Troubleshooting docs: explain disabled compute services
* Update documentation for \`\`ilo\`\` hardware type
* Updated from global requirements
* Boot from volume fails with 'iscsi' deploy interface
* Boot from volume fails with 'iscsi' deploy interface
* [contributor docs] ironic -> OSC baremetal CLI
* Minor improvements to the resource classes documentation
* Update Nova configuration documentation
* Build docs with Python 2 for now
* [doc] add FAQ about updating release notes
* Follow-up for commit cb793d013610e6905f58c823e68580714991e2df
* [docs] Update Releasing Ironic Projects
* Add doc/source/\_static to .gitignore
* Fix indentation in few of the documentation pages
* Upgrade guide for \`snmp\` hardware type
* tox.ini: Add 'py36' to the default envlist
* devstack: Comment variables related to multi-tenant networking
* Test ironic-dbsync online\_data\_migrations
* Add a comment about default devstack images
* Fix to use "." to source script files
* Add #!/bin/bash to devstack/common\_settings
* Add Sem-Ver flag to increment master branch version
* conductor saves version in db
* Update Pike release title to include version range
* Updated from global requirements
* remove REST API examples from RAID doc
* [admin docs] ironic -> openstack baremetal CLI
* [doc] change absolute to relative URL
* Configuration documentation migrated
* fix a typo in agent.py: s/doman/domain/
* Documentation for irmc hardware type
* correct URLs in contributor docs & main index
* Correct URLs in install docs
* correct URLs in admin docs
* Documentation for 'snmp' hardware type
* Fix incorrect documentation urls
* Updated from global requirements
* Partially revert "Set resource class during upgrade"
* Introduce keystoneauth adapters for clients
* [doc] Replace http with https
* Follow-up to \`\`ilo\`\` hardware type documentation
* Set explicit default to enabled driver interfaces
* Set resource class during upgrade
* Fix names of capabilities for FibreChannel volume boot
* iRMC: Follow-up: volume boot for virtual media boot interface
* Do not restart n-cpu during upgrade
* Make SNMP UDP transport settings configurable
* Enable OSProfiler support in Ironic - follow-up
* Wait for cleaning is completed after base smoke tests
* Add 'hardware type' for Dell EMC iDRACs
* Fix DRAC classic driver double manage/provide
* [devstack] use resource classes by default
* Add 9.1 to release\_mappings
* Imported Translations from Zanata
* Add 'force\_persistent\_boot\_device' to pxe props
* devstack: Remove unused variable IRONIC\_VM\_NETWORK\_RANGE
* Adds 9.0 to release\_mappings
* Get rid of sourcing stackrc in grenade settings
* Update reno for stable/pike
* Revert "[reno] Add prelude for Pike release"

9.0.0
-----

* Add the new capabilities to the iLO InspectInterface
* [docs] update irmc boot-from-volume
* [releasenotes] update irmc's boot-from-volume support
* [reno] Add prelude for Pike release
* Add storage interface to enabling-drivers doc
* Add admin guide for boot from volume
* iRMC: Add documentation for remote volume boot
* Remove ensure\_logs\_exist check during upgrade
* Add functional API tests for volume connector and volume target
* Follow-up to rolling upgrade docs
* Update proliantutils version for Pike release
* [reno] update
* Documetation for 'ilo' hardware type
* Follow up Secure boot support for irmc-pxe driver
* Update the documentation links - code comments
* Update the documentation links - install guide
* Remove translator assignments from i18n
* Add hardware types to support Cisco UCS Servers
* Remove setting custom http\_timeout in grenade
* Upgrade to hardware types: document changing interfaces for active nodes
* Update the resource classes documentation based on recent progress
* [devstack] switch to the latest API version and OSC commands
* Prevent changes of a resource class for an active node
* Guide on upgrading to hardware types
* iRMC: Support volume boot for iRMC virtual media boot interface
* Rolling upgrade procedure documentation
* Release notes clean up for the next release
* Fix missing print format error
* Secure boot support for irmc-pxe driver
* Adds hardware type for SNMP powered systems
* Add a guide for Devstack configuration for boot-from-volume
* Add a flag to always perform persistent boot on PXE interface
* Put tests in correct location for ironic/api/controllers/v1/
* [tempest] also catch BadRequest in negative tests with physical\_network in old API
* Use more specific asserts in tests
* [Trivialfix]Fix typos in ironic
* Remove WARNING from pin\_release\_version's help
* Update ironic.conf.sample due to non-ironic code
* Add new dbsync command with first online data migration
* BFV Deploy skip minor logging, logic, and test fixes
* Add hardware type for HPE OneView
* [doc-migration] Add configuration folder for documentation
* Add storage interface to api-ref
* Add API for volume resources to api-ref
* Disable automated cleaning for single node grenade
* Optimize node locking on heartbeat
* Remove file RELEASE-NOTES
* Removed unnecessary setUp() call in unit tests
* Adds doc for restore\_irmc\_bios\_config clean step
* Remove SSH-based driver interfaces and drivers
* [Tempest] fix negative tests on old API versions
* Remove install-guide env which is no longer effective
* Address review feedback for ipxe boot file fix
* Change ramdisk log filename template
* Remove usage of some of the deprecated methods
* Updated from global requirements
* grenade: Use test\_with\_retry to check if route is up
* Don't use multicell setup for ironic & increase timeout
* Tempest scenario test for boot-from-volume
* Refactor VIFPortIDMixin: factor out common methods
* Add negative attribute to negative port tests
* Rolling upgrades support for create\_port RPCAPI
* Fixes hashing issues for py3.5
* Generate iPXE boot script on start up
* grenade: For multi-node grenade, do not upgrade nova
* Changes log level of a message
* Fix small issues in the installation documentation
* Removes agent mixin from oneview drivers
* Fix docstring and default value for local\_group\_info
* [doc] update ironic's landing page
* Adding note for ironic virt driver nova-compute changes
* Added a condition for 'ilo' hardware type
* Updated from global requirements
* py3.5:Workaround fix for forcing virtualbmc installation with pip2
* [devstack] add support for running behind tls-proxy
* Start passing portgroup information to Neutron
* Add tempest tests for physical networks
* Updated from global requirements
* Refactor VIFPortIDMixin: rename
* Doc for disk erase support in iLO drivers
* DevStack: Add configuration for boot-from-volume
* Refactor get\_physnets\_by\_portgroup\_id
* Rolling upgrades support for port.physical\_network
* Allow updating interfaces on a node in available state
* replace 'interrace' with 'interface'
* Improve port update API unit tests
* Improve ports API reference
* Expose ports' physical network attribute in API
* Rename 'remove\_unavail\_fields' parameter
* Updated from global requirements
* Add missing parameter descriptions
* Updated from global requirements
* Generate iPXE boot script when deploying with boot from volume
* Add Driver API change in 1.33 to history
* Update URL home-page in documents according to document migration
* Using non-persistent boot in PXE interface
* Modifications for rolling upgrades
* Update comments related to ipmi & old BMCs
* Follow-up to fix for power action failure
* Fix copy/paste error in VIF attach note
* [reno] Clarify fix for inspect validation failures
* [trivial] Fix argument descriptions
* Remove \_ssh drivers from dev-quickstart
* Fix broken links in tempest plugin README
* Remove future plan from portgroup document
* Enable OSProfiler support in Ironic
* Revert "Wait until iDRAC is ready before out-of-band cleaning"
* Force InnoDB engine on interfaces table
* Add storage interface field to node-related notifications
* Removed nonexistent option from quickstart snippet
* Enable cinder storage interface for generic hardware
* Mock random generator for BackoffLoopingCall in IPMI unittests
* Raise HTTP 400 rather than 500 error
* Make IP address of socat console configurable
* Set nomulticell flag for starting nova-compute in grenade
* Physical network aware VIF attachment
* Update README to point at new doc location
* Move ironic dbsync tool docs into doc/source/cli
* Move doc/source/dev to doc/source/contributor
* Move operator docs into into doc/source/admin
* Move install guide into new doc/source/install location
* Improve graceful shutdown of conductor process
* switch from oslosphinx to openstackdocstheme
* Fix quotes in documentation and schema description
* Follow-up for bugfix 1694645 patch
* Add REST API for volume connector and volume target operation
* Add node power state validation to volume resource update/deletion
* Make redfish power interface wait for the power state change
* Refactor common keystone methods
* Adds clean step 'restore\_irmc\_bios\_config' to iRMC drivers
* Add CRUD notification objects for volume connector and volume target
* Updated from global requirements
* Don't retry power status if power action fails
* Fix VIF list for noop network interface
* Fetch Glance endpoint from Keystone if it's not provided in the configuration
* Replace the usage of 'manager' with 'os\_primary'
* Logic for skipping deployment with BFV
* iPXE template support for iSCSI
* Move \_abort\_attach\_volumes functionality to detach\_volumes
* Allow to load a subset of object fields from DB
* Unit test consistency: DB base and utils prefix
* Updated from global requirements
* Updated from global requirements
* Remove unnecessary line in docstring
* Validate portgroup physical network consistency
* Wire in storage interface attach/detach operations
* Wait until iDRAC is ready before out-of-band cleaning
* Minor changes to object version-related code
* Remove times.dbm prior to test run
* Discover hosts while waiting for hypervisors to show up in devstack
* Add docs for node.resource\_class and flavor creation
* Updated from global requirements
* Move port object creation to conductor
* Make default\_boot\_option configurable in devstack
* Trigger interface attach tests
* Support setting inbound global-request-id
* Follow-up docstring revision
* Runs the script configure\_vm.py in py3.5
* Replace get\_transport with get\_rpc\_transport
* Add version column
* Add ldlinux.c32 to boot ISO for virtual media
* Remove legacy auth loading
* Add a note for specifying octal value of permission
* Improve driver\_info/redfish\_verify\_ca value validation
* Updated from global requirements
* Stop sending custom context values over RPC
* Replace assertTrue(isinstance()) with assertIsInstance()
* Change volume metadata not to use nested dicts
* Add physical network to port data model
* Move deploy\_utils warnings to conductor start
* Remove unused methods from GlanceImageService
* [install-guide] explain the defaults calculation for hardware types
* Improve driver\_info/redfish\_system\_id value validation
* Add guru meditation report support
* Adds parameters to run CI with hardware types
* Fix description for [cinder] action\_retries option
* Deprecate elilo support
* Updated from global requirements
* Update ipmitool installation and usage documentation
* Replace test.attr with decorators.attr
* Updated from global requirements
* Replace test.attr with decorators.attr
* remove explicit directions for release notes on current branch
* Use cfg.URIOpt for URLs with required schemes
* Updated from global requirements
* Remove unneeded lookup policy check
* Add Cinder storage driver
* Add ipmitool vendor interface to the ipmi hardware type
* Replace test.attr with decorators.attr
* Fix directories permission for tftpboot
* Comment the default values in policy.json.sample
* Replace deprecated .assertRaisesRegexp()
* Updated from global requirements
* Remove remaining vendor passthru lookup/heartbeat
* Prevent tests from using utils.execute()
* Remove unit tests that test oslo\_concurrency.processutils.execute
* Remove single quoted strings in json sample
* Refactor install-guide: update node enrollment
* Refactor install-guide: driver and hardware types configuration
* Minor clean up in iLO drivers unit tests
* Remove translation of log messages
* Enable getting volume targets by their volume\_id
* Check if sort key is allowed in API version
* Updated from global requirements
* Remove logging translation calls from ironic.common
* [install-guide] add section on Glance+Swift config
* Fix attribute name of cinder volume
* Update reno for new ilo hardware type
* Remove log translations from ironic/drivers Part-1
* Update developer quickstart doc about required OS version
* Add 'iscsi' deploy support for 'ilo' hardware type
* Trivial fix typos while reading doc
* Fix docstrings in conductor manager
* [devstack] start virtualpdu using full path
* [Devstack] Increase default NIC numbers for VMs to 2
* Remove usage of parameter enforce\_type
* Properly allow Ironic headers in REST API
* Updated from global requirements
* Fix a typo
* DevStack: Install gunicorn and sushy based on g-r constraints
* Fix keystone.py 'get\_service\_url' method parameter
* Add functional api tests for node resource class
* Refactor install-guide: integration with other services
* Remove references to EOLed version of Ironic from the install guide
* DevStack: Setup a Redfish environment
* Add hardware type for HPE ProLiant servers based on iLO 4
* Bring the redfish driver address parameter closer to one of other drivers
* [Grenade]: Do not run ir-api on primary node after upgrade
* Validate outlet index in SNMP driver
* [Devstack] Rework VMs connection logic
* Fix oslo.messaging log level
* Add context to IronicObject.\_from\_db\_object()
* Add release notes for 8.0.0
* [api-ref] remove reference to old lookup/heartbeat
* Follow-up patch to redfish documentation
* [devstack] use the generic function to setup logging
* Fix cleaning documents
* Remove obsolete sentence from comment
* TrivialFix: Remove logging import unused
* Remove translation of log messages from ironic/drivers/modules/irmc
* Run db\_sync after upgrade
* Remove translation of log messages from ironic/drivers/modules/ucs
* Start enforcing config variables type in tests
* Add documentation for the redfish driver
* Read disk identifier after config drive setup
* Add a paragraph about image validation to Install Guide
* Make terminal timeout value configurable
* Remove nova mocks from documentation configuration
* Remove fake\_ipmitool\_socat driver from the documentation
* Add redfish driver
* Ensure we install latest libivrt
* Set env variables when all needed files are source
* save\_and\_reraise\_exception() instead of raise
* Follow-up patch of 7f12be1b14e371e269464883cb7dbcb75910e16f
* VirtualPDU use libvirt group instead of libvirtd
* Fix unit tests for oslo.config 4.0
* Always set host\_id when adding neutron ports
* Add /baremetal path instead of port 6385
* Add SUSE instructions to the install guide
* Remove pre-allocation model for OneView drivers
* Remove log translations from iLO drivers
* Follow-up patch of 565b31424ef4e1441cae022486fa6334a2811d21
* Setup logging in unit tests
* Remove deprecated DHCP provider methods
* Make config generator aware of 'default\_log\_levels' override
* [Devstack] Fix libvirt group usage
* Common cinder interface additional improvements
* Config drive support for ceph radosgw
* Improve error message for deleting node from error state
* Updated from global requirements
* Add comments re RPC versions being in sync
* Help a user to enable console redirection
* Fix some reST field lists in docstrings
* Avoid double ".img" postfix of image file path in devstack installation
* add portgroups in the task\_manager docstrings
* Remove unneeded exception handling from agent driver
* Updated from global requirements
* Remove translation of log messages from ironic/dhcp and ironic/cmd
* Updated from global requirements
* Bypassing upload deploy ramdisk/kernel to glance when deploy iso is given
* Drop commented import
* Enforce releasenotes file naming
* Remove unused methods in common/paths and common/rpc
* Remove translation of log messages from ironic/api
* Fix access to CONF in dhcp\_options\_for\_instance
* Add string comparison for 'IRONIC\_DEPLOY\_DRIVER'
* Modify the spelling mistakes Change explictly to explicitly

8.0.0
-----

* Revert "[Devstack] Rework VMs connection logic"
* Fix base object serialization checks
* Node should reflect what was saved
* Changes 'deploy' and 'boot' interface for 'pxe\_ilo' driver
* Use standard deploy interfaces for iscsi\_ilo and agent\_ilo
* Refactor iLO drivers code to clean 'boot' and 'deploy' operations
* Updated from global requirements
* Add base cinder common interface
* Updates to RPC and object version pinning
* Add release note for messaging alias removal
* Remove deprecated method build\_instance\_info\_for\_deploy()
* Remove deprecated, untested ipminative driver
* [Devstack] Rework VMs connection logic
* Docs: bump tempest microversion caps after branching
* Add assertion of name to test\_list\_portgroups test
* Skip PortNotFound when unbinding port
* Remove unnecessary setUp function in testcase
* Remove deprecated [ilo]/clean\_priority\_erase\_devices config
* Remove extra blank space in ClientSide error msg
* Updated from global requirements
* Convert BaseDriver.\*\_interfaces to tuples
* [Devstack] cleanup upgrade settings
* [doc] Update examples in devstack section
* devstack: install python-dracclient if DRAC enabled
* Call clean\_up\_instance() during node teardown for Agent deploy
* Don't pass sqlite\_db in db\_options.set\_defaults()
* Fix some api field lists in docstrings
* Copy and append to static lists
* Define minimum required API ver for portgroups
* Add RPC and object version pinning
* Updated from global requirements
* Fix docstrings for creating methods in baremetal api tests
* Extend tests and checks for node VIFs
* Remove translation of log messages from ironic/conductor
* Add functional API tests for portgroups
* Revert the move of the logger setup
* [devstack] Use global requirements for virtualbmc
* Updates documentation to install PySqlite3
* Remove log translation function calls from ironic.db
* Fix local copy of scenario manager
* Add standalone tests using direct HTTP links
* devstack: When Python 3 enabled, use Python 3
* Remove old oslo.messaging transport aliases
* Fix file\_has\_content function for Py3
* Fix usage of various deprecated methods
* Prune local copy of tempest.scenario.manager.py
* devstack: Don't modprobe inside containers
* Include a copy of tempest.scenario.manager module
* flake8: Specify 'ironic' as name of app
* Updated from global requirements
* Fix API doc URL in GET / response
* Add ironic standlaone test with ipmi dynamic driver
* Update new proliantutils version to 2.2.1
* Add Ironic standalone tests
* Fix typos of filename in api-ref
* Updated from global requirements
* Fix the exception message in tempest plugin
* Speed up test\_touch\_conductor\_deadlock()
* Cleanup hung iscsi session
* Refactor waiters in our tempest plugin
* Deprecate support for glance v1
* This adds a tempest test for creating a chassis with a specific UUID
* Address a shell syntax mistake
* Update ironic.conf.sample
* grenade: Only 'enable\_plugin ironic' if not already in conf
* Remove overwriting the default value of db\_max\_retries
* Do not load credentials on import in tempest plugin clients.py
* Update the Ironic Upgrade guide
* Validation before perform node deallocation
* Add wsgi handling to ironic-api in devstack
* Fix updating node.driver to classic
* devstack: Make sentry \_IRONIC\_DEVSTACK\_LIB a global variable
* Use Sphinx 1.5 warning-is-error
* Fixed release note for DBDeadLock handling
* Remove references to py34 from developer guide
* Delete release note to fix build
* Correct typos in doc files
* Clean up eventlet monkey patch comment and reno
* Moved fix-socat-command release note
* Allow to attach/detach VIFs to active ironic nodes
* Move eventlet monkey patch code
* Updated from global requirements
* doc: update FAQ for release notes
* Update test requirement
* Add tempest plugin API tests for driver
* Updated from global requirements
* Remove gettext.install() for unit tests
* Fix missing \_ import in driver\_factory
* Add support for DBDeadlock handling
* Fix BaseBaremetalTest.\_assertExpected docstring
* Updated ramdisk API docstrings
* Trivial: Change hardcoded values in tempest plugin
* Developer guide should not include Python 3.4
* Add testcases for iLO drivers
* Deduplicate \_assertExpected method in tests
* Remove unused logging import
* Use specific end version since liberty is EOL
* Use flake8-import-order
* Document PXE with Spanning Tree in troubleshooting FAQ
* Skip VIF tests for standalone ironic
* Switch to new location for oslo.db test cases
* Explicitly use python 2 for the unit-with-driver-libs tox target
* Add ironic port group CRUD notifications
* Remove logging import unused
* Update release nodes for Ocata
* reno 'upgrades' should be 'upgrade'
* Updated from global requirements
* Update docs create port group

7.0.0
-----

* Clean up release notes for 7.0.0
* Add a summary release note for ocata
* Walk over all objects when doing VIF detach
* Fix unit tests with UcsSdk installed
* Mock client initializations for irmc and oneview
* Follow up patch for SNMPv3 support
* Add a tox target for unit tests with driver libraries
* Fix missed '\_' import
* Change misc to test\_utils for tempest test
* Source lib/ironic in grenade settings
* Update api-ref for dynamic drivers
* Switch to use test\_utils.call\_until\_true
* Add port groups configuration documentation
* Remove most unsupported drivers
* SNMP agent support for OOB inspection for iLO Drivers
* No node interface settings for classic drivers
* Unbind tenant ports before rebuild
* Remove a py34 environment from tox
* Fix object save after refresh failure
* Pass session directly to swiftclient
* Adds network check in upgrade phase in devstack
* Fix log formating in ironic/common/neutron
* Follow-up iRMC power driver for soft reboot/poff
* Use https instead of http for git.openstack.org
* Validate the network interface before cleaning
* log if 'flat' interface and no cleaning network
* exception from driver\_factory.default\_interface()
* devstack: Adding a README for ironic-bm-logs directory
* [devstack] Allow using "ipmi" hardware type
* Remove trailing slash from base\_url in tempest plugin
* Improve enabled\_\*\_interfaces config help and validation
* Prepare for using standard python tests
* [Devstack] fix waiting resources on subnode
* Log an actual error message when failed to load new style credentials
* Speed up irmc power unit tests
* Add bumping sem-ver to the releasing docs
* Make \_send\_sensors\_data concurrent
* [devstack] remove deprecated IRONIC\_IPMIINFO\_FILE
* Fail conductor startup if invalid defaults exist
* Add dynamic interfaces fields to base node notification
* Improve conductor driver validation at startup
* Remove iSCSI deploy support for IPA Mitaka
* Do not change admin\_state for tenant port
* Use delay configoption for ssh.SSHPower drivers
* Add the timeout parameter to relevant methods in the fake power interface
* Adding clean-steps via json string examples
* Allow duplicate execution of update node DB api method
* Remove deprecated heartbeat policy check
* Add sem-ver flag so pbr generates correct version
* Fix a few docstring warnings
* Remove deprecated [deploy]erase\_devices\_iterations
* Remove support for driver object periodic tasks
* Log reason for hardware type registration failure
* Duplicated code in ..api.get\_active\_driver\_dict()
* Add hardware type 'irmc' for FUJITSU PRIMERGY servers
* Allow using resource classes
* DevStack: Only install edk2-ovmf on Fedora
* [Devstack] Add stack user to libvirt group
* Add soft reboot, soft power off and power timeout to api-ref
* Add dynamic interfaces fields to nodes API
* Add dynamic driver functionality to REST API
* [Devstack] Download both disk and uec images
* [Devstack] Set DEFAULT\_IMAGE\_NAME variable
* Update the outdated link in user-guide
* Add Inject NMI to api-ref
* Don't override device\_owner for tenant network ports
* Validate port info before assume we may use it
* Switch to decorators.idempotent\_id
* Updated from global requirements
* Minor updates to multi-tenancy documentation
* Follow-up iRMC driver doc update
* Devstack: Create a "no ansi" logfile for the baremetal console logs
* Add hardware type for IPMI using ipmitool
* [Devstack] enable only pxe|agent\_ipmitool by default
* Update iRMC driver doc for soft reboot and soft power off
* Fix broken link in the iLO driver docs
* DevStack: Fix cleaning up nodes with NVRAM (UEFI)
* iRMC power driver for soft reboot and soft power off
* Update proliantutils version required for Ocata release
* Fix rel note format of the new feature Inject NMI
* iRMC management driver for Inject NMI
* Revert "Revert "Remove ClusteredComputeManager""
* Use context manager for better file handling
* Updated from global requirements
* Fix typo in the metrics.rst file
* Allow to use no nova installation
* Fix api-ref warnings
* Turn NOTE into docstring
* Updated from global requirements
* Correctly cache "abortable" flag for manual clean steps
* Use global vars for storing image deploy path's
* Ipmitool management driver for Inject NMI
* Generic management I/F for Inject NMI
* Clean up driver\_factory.enabled\_supported\_interfaces
* Add hardware types to the hash ring
* Default ironic to not use nested KVM
* Do not use user token in neutron client
* Use only Glance V2 by default (with a compatibility option)
* Enable manual-management hardware type in devstack
* Register/unregister hardware interfaces for conductors
* Validate the generated swift temp url
* Move to tooz hash ring implementation
* Add VIFs attach/detach to api-ref
* DevStack: Configure nodes/environment to boot in UEFI mode
* Add tests for Payloads with SCHEMAs
* make sure OVS\_PHYSICAL\_BRIDGE is up before bring up vlan interface
* Update troubleshooting docs on no valid host found error
* Expose default interface calculation from driver\_factory
* Add default column to ConductorHardwareInterfaces
* Do not fail in Inspector.\_\_init\_\_ if [inspector]enabled is False
* Use TENANT\_VIF\_KEY constant everywhere
* Updated from global requirements
* Allow to attach/detach VIF to portgroup
* Refactor DRAC driver boot-device tests
* Updated from global requirements
* Remove check for UEFI + Whole disk images
* Updated from global requirements
* Update validate\_ports from BaremetalBasicOps
* Ipmitool power driver for soft reboot and soft power off
* Allow to set min,max API microversion in tempest
* Skip VIF api tests for old api versions
* Fix assertEqual parmeters position in unittests
* Ensures that OneView nodes are free for use by Ironic
* Move default image logic from DevStack to Ironic
* Document HCTL for root device hints
* Removes unnecessary utf-8 encoding
* Move heartbeat processing to separate mixin class
* Add Virtual Network Interface REST APIs
* Fix logging if power interface does not support timeout
* Add lsblk to ironic-lib filters
* Fix setting persistent boot device does not work
* Updated from global requirements
* Add docs about creating release note when metrics change
* Fix take over of ACTIVE nodes in AgentDeploy
* Fix take over for ACTIVE nodes in PXEBoot
* Don't translate exceptions w/ no message
* Correct logging of loaded drivers/hardware types/interfaces
* Move baremetal tempest config setting from devstack
* Change object parameter of swift functions
* Remove greenlet useless requirement
* Fixes grammar in the hash\_partition\_exponent description
* Revert "Disable placement-api by default"
* Remove service argument from tempest plugin client manager
* Fix the comma's wrong locations
* Remove netaddr useless requirement
* Generic power interface for soft reboot and soft power off
* Create a table to track loaded interfaces
* Remove trailing backtick
* Updated from global requirements
* Remove 'fork' option from socat command
* Add Virtual Network Interface RPC APIs
* Catch unknown exceptions in validate driver ifaces
* Disable placement-api by default
* Update regenerate-samples.sh api-ref script
* Updated from global requirements
* Add Virtual Network Interface Driver APIs
* 'updated\_at' field value after node is updated
* Add node console notifications
* Add node maintenance notifications
* Add ironic resources CRUD notifications
* Auto-set nullable notification payload fields when needed
* Update dev-quickstart: interval value cannot be -1
* Fix wrong exception message when deploy failed
* Add storage\_interface to base driver class
* Update multi-tenancy documentation
* Add storage\_interface to node DB table
* Add API reference for portgroup's mode and properties
* Set access\_policy for messaging's dispatcher
* Add a NodePayload test
* Add test to ensure policy is always authorized
* Fix bashate warning in devstack plugin
* Forbid removing portgroup mode
* Configure tempest for multitenancy/flat network
* Wrap iscsi portal in []'s if IPv6
* Fix policy dict checkers
* Updated from global requirements
* Introduce generic hardware types
* Remove grenade config workaround
* Add portgroup configuration fields
* Onetime boot when set\_boot\_device isn't persistent
* Revert "Change liberty's reno page to use the tag"
* Update multitenancy docs
* Use oslo\_serialization.base64 to follow OpenStack Python3
* Updated from global requirements
* Support defining and loading hardware types
* Change liberty's reno page to use the tag
* DevStack: Make $IRONIC\_IMAGE\_NAME less dependent of the name in DevStack
* Fix error when system uses /usr/bin/qemu-kvm, as in CentOS 7.2
* Adds another validation step when using dynamic allocation
* Fix return values in OneView deploy interface
* Clarify the comment about the object hashes
* Reusing oneview\_client when possible
* Enhance wait\_for\_bm\_node\_status waiter
* Use polling in set\_console\_mode tempest test
* Make CONF.debug also reflect on IPA
* Fail ironic startup if no protocol prefix in ironic api address
* Remove agent vendor passthru completely
* Remove iBoot, WoL and AMT drivers
* Remove agent vendor passthru from OneView drivers
* Move CONF.service\_available.ironic to our plugin
* devstack: add vnc listen address
* Autospec ironic-lib mocks, fix test error string
* Remove deprecation of snmp drivers
* Allow setting dhcp\_provider in devstack
* Fix default value of "ignore\_req\_list" config option
* Add unit test for create\_node RPC call
* Documentation for Security Groups for baremetal servers
* Remove agent vendor passthru from iLO drvers
* Updated from global requirements
* Add release names & numbers to API version history
* Remove the VALID\_ROOT\_DEVICE\_HINTS list
* Make "enabled\_drivers" config option more resilient to failures
* Fix double dots at the end of a message to single dot
* Clean up object code
* Use IronicObject.\_from\_db\_object\_list method
* Update help for 'provisioning\_network' option
* Updated from global requirements
* Add virtualpdu to ironic devstack plugin
* Auto enable the deploy driver
* Add volume\_connectors and volume\_targets to task
* Renaming audit map conf sample file
* Support names for {cleaning,provisioning}\_network
* Allow use \*\_ipmitool with vbmc on multinode
* Add RPCs to support volume target operations
* Fix import method to follow community guideline
* Add VolumeTarget object
* Unneeded testing in DB migration of volume connector
* Add volume\_targets table to database
* Cleanup adding Ironic to cluster on upgrade case
* Move interface validation from API to conductor side
* Update the links in iLO documentation
* Turn off tempest's multitenant network tests
* Make all IronicExceptions RPC-serializable
* Do not source old/localrc twise in grenade
* Fix docs error about OOB RAID support
* Remove agent vendor passthru from most drivers
* Follow-up for volume connector db\_id
* Remove file prefix parameter from lockutils methods
* Install syslinux package only for Wheezy / Trusty
* Show team and repo badges on README
* Drac: Deprecate drac\_host property
* Update keystone\_authtoken configuration sample in the install guide
* Add RPCs to support volume connector operation
* Add VolumeConnector object
* Add volume\_connectors table to save connector information
* Minor changes to neutron security groups code
* Drop bad skip check in tempest plugin
* Correct DB Interface migration test
* Updated from global requirements
* Add support for Security Groups for baremetal servers
* mask private keys for the ssh power driver
* Remove deprecated Neutron DHCP provider methods
* Add notification documentation to install guide
* Fix the message in the set\_raid\_config method
* Convert iPXE boot script to Jinja template
* Fix PXE setup for fresh Ubuntu Xenial
* Add node (database and objects) fields for all interfaces
* Move \`deploy\_forces\_oob\_reboot\` to deploy drivers
* Add route to Neutron private network
* Rely on portgroup standalone\_ports\_supported
* Add node provision state change notification
* Update the alembic migration section in the developer FAQ
* Add notification documentation to administrator's guide
* Revert "Remove ClusteredComputeManager"
* Remove ClusteredComputeManager
* Followup to 0335e81a8787
* Update iptables rules and services IPs for multinode
* Add devstack setup\_vxlan\_network()
* Skip some steps for multinode case
* Timing metrics: iRMC drivers
* Use function is\_valid\_mac from oslo.utils
* Docs: Document using operators with root device hints
* Add portgroup to api-ref
* Updated from global requirements
* Add user and project domains to ironic context
* Bring configurations from tempest to ironic\_tempest\_plugin
* Do not pass ipa-driver-name as kernel parameter
* Timing metrics: OneView drivers
* Add unit test for microversion validator
* Update ironic node names for multinode case
* Update devstack provision net config for multihost
* Add CI documentation outline
* Add possibility to remove chassis\_uuid from a node
* Create dummy interfaces for use with hardware types
* [install-guide] describe service clients auth
* Simplify base interfaces in ironic.drivers.base
* Integrate portgroups with ports to support LAG
* Updated from global requirements
* Increase verbosity of devstack/lib/ironic
* Update to hacking 0.12.0 and use new checks
* Add PS4 for better logfile information of devstack runs
* Update guide section for messaging setup
* Updated from global requirements
* Replaces uuid.uuid4 with uuidutils.generate\_uuid()
* Enable PXE for systems using petitboot
* Fix typo of 'authenticaiton'
* Add a unit test for microversion validation V1.22
* Clean up unit test of API root test
* DevStack: Fix standard PXE on Ubuntu Xenial
* Skip db configuration on subnodes
* Ignore required\_services for multinode topology
* Add PortGroups API
* DevStack: Support for creating UEFI VMs
* Updated from global requirements
* Clarify ironic governance requirements and process
* API: lookup() ignore malformed MAC addresses
* TrivialFix: Fix typo in config file
* DRAC get\_bios\_config() passthru causes exception
* Fix exception handling in iscsi\_deploy.continue\_deploy
* Log currently known iSCSI devices when we retry waiting for iSCSI target
* Use kvm for ironic VMs when possible
* Correct log the node UUID on failure
* Updated from global requirements
* Change 'writeable' to 'writable'
* Add the way to get the deploy ram disks
* Remove use of 'vconfig' command in devstack ironic script
* Imported Translations from Zanata
* Updated from global requirements
* Revert "Set SUBNETPOOL\_PREFIX\_V4 to FIXED\_RANGE"
* Fix typo in release note filename
* Use function import\_versioned\_module from oslo.utils
* Updated from global requirements
* Remove "dhcp" command from the iPXE template
* Fixes a small documentation typo in snmp
* IPMI command should depend on console type
* Trivial fix of notifications doc
* Mock ironic-lib properly in test\_deploy\_utils
* Remove ..agent.build\_instance\_info\_for\_deploy() in Pike
* Trivial: fix typo in docstring
* Add a missing error check in ipmitool driver's reboot
* Adding Timing metrics for DRAC drivers
* Remove 'agent\_last\_heartbeat' from node.driver\_internal\_info
* Add power state change notifications
* Skip create\_ovs\_taps() for multitenancy case
* Remove unnecessary '.' before ':' in ironic rst
* Updated from global requirements
* Imported Translations from Zanata
* Replace parse\_root\_device\_hints with the ironic-lib version one
* Fixes parameters validation in SSH power manager
* Fix API docs to include API version history
* fix a typo in document
* Updated from global requirements
* Update guide for PXE multi-architecture setup
* Remove "agent\_last\_heartbeat" internal field from agent drivers
* No need to clear "target\_provision\_state" again from conductor
* Trivial: fix warning message formatting
* Updated from global requirements
* Fix some typos
* Add docs about releasing ironic projects
* Fix unit tests failing with ironic-lib 2.1.1
* Do not hide unexpected exceptions in inspection code
* Avoid name errors in oneview periodics
* A few fixes in Multitenancy document
* Introduce default\_boot\_option configuration option
* Fix broken xenial job
* Fix setting custom IRONIC\_VM\_NETWORK\_BRIDGE
* Update configure\_tenant\_networks
* Remove wrong check from conductor periodic task
* Remove reservation from sync power states db filter
* Fix a typo in deploy.py
* Updated from global requirements
* Fix some PEP8 issues and Openstack Licensing
* Clarify when oneview node can be managed by ironic
* Add tense guide to release note FAQ
* Refactor \_test\_build\_pxe\_config\_options tests
* Imported Translations from Zanata
* OneView driver docs explaining hardware inspection
* Enable release notes translation
* Clean up provision ports when reattempting deploy
* Remove unnecessary option from plugin settings
* Cleanup unused (i)PXE kernel parameters
* Set SUBNETPOOL\_PREFIX\_V4 to FIXED\_RANGE
* Enable DeprecationWarning in test environments
* Fix \_lookup() method for node API routing
* Log node state transitions at INFO level
* Update ironic config docs for keystone v3
* Clean exceptions handling in conductor manager
* Move build\_instance\_info\_for\_deploy to deploy\_utils
* Fix undisplayed notes in Quick-Start
* Keep numbering of list in Install Guide
* Add description for vendor passthru methods
* [install-guide] describe pxe.ipxe\_swift\_tempurl
* Fix docstrings in tempest plugin baremetal json client
* Add entry\_point for oslo policy scripts
* Remove unneeded exception handling from conductor
* Remove unused methods in common/utils.py
* Do not use mutable object as func default param
* Trivial: Fix some typos in comments and docstring
* doc: Add oslo.i18n usage link
* Replace assertTrue(isinstance()) with assertIsInstance()
* Fix typo: remove redundant 'the'
* Support multi arch deployment
* Updated from global requirements
* Use method delete\_if\_exists from oslo.utils
* Use assertRaises() instead of fail()
* Cleanup get\_ilo\_license()
* Fix grenade jobs
* Add a missing whitespace to an error message
* Invalid URL and Typo in enrollment.rst
* Update configuration reference link to latest draft
* Update external links to developer documentation
* Fail test if excepted error was not raised
* Add inspection feature for the OneView drivers
* Use correct option value for standalone install
* Move flavor create under 'VIRT\_DRIVER == ironic'
* Change links to point to new install guide
* Fix inexact config option name in multitenancy.rst
* Fix typos in docstring/comments
* Have bashate run for entire project
* Change 'decom' to clean/cleaning
* Fix docstring typo in test\_common.py
* Fix invalid git url in devstack/local.conf sample
* Fix absolute links to install-guide.rst in developer docs
* Update developer's guide "Installation Guide" link
* Add link to new guide in old install guide
* Fixing Typo
* [install-guide] Import "Setup the drivers for the Bare Metal service"
* [install-guide] Import "Trusted boot with partition image"
* [install-guide] Import "Building or downloading a deploy ramdisk image"
* [install-guide] Import "Appending kernel parameters to boot instances"
* [install-guide] Import configdrive
* [install-guide] Import HTTPS, standalone and root device hints
* [install-guide] Import "Enrollment" and "Troubleshooting" sections
* [install-guide] Import "Local boot with partition images"
* [install-guide] Import "Flavor creation"
* [install-guide] Import "Image requirements"
* [install-guide] Import "integration with other OpenStack components"
* [install-guide] Import Install and configure sections
* [install-guide] Import "Bare Metal service overview"
* Remove unused method is\_valid\_ipv6\_cidr
* Support https in devstack plugin
* Use six.StringIO instead of six.moves.StringIO
* Remove unneeded try..except in heartbeat
* Fix a typo in helper.py
* Add more details to MIGRATIONS\_TIMEOUT note
* Fixes wrong steps to perform migration of nodes
* Increase timeout for migration-related tests
* Update reno index for Newton
* Add i18n \_() to string
* Change the logic of selecting image for tests
* Always return chassis UUID in node's API representation
* Updated from global requirements
* Fix iLO drivers to not clear local\_gb if its not detected

6.2.0
-----

* Clean up release notes for 6.2.0
* Fix DRAC passthru 'list\_unfinished\_jobs' desc
* DevStack: Use Jinja2 for templating when creating new VMs
* DRAC: list unfinished jobs
* Fix broken unit tests for get\_ilo\_object
* Sync ironic-lib.filters from ironic-lib
* Documentation change for feature updates in iLO drivers
* Remove websockify from requirements
* Add a note about security groups in install guide
* Remove unnecessary setUp
* Adds a missing space in a help string
* Remove duplicated line wrt configdrive
* Notification event types have status 'error'
* Refactor common checks when instantiating the ipmitool classes
* Grub2 by default for PXE + UEFI
* Support configdrive in iscsi deploy for whole disk images
* Remove NotificationEventTypeError as not needed
* Mark untested drivers as unsupported
* [trivial] Fix typo in docstring
* Replace "phase" with "status" in notification base
* Updated from global requirements
* Fix test syntax error in devstack/lib/ironic
* Separate WSGIService from RPCService
* Fix link from doc index to user guide
* Update proliantutils version required for Newton release
* Remove unused argument in Tempest Plugin
* Fix docstrings in Tempest Plugin REST client for Ironic API
* Fix docstrings to match with method arguments
* Remove cyclic import between rpcapi and objects.base
* Fix nits on DRAC OOB inspection patch
* Fix DRAC failure during automated cleaning
* Replace six iteration methods with standard ones
* Timing metrics: iLO drivers
* Use assertEqual() instead of assertDictEqual()
* Configure clean network to provision network
* Updated from global requirements
* \_\_ne\_\_() unit tests & have special methods use (self, other)
* Add metrics to administrator guide
* Add \_\_ne\_\_() function for API Version object
* Update unit tests for neutron interface
* Update ironic/ironic.conf.sample
* Allow using TempURLs for deploy images
* Log a warning for unsupported drivers and interfaces
* Add a basic install guide
* [api-ref] Remove temporary block in conf.py
* Deny chassis with too long description
* Update the string format
* [api-ref] Correcting type of r\_addresses parameter
* Remove unused file: safe\_utils.py
* DRAC OOB inspection
* Remove neutron client workarounds
* Update driver requirement for iRMC
* Refresh fsm in task when a shared lock is upgraded
* Updated from global requirements
* Fix exception handling in NodesController.\_lookup
* Remove unused LOG and CONF
* Fix updating port.portgroup\_uuid for node
* Add a newline at the end of release note files
* Replace DOS line endings with Unix
* Fix ironic-multitenant-network job
* Update test\_update\_portgroup\_address\_no\_vif\_id test
* Use assertIsInstance/assertNotIsInstance in tests
* Add standalone\_ports\_supported to portgroup - DB
* Config logABug feature for Ironic api-ref
* DevStack: Configure retrieving logs from the deploy ramdisk
* DRAC RAID configuration
* Metrics for ConductorManager
* Option to enroll nodes with drac driver
* Allow suppressing ramdisk logs collection
* Fix pep8 on Python3.5
* Fix incorrect order of params of assertEqual()
* Updated from global requirements
* Fix for check if dynamic allocation model is enabled
* Add multi-tenancy section to security doc
* Fix formatting strings in LOG.error
* Mask instance secrets in API responses
* Update documentation for keystone policy support
* Fix typo in policy.json.sample
* Add node serial console documentation
* Prevent URL collisions with sub-controllers: nodes/ports
* Centralize Config Options - patch merge, cleanup
* Update the webapi version history reference
* Fix fall back to newer keystonemiddleware options
* OneView test nodes to use dynamic allocation
* Updated from global requirements
* Fix issues in dev-quickstart and index
* Updated from global requirements
* Add notification base classes and docs
* Update hacking test-requirement
* Documentation update
* Removed unneeded vlan settings from neutron config
* iLO drivers documentation update
* Move console documentation to separate file
* Switch Inspector interface to pass keystoneauth sessions
* Adds instructions to perform nodes migration
* Replace DB API call to object's method in iLO drivers
* Move "server\_profile\_template\_uri" to REQUIRED\_ON\_PROPERTIES
* Using assertIsNone() is preferred over assertEqual()
* Updated from global requirements
* Update api-ref for v1.22
* Updated from global requirements
* Pass swiftclient header values as strings
* Get ready for os-api-ref sphinx theme change
* Log node uuid rather than id when acquiring node lock
* Allow changing lock purpose on lock upgrade
* Fix typo: interations -> iterations
* Update code to use Pike as the code name
* Operator documentation for multitenancy
* Always set DEFAULT/host in devstack
* Fix AgentDeploy take\_over() docstring
* Clean imports in code
* Copy iPXE script over only when needed
* Fix incorrect order of params of assertEqual()
* Fix iLO drivers inconsistent boot mode default value
* Update readme file
* Bring upgrade documentation up to date
* Fix test\_find\_node\_by\_macs test
* Use memory mode for sqlite in db test
* Fix key word argument interface\_type -> interface
* Use upper-constraints for all tox targets
* Add nova scheduler\_host\_subset\_size option to docs
* Fix the description of inspection time fields
* DevStack: No need to change the ramdisk filesystem type
* Fix incorrect order of params of assertEqual() in test\_objects.py
* Fix assertEqual(10, 10) in unit/api/v1/test\_utils.py
* Adding InfiniBand Support
* Doc: Recommend users to update their systems
* Centralize config options - [iscsi]
* Centralize config options - [pxe]
* Add "erase\_devices\_metadata\_priority" config option
* Updated from global requirements
* Update renos for fix to ipmi's set-boot-device
* Remove unused [pxe]disk\_devices option
* IPMINative: Check the boot mode when setting the boot device
* IPMITool: Check the boot mode when setting the boot device
* Fix ssh credential validation message
* Remove CONF.import\_opt() from api/controllers/v1/node.py
* Document retrieving logs from the deploy ramdisk
* Fix updating port MAC address for active nodes
* Remove incorrect CONF.import\_opt() from test\_ipmitool.py

6.1.0
-----

* Rename some variables in test\_ipminative.py
* Update proliantutils version required for Newton release
* Refactor OneView dynamic allocation release notes
* Clean up release notes for 6.1.0
* Refactor multitenant networking release notes
* DevStack guide: Bump IRONIC\_VM\_SPECS\_RAM to 1280
* Deprecate ClusteredComputeManager
* 'As of' in documentation is incorrect
* Updated Dev quickstart for viewing doc changes
* Remove duplicate parameters from local.conf example
* Check keyword arguments
* Deprecate putting periodic tasks on a driver object
* Updated from global requirements
* Add metrics for the ipminative driver
* test\_console\_utils: using mock\_open for builtin open()
* Update devstack configure\_ironic\_ssh\_keypair
* Trivial: Remove useless function call in glance service test
* Simplify code by using mask\_dict\_password (again)
* Officially deprecate agent passthru classes and API
* Timing metrics: pxe boot and iscsi deploy driver
* Fix the mistakes in Installation Guide doc
* Use devstack test-config phase
* Rename BaseApiTest.config to app\_config
* Documentation fixes for iLO SSL Certificate feature
* Metrics for agent client
* Simplify code by using mask\_dict\_password
* OneView driver docs explaining Dynamic Allocation
* Docs: Run py34 tox test before py27
* Collect deployment logs from IPA
* Fix typo
* Remove oslo-incubator references
* Promote agent vendor passthru to core API
* Update add nova user to baremetal\_admin behaviour
* Fix typo in Install-guide.rst file
* Replacing generic OneViewError w/ InvalidNodeParameter
* Add Dynamic Allocation feature for the OneView drivers
* Fix \_\_all\_\_ module attributes
* Fix tempest realted exceptions during docs build
* Add keystone policy support to Ironic
* Follow up to keystoneauth patch
* Add a data migration to fill node.network\_interface
* Test that network\_interface is explicitly set on POST/PATCH
* Updated from global requirements
* Create a custom StringField that can process functions
* Revert "Devstack should use a prebuilt ramdisk by default"
* Fix for "db type could not be determined" error message
* Update devstack plugin with new auth options
* Migrate to using keystoneauth Sessions
* Updating dev quickstart to include compatiblity for newest distros
* Update nova scheduler\_host\_manager config docs
* Extend the "configuring ironic-api behind mod\_wsgi" guide
* Add metrics for the ipmitool driver
* Timing metrics for agent deploy classes
* Pass agent metrics config via conductor
* Minor docstring and unittests fixes for IPMIConsole
* Move default network\_interface logic in node object
* Updated from global requirements
* Devstack should use a prebuilt ramdisk by default
* Updated tests for db migration scripts
* Centralize config options - [agent]
* Log full config only once in conductor
* Add node.resource\_class field
* Add api-ref for new port fields
* Add support for the audit middleware
* Change comment regarding network\_interface
* Fix rendering for version 1.14
* Use 'UUID', not 'uuid' in exception strings
* IPMITool: add IPMISocatConsole and IPMIConsole class
* Use assertEqual() instead of assertDictEqual()
* Remove unused code when failing to start console
* Trivial: Fix a trivial flake8 error
* Centralize config options - [deploy]
* Centralize config options - [api]
* Added note to local.conf addressing firewall/proxy blocking Git protocol
* Bug fixes and doc updates for adoption
* Do the VM setup only when requested
* Remove unused import
* Remove duplicate copyright
* Add build-essential to required packages for development
* Implement new heartbeat for AgentDeploy
* Add Python 3.5 tox venv
* Updated from global requirements
* Doc update for in-band cleaning support on more drivers
* Updated from global requirements
* Support to validate iLO SSL certificate in iLO drivers
* Update {configure|cleanup}ironic\_provision\_network
* Add test to verify ironic multitenancy
* Add multitenancy devstack configuration examples
* Following the hacking rule for string interpolation at logging
* Centralize config options - [DEFAULT]
* Add py35 to tox environments
* Metric chassis, driver, node, and port API calls
* Fix fake.FakeBoot.prepare\_ramdisk() signature
* Follow-up to 317392
* Follow-up patch of 0fcf2e8b51e7dbbcde6d4480b8a7b9c807651546
* Updated from global requirements
* Expose node's network\_interface field in API
* Update devstack section of quickstart to use agent\_ipmitool
* Grammar fix in code contribution guide
* Deprecate [ilo]/clean\_priority\_erase\_devices config
* Add configure\_provision\_network function
* Update Ironic VM network connection
* Centralize config options - [neutron]
* Follow-up fixes to 206244
* Nova-compatible serial console: socat console\_utils
* Updated from global requirements
* Add multitenancy-related fields to port API object
* Update the deploy drivers with network flipping logic
* Add 'neutron' network interface
* Fix docstring warnings
* Add and document the "rotational" root device hint
* Add network interface to base driver class
* Increase devstack BM VM RAM for coreos to boot
* Config variable to configure [glance] section
* Add support for building ISO for deploy ramdisk
* Add a doc about appending kernel parameters to boot instances
* Trivial grammar fixes to the upgrade guide
* Remove unused expected\_filter in the unit test
* Updated from global requirements
* Remove white space between print and ()
* Remove IBootOperationError exception
* Delete bios\_wsman\_mock.py from DRAC driver
* Correct reraising of exception
* Allow to enroll nodes with oneview driver
* Add internal\_info field to ports and portgroups
* Centralize config options - [glance]
* Document API max\_limit configuration option
* Fix two types in ironic.conf.sample
* Remove unused LOG
* Remove iterated form of side effects
* Improve the readability of configuration drive doc part
* Drop IRONIC\_DEPLOY\_DRIVER\_ISCSI\_WITH\_IPA from documentation
* Allow to use network interfaces in devstack
* Updated from global requirements
* Centralize config options - [virtualbox]
* Centralize config options - [swift]
* Centralize config options - [ssh]
* Centralize config options - [snmp]
* Add Ironic specs process to the code contribution guide
* Add network\_interface node field to DB and object
* Fix typo in inspection.rst
* Add missing translation marker to clear\_node\_target\_power\_state
* Throwing an exception when creating a node with tags
* Follow-up patch of 9a1aeb76da2ed53e042a94ead8640af9374a10bf
* Fix releasenotes formatting error
* Improve tests for driver's parse\_driver\_info()
* Centralize config options - [seamicro]
* Centralize config options - [oneview]
* Centralize config options - [keystone]
* Centralize config options - [irmc]
* Centralize config options - [ipmi]
* Centralize config options - [inspector]
* Centralize config options - [ilo]
* Introduce new driver call and RPC for heartbeat
* Remove unnecessary calls to dict.keys()
* Fail early if ramdisk type is dib, and not building
* Add dbapi and objects functions to get a node by associated MAC addresses
* Drop references to RPC calls from user-visible errors
* Centralize config options - [iboot]
* Updated from global requirements
* Replace dict.get(key) in api & conductor tests
* Use PRIVATE\_NETWORK\_NAME for devstack plugin
* Create common neutron module
* Updated from global requirements
* Properly set ephemeral size in agent drivers
* Add validation of 'ilo\_deploy\_iso' in deploy.validate()
* Restore diskimage-builder install

6.0.0
-----

* Updated from global requirements
* Mask password on agent lookup according to policy
* Clear target\_power\_state on conductor startup
* Replace assertRaisesRegexp with assertRaisesRegex
* Fix test in test\_agent\_client.py
* Replace dict.get(key) in drivers unit tests
* Docs: Fix some typos in the documentation
* Removes the use of mutables as default args
* Follow-up to Active Node Creation
* Fix parameter create-node.sh
* Replace dict.get(key) in drivers/modules/\*/ tests
* Change port used for Ironic static http to 3928
* Centralize config options - [dhcp]
* Centralize config options - [database]
* Centralize config options - [conductor]
* Centralize config options - [cisco\_ucs]
* Centralize config options - [cimc]
* Centralize config options - [console]
* No need for 'default=None' in config variable
* Fix typo in agent driver
* Use assertIn and assertNotIn
* Document testing an in-review patch with devstack
* Replace vif\_portgroup\_id with vif\_port\_id
* Use assert\_called\_once\_with in test\_cleanup\_cleanwait\_timeout
* Trivial comments fix
* Add Link-Local-Connection info to ironic port
* Remove workaround for nova removing instance\_uuid during cleaning
* Document support for APC AP7921
* Updated from global requirements
* Add cleanwait timeout cleanup process
* Add restrictions for changing portgroup-node association
* Imported Translations from Zanata
* Support for APC AP7922
* fix sed strings in developer doc
* Replace dict.get(key) with dict[key] in unit tests
* Fix JSON error in documentation
* Remove support for the old ramdisk (DIB deploy-ironic element)
* Updated from global requirements
* Document packing and unpacking the deploy ramdisk
* Fix nits related to Ports api-ref
* Gracefully degrade start\_iscsi\_target for Mitaka ramdisk
* Update the api-ref documentation for Drivers
* Update comment from NOTE to TODO
* Active Node Creation via adopt state
* Update resources subnet CIDR
* remove neutron stuff from devstack deb packages
* Keep original error message when cleaning tear down fails
* Add config option for ATA erase fallback in agent
* Fix markup in documentation
* Imported Translations from Zanata
* Updated from global requirements
* Add debug environment to tox
* Correct RAID documentation JSON
* Added ironic-ui horizon dashboard plugin to ironic docs
* Updated from global requirements
* Disable disk\_config compute-feature-enabled in tempest
* Make sure create\_ovs\_taps creates unique taps
* NOTIFICATION\_TRANSPORT should be global
* Remove links to github for OpenStack things
* Update the api-ref documentation for Ports
* Add one use case for configdrive
* Updated from global requirements
* Remove hard-coded keystone version from setup
* Use a single uuid parameter in api-ref
* Use correct iscsi portal port in continue\_deploy
* Fix raises to raise an instance of a class
* Fix formatting of a release note
* Remove support for 'hexraw' iPXE type
* Use messaging notifications transport instead of default
* Updated from global requirements
* tempest: start using get\_configured\_admin\_credentials
* Fix signature for request method
* Remove backward compatibility code for agent url
* Add 'How to get a decision on something' to FAQ
* Follow-up patch of 8e5e69869df476788b3ccf7e5ba6c2210a98fc8a
* Introduce provision states: AVAILABLE, ENROLL
* minor changes to security documentation
* Add support for API microversions in Tempest tests
* Make use of oslo-config-generator
* Mention RFEs in README
* Make the ssh driver work on headless VirtualBox machines
* Allow to specify node arch
* Remove unused is\_valid\_cidr method
* Updated from global requirements
* Restart n-cpu after Ironic install
* Move all cleanups to cleanup\_ironic
* Keep backward compatibility for openstack port create
* Revert "Run smoke tests after upgrade"
* Add some docs about firmware security
* Change HTTP\_SERVER's default value to TFTPSERVER\_IP
* Update the api-ref documentation for Root and Nodes
* Read the Sphinx html\_last\_updated\_fmt option correctly in py3
* devstack: Configure console device name
* Updated from global requirements
* Replace project clients calls with openstack client
* Stop unit-testing processutils internals
* Fix start order for Ironic during upgrade
* Run smoke tests after upgrade
* Add ironic to enabled\_services
* Remove link to Liberty configs
* Updated from global requirements
* Fix shutdown.sh & upgrade.sh for grenade
* add mitaka configuration reference link to the index page
* Remove "periodic\_interval" config option
* Remove verbose option
* Updated from global requirements
* Eliminate warnings about rm in api-ref build
* Remove deprecated driver\_periodic\_task
* Remove backward compat for Liberty cleaning
* Remove [conductor]/clean\_nodes config option
* Remove "message" attribute support from IronicException
* Setup for using the Grenade 'early\_create' phase
* Add support for dib based agent ramdisk in lib/ironic
* Remove deprecated [pxe]/http\_\* options
* Remove [agent]/manage\_tftp option
* Remove "discoverd" configuration group
* Regenerate sample config
* Doc: Replace nova image-list
* Migrate to os-api-ref library
* Add require\_exclusive\_lock decorators to conductor methods
* Fix syntax error in devstack create-node script
* Updated from global requirements
* Fix formatting error in releasenotes
* Allow vendor drivers to acquire shared locks
* Modify doc for RAID clean steps in manual cleaning
* Make iPXE + TinyIPA the defaults for devstack
* Only install DIB if going to use DIB
* Add some docs/comments to devstack/plugin.sh
* devstack: Fetch tarball images via https
* DevStack: Support to install virtualbmc from source
* Regenerate sample configuration
* Allow configuring shred's final overwrite with zeros
* Updated from global requirements
* Deployment vmedia operations to run when cleaning
* Extend IRONIC\_RAMDISK\_TYPE to support 'dib'
* Cleanup unused conf variables
* Adds RAID interface for 'iscsi\_ilo'
* Pass environment through to create-node.sh
* DevStack: Support to install pyghmi from source
* RAID interface to support JBOD volumes
* Remove ClusteredComputeManager docs
* API: Check for reserved words when naming a node
* File download fails with swift pseudo folder
* Migrate api-ref into our tree
* Updating dev-quickstart.rst file links
* Devstack: allow extra PXE params
* Updated from global requirements
* Update resources only for specific node during deletion
* Fix tox cover command
* Fix VirtualBox cannot set boot device when powered on
* Set root hints for disks less than 4Gb and IPA
* Use Ironic node name for VM
* Allow to sepecify VM disk format
* Update compute\_driver in documentation
* Replace logging constants with oslo.log
* iscsi: wipe the disk before deployment
* Joined 'tags' column while getting node
* FIX: IPMI bmc\_reset() always executed as "warm"
* Fix API node name updates
* DevStack: Parametrize automated\_clean
* Very important single character typo fix
* Remove two DEPRECATED config options from [agent]
* Allow to set Neutron port setup delay from config
* Update ironic.config.sample
* Fix usage of rest\_client expected\_success() in tests
* Fixed nits in the new inspection doc page
* Imported Translations from Zanata
* Updated from global requirements
* Document how to run the tempest tests
* Update the inspection documentation
* ipxe: retry on failure
* Add note on prerequisite of 'rpm' file extraction
* Follow-up patch of 0607226fc4b4bc3c9e1738dc3f78ed99e5d4f13d
* Devstack: Change to use 'ovs-vsctl get port tag'
* Restart consoles on conductor startup
* Remove backwards compat for CLEANING
* Make sure Cisco drivers are documented on IRONIC\_DEPLOY\_DRIVER
* Remove two deprecated config option names from [agent] section
* Updated from global requirements
* Add support for Cisco drivers in Ironic devstack
* Updated from global requirements
* [docstring] Update ironic/api/controllers/v1/\_\_init\_\_.py comment
* add new portal\_port option for iscsi module
* Fix tinyipa initrd tarballs.openstack.org file name
* Remove description of 'downgrade' for ironic-dbsync
* In node\_power\_action() add node.UUID to log message
* Rename juno name state modification method
* Prepare for transition to oslo-config-generator
* Updated from global requirements
* Reduce amount of unhelpful debug logging in the API service
* Correct api version check conditional for node.name
* Updated from global requirements
* Enable download of tinyipa prebuilt image
* Follow-up to I244c3f31d0ad26194887cfb9b79f96b5111296c6
* Use get\_admin\_context() to create the context object
* Updated from global requirements
* Don't power off non-deploying iLO nodes in takeover
* deployment vmedia ops should not be run when not deploying
* Fix NamedTemporaryFile() OSError Exception
* Updated from global requirements
* Fix \_do\_next\_clean\_step\_fail\_in\_tear\_down\_cleaning()
* Make tox respect upper-constraints.txt
* Adopt Ironic's own context
* Allow fetching IPA ramdisk with branch name
* Tune interval for node provision state check
* Fix typo in devstack script
* Note on ilo firmware update swift url scheme
* Force iRMC vmedia boot from remotely connected CD/DVD
* Normalize MAC OctetString to fix InvalidMAC exception
* Enable Grenade usage as a plugin
* Readability fixes for cleaning\_reboot code
* Support reboot\_requested bool on agent clean\_steps
* Update tempest compute flavor\_ref/flavor\_ref\_alt
* Move testcases related to parse\_instance\_info()
* Improve check for ssh-key to include public and private files
* Assign valid values to UUIDFields in unit tests
* Fix typos in some source files
* Follow up patch of 843ce0a16160f2e2710ef0901028453cd9a0357c
* Clean up test node post data
* Fix: Duplicated driver causes conductor to fail
* Use trueorfalse function instead of specific value
* Update reno for stable/mitaka
* Doc update to enable HTTPS in Glance and Ironic comm
* Fix race in hash ring refresh unit test
* Addressing nits on I2984cd9d469622a65201fd9d50f964b144cce625
* Config to stop powering off nodes on failure

5.1.0
-----

* Documentation update for partition image support
* Delete bridge "brbm" in devstack/unstack.sh
* Remove unneeded use of task.release\_resources()
* [Devstack]Add ability to enable shellinabox SSL certificate
* Append 'Openstack-Request-Id' header to the response
* Add disk\_label and node\_uuid for agent drivers
* Fix sphinx docs build
* Update authorized\_keys with new key only
* Agent: Out-of-band power off on deploy
* Document partition image support with agent\_ilo
* Add support for partition images in agent drivers
* Update the text in user guide of ironic
* Translate requests exception to IronicException
* Extend the Conductor RPC object
* Make sure target state is cleared on stable states
* Removes redundant "to"
* Install apparmor b/c Docker.io has undeclared dep
* Don't depend on existing file perm for qemu hook
* Move \_normalize\_mac to driver utils
* Devstack: add check of chassis creating
* Allow user to specify cleaning network
* Update ironic\_ssh\_check method
* Adds doc - firmware update(iLO) manual clean step
* Add ensure\_thread\_contain\_context() to task\_manager
* [devstack] Do not die if neutron is disabled
* Follow-up of firmware update(iLO) as manual cleaning step
*  Updating driver docs with DL hardwares requirements
* Remove unneeded 'wait=False' to be more clean and consistent
* Pass region\_name to SwiftAPI
* Uses jsonschema library to verify clean steps
* Fix important typo in the ipmitool documentation
* DevStack: Allow configuring the authentication strategy
* Add documentation for RAID

5.0.0
-----

* Add documentation about the disk\_label capability
* SSH driver: Remove pipes from virsh's list\_{all, running}
* Add documentation for the IPMITool driver
* Fix error in cleaning docs
* Replace depricated tempest-lib with tempest.lib
* Add new 'disk\_label' capability
* Fix JSON string in example of starting manual cleaning
* Remove 'grub2' option in creating whole-disk-images
* Update iRMC driver doc for inspection
* Don't use token for glance & check for some unset vars
* Use 'baremetal' flavor in devstack
* [devstack] Fix IPA source build on Fedora
* DevStack: Enable VirtualBMC logs
* Support for passing CA certificate in Ironic Glance Communication
* Updated from global requirements
* Firmware update(iLO) as manual cleaning step
* Updated from global requirements
* Remove code duplication
* Update iLO documentation for clean step 'reset\_ilo'
* Refactor the management verbs check to utils
* Updated from global requirements
* Remove duplicate doc in ironic.conf.sample
* Prep for 5.0 release
* Fix unittests after new releases of libraries
* Updating docs with support for DL class servers
* Update CIMC driver docs to install ImcSdk from PyPi
* Add returns to send\_raw() ipmitool function
* Add function for dump SDR to ipmitool driver
* Add clean step in iLO drivers to activate iLO license
* Update proliantutils version to 2.1.7 for Mitaka release
* ipxe: add --timeout parameter to kernel and initrd
* Updated iLO driver documentation to recommend ipmitool version
* Refactor driver loading to load a driver instance per node
* Clean up driver loading in init\_host
* add wipefs to ironic-lib.filters
* Updated from global requirements
* Use assertEqual/Greater/Less/IsNone
* Follow up nits of 3429e3824c060071e59a117c19c95659c78e4c8b
* API to list nodes using the same driver
* [devstack] set ipa-debug=1 for greater debugability
* Loose python-oneviewclient version requirement
* Set node last\_error in TaskManager
* Add possible values for config options
* Follow up nits of irmc oob inspection
* Enable removing name when updating node
* Make some agent functions require exclusive lock
* Add db api layer for CRUD operations on node tags
* Update proliantutils version required for Mitaka release
* Add deprecated\_for\_removal config info in ironic.conf.sample
* Update ironic.conf.sample
* Tolerate roles in context.RequestContext
* Switch to Futurist library for asynchronous execution and periodic tasks
* Move \_from\_db\_object() into base class
* Add ironic\_tempest\_plugin to the list of packages in setup.cfg
* Fix gate broken by sudden remove of SERVICE\_TENANT\_NAME variable
* Add manual cleaning to documentation
* Import host option in base test module
* Fixes automated cleaning failure in iLO drivers
* Updated from global requirements
* DevStack: Add support for deploying nodes with pxe\_ipmitool
* Change the libvirt NIC driver to virtio
* DevStack: Support to install diskimage-builder from source
* [Devstack]Add ability to enable ironic node pty console
* Use 'node' directly in update\_port()
* Add links to the standalone configdrive documentation
* DevStack: Install squashfs-tools
* [DevStack] fix restart of nova compute
* Use http\_{root, url} config from "deploy" instead of "pxe"
* During cleaning, store clean step index
* Use oslo\_config.fixture in unit tests
* Introduce driver\_internal\_info in code-contribution-guide
* Updated from global requirements
* Correct instance parameter description
* Add node.uuid to InstanceDeploy error message
* Set existing ports pxe\_enabled=True when adding pxe\_enabled column
* Augmenting the hashing strategy
* Add hardware inspection module for iRMC driver
* Document possible access problems with custom IRONIC\_VM\_LOG\_DIR path
* Add documentation for proxies usage with IPA
* Updated from global requirements
* Devstack: create endpoint in catalog unconditionally
* Comment out test options that already exists on tempest's tree
* Replace config 'clean\_nodes' with 'automated\_clean'
* Remove 'zapping' from code
* Cache agent clean steps on node
* API to manually clean nodes
* Replace ifconfig with ip
* Updated iLO documentation for boot mode capability
* Agent vendor handles manual cleaning
* Remove downgrade support from migrations
* Enable tinyipa for devstack Ironic
* Disable clean step 'reset\_ilo' for iLO drivers by default
* Add proxy related parameters to agent driver
* Update ironic.conf.samle
* Fix genconfig "tempdir" inconsistency
* Update the home page
* Follow-up on dracclient refactor
* Log warning if ipmi\_username/ipmi\_password missing
* Add portgroups to support LAG interfaces - net
* Add portgroups to support LAG interfaces - RPC
* Add portgroups to support LAG interfaces - objs
* Add portgroups to support LAG interfaces - DB
* Fix missing lookup() vendor method error for pxe\_drac
* Refresh ssh verification mechanism
* Refactor install-guide to configure API/Conductor seperately
* Enable Ironic Inspector for Cisco Drivers
* Fix doc8's "duplicated target names" (D000) error
* Remove conditional checking the auth\_strategy values
* Extend root device hints to support device name
* Fix spawn error hook in "continue\_node\_clean" RPC method
* Enable doc8 style checker for \*.rst files
* Updated from global requirements
* Show transitions initiated by API requests
* Remove hard-coded DEPLOYWAIT timeout from Baremetal Scenario
* Fix tiny format issue with install\_guide
* Add priority to manual clean step example
* Use node uuid in some exception log
* Fix error message in devstack
* Updated from global requirements
* [devstack] Restart nova compute before checking hypervisor stats
* Imported Translations from Zanata
* Fix minor typo
* DRAC: cleanup after switch to python-dracclient
* API service logs access requests again
* Updated from global requirements
* Correct port\_id parameter description
* Remove duplicate words in API version history
* Remove unneeded enable\_service in dev-quickstart.rst
* Clarify that size in root device hints and local\_gb are often different
* Update ImcSdk requirement to use PyPi
* Clean up 'no\_proxy' unit tests
* Add more unit tests for NO\_PROXY validation
* Add ability to cache swift temporary URLs
* DRAC: switch to python-dracclient on vendor-passthru
* Migrate Tempest tests into Ironic tree
* Use Tempest plugin interface
* Fix issues with uefi-ipxe booting
* Update links to OpenStack manuals
* Fix issue where system hostname can impact genconfig
* Add choices option to several options
* Add xinetd and its TFTP configuration in Install Guide
* Reorganize the developer's main page
* Document backwards compat for passthru methods
* Drop MANIFEST.in - it's not needed pbr
* Clean up unneeded deprecated\_group
* Devstack: replace 'http' with SERVICE\_PROTOCOL
* Clarify rejected status in RFE contribution docs
* Bring UP baremetal bridge
* Adjust ipminative.\_reboot to comply with pyghmi contract
* Document the process of proposing new features
* Updated from global requirements
* Use assertTrue/False instead of assertEqual(T/F)
* devstack 'cleanup-node' script should delete OVS bridges
* Change default IRONIC\_VM\_SPECS\_RAM to 1024
* Remove release differences from flavor creation docs
* Add documentation for standalone ilo drivers
* Devstack: Make sure libvirt's hooks directory exists
* Update the ironic.conf.sample file
* Follow-up on refactor DRAC management interface
* Allow user to set arch for the baremetal flavor and ironic node
* tox: make it possible to run pep8 on current patch only
* Devstack: Use [deploy] erase\_devices\_priority config option
* Remove bashate from envlist
* Use ironic-lib's util methods
* Refactor objects into a magic registry
* Don't return tracebacks in API response in debug mode
* Updated from global requirements
* Change assertTrue(isinstance()) by optimal assert
* Remove \*/openstack/common\* in tox
* Remove vim headers in source files
* Trival: Remove unused logging import
* Use ironic-lib's qemu\_img\_info() & convert\_image()
* Update "Developer Quick-Start" guide for Fedora 23+
* Enable ironic devstack plugin in local.conf sample
* Correct a tiny issue in install-guide
* Install 'shellinabox' package for Ironic
* Fix translations in driver base
* Run flake8 against the python scripts under tools/ and devstack/tools
* Add UEFI support for iPXE
* Add console feature to ssh driver
* Conductor handles manual cleaning
* Add extensions to the scripts at devstack/tools/ironic/scripts
* Fix "No closing quotation" error when building with tox
* Devstack: Remove QEMU hook at ./unstack
* Run bashate as part of the pep8 command
* Fix bashate errors in grenade plugin
* Fix syntax errors in the shell scripts under devstack/tools
* Use the apache-ironic.template from our tree
* Fix typo in ironic/conductor/manager.py
* genconfig: Debug info for unknown config types
* Keep the console logs for all boots
* Use imageutils from oslo.utils
* Add documentation for user inputs as HTTPS URLs
* Add bashate tox command
* Updated from global requirements
* Add documentation for swiftless intermediate images
* DRAC: switch to python-dracclient on management interface
* DRAC: switch to python-dracclient on power interface
* Follow up nits of Exception to str type conversion
* Clean up variables in plugin.sh
* Replace assertEqual(None, \*) with assertIsNone in tests
* Add utility function to validate NO\_PROXY
* Add bifrost as an option projects in Service overview
* Sequence diagrams for iLo driver documentation
* Refactor ilo documentation for duplicate information
* Update swift HTTPs information in ilo documentation
* Updated from global requirements
* Deprecated tox -downloadcache option removed
* Remove override-defaults
* Use 'service\_type' of 'network'. Not 'neutron'
* Update ironic.conf.sample by applying the bug fix #1522841
* Add grenade plugin
* Follow up patch to correct code-contribute-guide
* Fix iPXE template for whole disk image
* Add devstack plugin
* Copy devstack code to ironic tree
* Add FSM.is\_stable() method
* Explicitly depend on WebTest>=2.0
* Always pass keystone credentials to neutronclient
* Remove extra space in 'host' config comment
* Add oslo\_config.Opt support in Ironic config generator
* Refactor disk partitioner code from ironic and use ironic-lib
* Simplifies exception message assurance for oneview.common tests
* Use node.uuid directly in stop\_console()
* Correct NotImplemented to NotImplementedError in rpcapi.py
* Adding oneview.common tests for some method not well tested
* Add port option support for ipmitool
* Numerous debug messages due to iso8601 log level
* Handle deprecated opts' group correctly
* Updated from global requirements
* Clarify what changes need a release note
* Remove wsgi reset\_pool\_size\_to\_default test
* Add Mitaka release notes page
* Update python-scciclient version number
* Add release notes from Icehouse to Liberty
* Add Code Contribution Guide for Ironic
* Replace HTTP 'magic numbers' with constants
* Documentation points to official release notes

4.3.0
-----

* Fix awake AMT unit test
* Fix bug where clean steps do not run
* Add reno for AMT wakeup patch
* Updating OneView driver requirements and docs
* Correct the db connection string in dev-quickstart
* Split BaseConductorManager from ConductorManager
* Validate arguments to clean\_step() decorator
* test: Remove \_BaseTestCase
* Wake up AMT interface before send request
* Fall back to old boot.ipxe behaviour if inc command is not found
* Only mention IPA in the quick start and user guides for DevStack
* Improve options help for image caching
* Add troubleshooting docs for "no valid host found"
* change mysql url in dev-quickstart doc
* Extend FAQ with answer of how to create a new release note
* Sync ironic.conf sample
* Comment spelling error in ironic-images.filters file
* Updated from global requirements
* Add a developer FAQ
* Add tests for RequestContextSerializer
* Add a test to enforce object version bump correctly
* force releasenotes warnings to be treated as errors
* Avoid RequestContextSerializer from oslo.messaging
* Follow up patch for the first commit of iRMC new boot I/F
* Move iso8601 as a test dependency only
* Catch up release notes for Mitaka
* Move common code from ironic.conductor.manager to ironic.conductor.utils
* Add deprecated config info in ironic.conf.sample
* Add switch to enable/disable streaming raw images for IPA
* SwiftAPI constructor should read CONF variables at runtime
* Take over console session if enabled
* Drop some outdated information from our quick start guide
* Refactor IRMCVirtualMediaAgentDeploy by applying new BootInterface
* Refactor IRMCVirtualMediaIscsiDeploy by applying new BootInterface
* Updated from global requirements
* Fix: Next cleaning hangs if the previous cleaning was aborted
* Add clean up method for the DHCP factory
* Add missing packages to dev-quickstart
* Support arguments for clean step methods
* Validate all tcp/udp port numbers
* Add manual cleaning to state machine
* Specifying target provision states in fsm
* Use server\_profile\_template\_uri at scheduling
* Check shellinabox started successfully or not
* Add SSL support to the Ironic API
* Updated from global requirements
* Use wsgi from oslo.service for Ironic API
* Remove duplicated unit tests in test\_manager
* Get mandatory patch attrs from WSME properties
* Add and document two new root device hints: wwn\_{with, vendor}\_extension
* Sort root device hints when parsing
* add "unreleased" release notes page
* Follow up patch for 39e40ef12b016a1aeb37a3fe755b9978d3f9934f
* Document 'erase\_devices\_iterations' config option
* Update iLO documentation
* Adds test case for the iscsi\_ilo recreate boot iso
* Refactor agent\_ilo driver to use new boot interface
* Updated from global requirements
* Refactor iLO driver console interface into new module
* Add reno for release notes management
* Add choices to temp\_url\_endpoint\_type config option
* Fix oslo namespace in default log level
* Remove \_\_name\_\_ attribute from WSME user types
* refine the ironic installation guide
* Revert "Add Pillow to test-requirements.txt"
* Update etc/ironic/ironic.conf.sample
* Make task parameter mandatory in get\_supported\_boot\_devices
* Follow up patch for Ib8968418a1835a4131f2f22fb3e4df5ecb9b0dc5
* Check shellinabox process during stopping console
* Add whole disk image creation command to Installation Guide
* Fix docker.io bug in the Install Guide
* Updated from global requirements
* Node's last\_error to show the actual error from sync\_power\_state
* Updated from global requirements
* Rename test\_conductor\_utils.py to test\_utils.py
* Follow up patch for 8c3e102fc5736bfcf98525ebab59b6598a69b428
* Add agent\_iboot entrypoint
* Validate console port number in a valid range
* iboot: add wait loop for pstate to activate
* Don't reraise the exception in \_set\_console\_mode
* Check seamicro terminal port as long as it specified
* Add missing unit tests for some PXE drivers
* Validate the input of properties of nodes
* Add documentation for Ceph Object Gateway support
* Refactor iscsi\_ilo driver to use new boot interface
* Fix comments on DRAC BIOS vendor\_passthru
* cautiously fail on unhandled heartbeat exception
* Add "agent\_wol" (AgentAndWakeOnLanDriver)
* Added unit tests for CORS middleware
* Use oslo\_config new type PortOpt for port options
* Fix markup error in deploy/drivers.rst
* Update the Configuration Reference to Liberty in doc
* Updated from global requirements
* Use self.\_\_class\_\_.X instead of self.X
* Rename utils.py to mgr\_utils.py to avoid namespace collision
* XenAPI: Add support for XenServer VMs
* Add PortOpt to config generator
* Imported Translations from Zanata
* Move hash\_ring refresh logic out of sync\_local\_state
* Move ironic.tests.unit.base to ironic.tests.base
* Change required version of ImcSdk to 0.7.2
* Add an iboot reboot\_delay setting
* iPXE document about the existence of prebuilt images
* Fix a typo
* Switched order of CORS middleware
* DRAC BIOS vendor\_passthru: enable rebooting the node
* Replace deprecated LOG.warn with warning
* Add db migration and model for tags table
* Add OneView driver documentation
* Fix snmp property descriptions
* Updated from global requirements
* Slightly reword README
* Remove unused functions from agent driver
* mocking syscalls to make the tests run on OS X
* Enable cmd/api & cmd/conductor to be launched directly
* Add reboot\_delay option to snmp driver
* Add self.raid for iSCSI based drivers
* Move test\_pxe.py inside unit/drivers/modules directory
* Move pxe.\_parse\_instance\_info() to deploy\_utils
* Add note about driver API breakage
* Fix a missing detail in install guide
* Enable radosgw support in ironic
* Updated from global requirements
* Add agent\_amt docs
* Add release notes for 4.2.1
* Convert set() to list in ListType
* remove lxml requirement
* Update python-oneviewclient version
* Fix an annoying detail in the developer quick-start
* Updated from global requirements
* Expose versioning information on GET / endpoint
* Fixes logging of failure in deletion of swift temporary object
* ucs\_hostname changed to ucs\_address
* Updated from global requirements
* Remove functions: \_cleanse\_dict & format\_message
* Move FakeOneViewDriver to the fake.py module
* Add testresources and testscenarios used by oslo.db fixture
* Add agent\_amt driver
* Imported Translations from Zanata
* Stop adding translation function to builtins
* Fix tests giving erroneous output during os-testr run
* OneView Driver for Ironic
* Fix agent\_ilo to remove temporary images
* Updated from global requirements
* iPXE: Fix assumption that ${mac} is the MAC of the NIC it's booting
* Prevent iRMC unit test from potential failure at the gate
* Add secret=True to password option
* Fix a bug error by passwords only includes numbers
* Add support for in-band cleaning in ISCSIDeploy
* Fix typo in document
* Remove unused import of oslo\_log
* Use power manager to reboot in agent deployments
* Add retries to ssh.\_get\_hosts\_name\_for\_node
* Refactor deploy\_utils methods
* Fix irmc driver unit test
* PXE: Support Extra DHCP Options for IPv6
* Use standard locale when executing 'parted' command
* Updated from global requirements
* To run a specific unit test with ostestr use -r
* Add .eggs to gitignore
* Fix log formatting issue in agent base
* Add notes to functions which are in ironic-lib
* Allow empty password for ipmitool console
* Update help string on tftp\_root option
* Updated from global requirements
* Fix conductor deregistration on non init conductor
* Imported Translations from Zanata
* Add Pillow to test-requirements.txt
* Add agent inspection support for IPMI and SSH drivers
* Python 3.4 unit tests fail with LANG=C
* Fix ubuntu install command in install guide
* Move unit tests to correct directory
* Add 'whitelist\_externals = bash' for two testenvs
* Rename 'message' attribute to '\_msg\_fmt' in IronicException
* Follow up for: Prepare for functional testing patch
* Fix documentation for installing mariaDB
* Update help strings for DRAC configs
* Switch tox unit test command to use ostestr
* Use standard locale when executing 'dd' command
* Imported Translations from Zanata
* Fix typo: add a missing white space
* Prepare for functional testing
* Fix some iBoot strings
* Replace six.iteritems() with .items()
* Make generation of ironic.conf.sample deterministic
* Cached file should not be deleted if time equal to master

4.2.0
-----

* Cleanup of Translations
* Update architecture docs to mention new driver interfaces
* Add 4.2.0 release notes
* Update docs for Fedora 22
* Add i18n \_ import to cimc common
* Update proliantutils version required for L release
* Use of 'the Bare Metal service' in guide
* Update install guide to reflect latest code
* Implement indirection\_api
* Add 'abort' to state machine diagram
* Unit test environment setup clarification
* Make end-points discoverable via Ironic API
* Updated from global requirements
* Allow unsetting node.target\_raid\_config
* Allow abort for CLEANWAIT states
* Clean up CIMC driver docs and comments
* Add Cisco IMC PXE Driver
* Fix final comments in RAID commits
* Refactor agent {prepare,tear\_down}\_cleaning into deploy\_utils
* Handle unquoted node names from virt types
* Fix iRMC vmedia deploy failure due to already attached image
* Implement take\_over for iscsi\_ilo driver
* Fix typo in vendor method dev documentation
* Fix incorrect urls
* Check image size before provisioning for agent driver
* Help patch authors to remember to update version docs
* Add constraint target to tox.ini
* Add IPMINative vendor methods to \*IPMINative drivers
* Fix string formatting issues
* Remove DictMatches custom matcher from unit tests
* Imported Translations from Zanata
* Remove unused object function
* Use oslo.versionedobjects remotable decorators
* Base IronicObject on VersionedObject
* Update descriptions in RAID config schema
* Document GET ...raid/logical\_disk\_properties
* Convert functools.wraps() usage to six.wraps()
* Remove comment about exception decorator
* Replace metaclass registry with explicit opt-in registry from oslo
* Add config option to override url for links
* Fix iBoot test\_\_switch\_retries test to not waste time sleeping
* Allow tftpd usage of '--secure' by using symlinks
* Add support for inband raid configuration agent ramdisk
* Agent supports post-clean-step operations
* Update 'Installation Guide' for RHEL7/CentOS7/Fedora
* Fix docs about --is-public parameter for glance image-create
* Fix indentation of the console docs
* Fix heading levels in the install-guide
* Cache the description of RAID properties
* Remove the hard dependency of swift from ilo drivers
* Fix mistakes in comments
* Updated from global requirements
* Fix object field type calling conventions
* Add version info for pyghmi in driver-requirements.txt

4.1.0
-----

* Add 4.1.0 release notes
* Try to standardize retrieval of an Exception's description
* Add description how to restart ironic services in Fedora/RHEL7/CentOS7
* Improve the ability to resolve capability value
* Add supported environment 'VMware' to comments
* Updated from global requirements
* Remove policy 'admin' rule support
* Handle missing is\_whole\_disk\_image in pxe.\_build\_pxe\_config\_options
* Raise InvalidPrameterValue when ipmi\_terminal\_port is ''
* Fix doc typo
* Remove executable permission from irmc.py
* Add APIs for RAID configuration
* agent\_ilo fails to bring up instance
* Updated from global requirements
* Remove 'is\_valid\_event' method
* Set boot device in PXE Boot interface method prepare\_instance()
* Revert "Do not overwrite the iPXE boot script on every deployment"
* Add vendor interface to ipminative driver
* When boot option is not persisted, set boot on next power on
* Document nodes in enroll state, in install guide
* Added CORS support middleware to Ironic
* Refactor map\_color()
* Removes unused posix-ipc requirement
* Add retry options to iBoot power driver
* Trusted boot doc
* Prevent ilo drivers powering off active nodes during take over
* Add release notes for 4.0.0
* Clean up cleaning error handling on heartbeats
* Use vendor mixin in IPMITool drivers
* Use oslo.messaging serializers
* Add RPC APIs for RAID configuration
* Add new method validate\_raid\_config to RAIDInterface
* Fix docker package name in Ubuntu 14.04 in Install Guide
* Updated from global requirements
* Do not overwrite the iPXE boot script on every deployment
* Reset tempdir config option after NestedTempfile fixture applied
* Remove unused dep discover from test reqs
* Add deprecation warning to periodic tasks with parallel=False
* Use six.text\_type in parse\_image\_ref
* Ensure that pass\_deploy\_info() always calls boot.prepare\_instance()
* Add minimum and maximum on port option
* Update ironic.conf.sample with tox -egenconfig
* Update documentation to install grub2 when creating the user image
* Fix logging and exceptions messages in ipminative driver
* Fix minor spelling/grammar errors
* Put py34 first in the env order of tox
* format links in the readme to work with the release notes tools
* Periodically checks for nodes being cleaned
* Add links for UEFI secure boot support to iLO driver documentation
* Add cleanup in console utils tests
* Follow up the nits in iRMC vmedia driver merged patch
* Refactor agent driver with pxe boot interface
* Update tests to reflect WSME 0.8 fixes
* Remove ObjectListBase
* Remove broken workaround code for old mock
* Create a versions.py file
* Improve comparison operators for api/controllers/base.py
* Switch to post-versioning

4.0.0
-----

* Fix improper exception catching
* Fix nits from 'HTTP constants' patch
* Use JsonEncoded{Dict,List} from oslo\_db
* Move tests into correct directories
* Fix logging levels in do\_node\_deploy
* Fix misspelling from "applicatin" to "application"
* Updated from global requirements
* Remove unneeded module variable '\_\_all\_\_'
* Updated from global requirements
* Change and edit of Ironic Installation Guide
* Remove the --autofree option from boot.ipxe
* Switch from deprecated timeutils.isotime
* Fix "tox -egenconfig" by avoiding the MODULEPATH env variable
* Improve logging for agent driver
* Refactor the essential prop list of inspect driver
* Reset clean\_step if error occurs in CLEANWAIT
* Fix bug sending sensor data for drivers w/o management
* Replace HTTP 'magic numbers' with constants
* Address final comments on update image cache based on update time
* 'updated\_at' field shows old value after resource is saved
* Increase size of nodes.driver column
* Add better dbapi support for querying reservation
* Allow digits in IPA driver names
* Updated from global requirements
* Add documentation for iRMC virtual media driver
* Add copyright notice to iRMC driver source code
* Remove CONF.agent.agent\_pxe\_bootfile\_name
* Update single letter release names to full names
* Enforce flake8 E711
* Update docstring for agent deploy's take\_over
* Update cached images based on update time
* Updated from global requirements
* Add RAIDInterface for RAID configuration
* get\_supported\_boot\_devices() returns static device list
* add ironic client and ironic inspector projects into contribution list
* Updated from global requirements
* Use the oslo\_utils.timeutils 'StopWatch' class
* Update the documentation to use IPA as deploy ramdisk
* Inspector inspection fails due to node locked error
* Prevent power actions when the node is in CLENWAIT state
* Imported Translations from Transifex
* Remove unnecessary trailing backslash in Installation Guide
* Refactor some minor issues to improve code readability
* Fix misspelling in comment
* Make app.wsgi more like ironic.cmd.api
* Migrate IronicObjectSerializer to subclass from oslo
* Updated from global requirements
* Fix warnings on doc builds
* Change vagrant.yml to vagrant.yaml
* Developer quickstart documentation fixes
* Document configuring ironic-api behind mod\_wsgi
* Updated from global requirements
* Add deprecation messages on the bash ramdisk endpoints
* Document API versioning
* Log configuration values as DEBUG, not INFO
* Update ironic.conf.sample
* Update ironic.conf.sample
* Add information 'node\_uuid' in debug logs to facilitate the reader's life
* Clean up instance\_uuid as part of the node's tear down
* Fix a trusted boot test bug
* Add more info level log to deploy\_utils.work\_on\_disk() method
* Fix broken agent virtual media drivers
* Updated from global requirements
* Fix apache wsgi import
* Add raises docstring tag into object.Ports methods
* Only take exclusive lock in sync\_power\_state if node is updated
* Secure boot support for pxe\_ilo driver
* UCS: node-get-boot-device is failing for Cisco servers
* grub2 bootloader support for uefi boot mode
* Add Nova scheduler\_tracks\_instance\_changes config to docs
* Use automaton's converters/pydot
* enroll/verify/cleanwait in state machine diagram
* Save and re-raise exception
* Cache Keystone client instance
* Refactor pxe - New PXEBoot and ISCSIDeploy interfaces
* Don't prevent updates if power transition is in progress
* Follow-on to b6ed09e297 to fix docstrings/comments
* Make inspector driver test correctly
* Allow inspector driver to work in standalone mode
* Remove outdated TODO.rst file
* Updated from global requirements
* Introduce support for APC MasterSwitchPlus and Rack PDU
* Allow agent lookup to directly accept node UUID
* Add CLEANWAIT state
* Allow updates in VERIFYING state
* Allow deleting nodes in ENROLL state
* Updated from global requirements
* Fixes a testcase related to trusted boot in UEFI boot mode
* Clarify inspection upgrade guide
* Refactor refresh method in objects for reuse
* Imported Translations from Transifex
* Use utils.mkfs directly in deploy\_utils
* Updated from global requirements
* Migrate ObjectListBase to subclass from the Oslo one
* Clean up tftp files if agent deployed disk image
* Don't do a premature reservation check in the provision API
* Move the http\_url and http\_root to deploy config
* Allow upgrading shared lock to an exclusive one
* Fix the DEPLOYWAIT check for agent\_\* drivers
* Add a missing comma in Vendor Methods of Developer Guide
* Replacing dict.iteritems() with dict.items()
* Updated from global requirements
* db: use new EngineFacade feature of oslo.db
* Address minor comments on the ENROLL patch
* Remove requirements.txt from tox.ini deps
* Updated from global requirements
* Replace common.fileutils with oslo\_utils.fileutils
* Updated from global requirements
* Switch to the oslo\_utils.fileutils
* Start using new ENROLL state
* Add .idea to .gitignore
* Periodically checks the status of nodes in DEPLOYING state
* Add IPA support for iscsi\_irmc driver
* Updated from global requirements
* Vagrant configuration generation now uses pymysql
* Remove deprecated code for driver vendor passthru
* Add DRAC BIOS config vendor passthru API
* Use DEPLOYWAIT while waiting for agent to write image
* Fix unittests due mock 1.1.0 release
* Migrate RPC objects to oslo.versionedobjects Fields
* Imported Translations from Transifex
* Updated from global requirements
* Mock the file creation for the GetConfigdriveTestCase tests
* Address follow-up comments
* Clear ilo\_boot\_iso before deploy for glance images
* Enable translation for config option help messages
* Replace is\_hostname\_safe with a better check
* Initial oslo.versionedobjects conversion
* Add whole disk image support for iscsi\_irmc driver
* Add localboot support for iscsi\_irmc driver
* Add iRMC Virtual Media Deploy module for iRMC Driver
* add python-scciclient version number requirement
* Remove db connection string env variable from tox.ini
* Make use of tempdir configuration
* Updated from global requirements
* Fix failing unit tests under py34
* Allow vendor methods to serve static files
* Allow updates when node is on ERROR provision state
* Add sequence diagrams for pxe\_ipmi driver
* Fix logging for soft power off failures
* Mute ipmi debug log output
* Validate IPMI protocol version for IPMIShellinaboxConsole
* Image service should not be set in ImageCache constructor
* Clean nodes stuck in DEPLOYING state when ir-cond restarts
* Add ability to filter nodes by provision\_state via API
* Refactor check\_allow\_management\_verbs
* Add node fields for raid configuration
* Switch to oslo.service
* Fix "boot\_mode\_support" hyper link in Installation Guide
* Log configuration options on ironic-conductor startup
* Allow deleting even associated and active node in maintenance mode
* Use oslo\_log
* Replace self.assertEqual(None,\*) to self.assertIsNone()
* Improve warning message in conductor.utils.node\_power\_action()
* Add a new boot section 'trusted\_boot' for PXE
* use versionutils from oslo\_utils
* Make task\_manager logging more helpful
* Add IPMI 1.5 support for the ipmitool power driver
* Add iBoot driver documentation
* Updated from global requirements
* Add unit test for ilo\_deploy \_configure\_vmedia\_boot()
* Do not use "private" attribute in AuthTokenMiddleware
* API: Get a subset of fields from Ports and Chassis
* Save disk layout information when deploying
* Add ENROLL and related states to the state machine
* Refactor method to add or update capability string
* Use LOGDIR instead of SCREEN\_LOGDIR in docs
* Always allow removing instance\_uuid from node in maintenance mode
* API: Get a subset of fields from Nodes
* Switch from MySQL-python to PyMySQL
* Updated from global requirements
* copy editing of ironic deploy docs
* Transition state machine to use automaton oslo lib
* Finish switch to inspector and inspector-client
* Rename ilo\_power.\_attach\_boot\_iso to improve readability
* Expose current clean step in the API
* Fix broken ACL tests
* Add option to configure passes in erase\_devices
* Refactor node's and driver's vendor passthru to a common place
* Change return value of [driver\_]vendor\_passthru to dict
* Add Wake-On-Lan driver documentation
* Fixes a bug on the iLO driver tutorial
* Address follow-up comments on ucs drivers
* Added documentation to Vagrantfile
* Updated from global requirements
* Addresses UcsSdk install issue
* Don't raise exception from set\_failed\_state()
* Add disk layout check on re-provisioning
* Add boot interface in Ironic
* Fix Cisco UCS slow tests
* Validate capability in properties and instance\_info
* Pass environment variables of proxy to tox
* DRAC: fix set/get boot device for 11g
* Enable flake8 checking of ironic/nova/\*
* Remove tools/flakes.py
* Wake-On-Lan Power interface
* IPA: Do a soft power off at the end of deployment
* Remove unnecessary validation in PXE
* Add additional logging around cleaning
* remove unneeded sqlalchemy-migrate requirement
* Add vendor-passthru to attach and boot an ISO
* Updated from global requirements
* Sync with latest oslo-incubator
* Add pxe\_ucs and agent\_ucs drivers to manage Cisco UCS servers
* Doc: Use --notest for creating venv
* Updated from global requirements
* Fix DRAC driver job completion detection
* Add additional required RPMs to dev instructions
* Update docs for usage of python-ironicclient
* Install guide reflects changes on master branch
* Remove auth token saving from iLO driver
* Don't support deprecated drivers' vendor\_passthru
* Updated from global requirements
* Enforce flake8 E123/6/7/8 in ironic
* Change driver\_info to driver\_internal\_info in conductor
* Use svg as it looks better/scales better than png
* Updated from global requirements
* Use oslo config import methods for Keystone options
* Add documentation for getting a node's console
* fix node-get-console returns url always start with http
* Update the config drive doc to replace deprecated value
* Updated from global requirements
* Remove bogus conditional from node\_update
* Prevent node delete based on provision, not power, state
* Revert "Add simplegeneric to py34 requirements"
* Do not save auth token on TFTP server in PXE driver
* Updated from global requirements
* Update iLO documentation for UEFI secure boot
* ironic-discoverd is being renamed to ironic-inspector
* Update doc "install from packages" section to include Red Hat
* Improve strictness of iLO test cases error checking
* Remove deprecated pxe\_deploy\_{kernel, ramdisk}
* Get admin auth token for Glance client in image\_service
* Fix: iSCSI iqn name RFC violation
* Update documentation index.rst
* Update AMT Driver doc
* Refactor ilo.common.\_prepare\_floppy\_image()
* Do not add auth token in context for noauth API mode
* DRAC: config options for retry values
* Disable meaningless sort keys in list command
* Update pyremotevbox documentation
* Fix drac implementation of set\_boot\_device
* Update to hacking 0.10.x
* Prepare for hacking 0.10.x
* Rename gendocs tox environment
* Add simplegeneric to py34 requirements
* Reduce AMT Driver's dependence on new release of Openwsman
* Fixes some docstring warnings
* Slight changes to Vagrant developer configs
* Delete neutron ports when the node cleaning fails
* Update docstring DHCPNotFound -> DHCPLoadError
* Wrap all DHCP provider load errors
* Add partition number to list\_partitions() output fields
* Added vagrant VM for developer use
* Execute "parted" from root in list\_partitions()
* Remove unused CONF variable in test\_ipminative.py
* Ironic doesn't use cacert while talking to Swift
* Fix chainloading iPXE (undionly.kpxe)
* Updated from global requirements
* Improve root partition size check in deploy\_partition\_image
* ironic/tests/drivers: Add autospec=True and spec\_set=
* Fix and enhance "Exercising the Services Locally" docs
* Fix typos in Ironic docs
* Fix spelling error in docstring
* Remove deprecated exceptions
* Check temp dir is usable for ipmitool driver
* Improve strictness of AMT test cases error checking
* Improve strictness of iRMC test cases error checking
* Fix Python 3.4 test failure
* Remove unneeded usage of '# noqa'
* Drop use of 'oslo' namespace package
* Updated from global requirements
* Specify environment variables needed for a standalone usage
* Adds OCS Power and Management interfaces
* Run tests in py34 environment
* Adds docstrings to some functions in ironic/conductor/manager.py
* Add section header to state machines page
* Update config generator to use oslo released libs
* Use oslo\_log lib
* Include graphviz in install prerequisites
* Link to config reference in our docs
* Adopt config generator
* Remove cleanfail->cleaning from state diagram
* Imported Translations from Transifex
* Return HTTP 400 for invalid sort\_key
* Update the Vendor Passthru documentation
* Add maintenance mode example with reason
* Add logical name example to install-guide
* Improve strictness of DRAC test cases error checking
* Add a venv that can generate/write/update the states diagram
* Log attempts while trying to sync power state
* Disable clean\_step if config option is set to 0
* Improve iSCSI deployment logs
* supports alembic migration for db2
* Updated from global requirements
* Update iLO documentation for capabilities

2015.1.0
--------

* ironic/tests/drivers/amt: Add autospec=True to mocks
* ironic/tests/drivers/irmc: Add spec\_set & autospec=True
* Updated from global requirements
* ironic/tests/drivers/drac: Add spec\_set= or autospec=True
* Create a 3rd party mock specs file
* Release Import of Translations from Transifex
* Document how to configure Neutron with iPXE
* Remove state transition: CLEANFAIL -> CLEANING
* Remove scripts for migrating nova baremetal
* Add a missing comma and correct some typos
* Remove API reboot from cleaning docs
* Remove scripts for migrating nova baremetal
* Fixed is\_glance\_image(image\_href) predicate logic
* Rearrange some code in PXEDeploy.prepare
* Fixes typo in ironic/api/hooks.py and removes unnecessary parenthesis
* update .gitreview for stable/kilo
* Add cleaning network docs
* Remove ironic compute driver and sched manager
* ironic/tests/drivers/ilo: Add spec= & autospec=True to mocks
* Replace 'metrics' with 'meters' in option
* Update some config option's help strings
* document "scheduler\_use\_baremetal\_filters" option in nova.conf
* Fix heartbeat when clean step in progress
* Fix heartbeat when clean step in progress
* Update ilo drivers documentation for inspection
* Open Liberty development

2015.1.0rc1
-----------

* Local boot note about updated deploy ramdisk
* Convert internal RPC continue\_node\_cleaning to a "cast"
* iLO driver documentation for node cleaning
* Fix typos in vendor-passthru.rst
* Add Ceilometer to Ironic's Conceptual Architecture
* Improve AMT driver doc
* iLO driver documentation for UEFI secure boot
* Fix for automated boot iso issue with IPA ramdisk
* Update session headers during initialization of AgentClient
* Agent driver fails without Ironic-managed TFTP
* Add notes about upgrading juno->kilo to docs
* Address comments on I5cc41932acd75cf5e9e5b626285331f97126932e
* Use mock patch decorator for eventlet.greenthread.sleep
* Cleanup DHCPFactory.\_dhcp\_provider after tests
* Follow-up to "Add retry logic to \_exec\_ipmitool"
* Nit fixes for boot\_mode being overwritten
* Update installation service overview
* Don't pass boot\_option: local for whole disk images
* Fixup post-merge comments on cleaning document
* Use hexhyp instead of hexraw iPXE type
* Fix exception handling in Glance image service
* Update proliantutils version required for K release
* Fix type of value in error middleware response header
* Imported Translations from Transifex
* Fix mocks not being stopped as intended
* Add maintenance check before call do\_node\_deploy
* Fix VM stuck when deploying with pxe\_ssh + local boot
* Fix bad quoting in quickstart guide
* Set hash seed to 0 in gendocs environment
* boot\_mode is overwritten in node properties
* Add retry logic to \_exec\_ipmitool
* Check status of bootloader installation for DIB ramdisk
* Add missing mock for test\_create\_cleaning\_ports\_fail
* Shorten time for unittest test\_download\_with\_retries
* Disable XML now that we have WSME/Pecan support
* tests/db: Add autospec=True to mocks
* Sync with oslo.incubator
* Enable cleaning by default
* Improve error handling when JSON is not returned by agent
* Fix help string for glance auth\_strategy option
* Document ports creating configuration for in-band inspection
* Remove DB tests workarounds
* Fix formatting issue in install guide
* Add missing test for DB migration 2fb93ffd2af1
* Regenerate states diagram after addition of CLEANING
* Fix UnicodeEncodeError issue when the language is not en\_US
* pxe deploy fails for whole disk images in UEFI
* Remove setting language to en\_US for 'venv'
* Add config drive documentation
* Refactor test code to reduce duplication
* Mock time.sleep() for two unittests
* Clarify message for power action during cleaning
* Add display-name option to example apache2 configuration
* New field 'name' not supported in port REST API
* Update doc for test database migrations
* Add PXE-AMT driver's support of IPA ramdisk
* Fix cleaning nits
* Update docs: No power actions during cleaning
* Prevent power actions on node in cleaning
* Followup to comments on Cleaning Docs
* Remove inspect\_ports from ilo inspection
* Removed hardcoded IDs from "chassis" test resources
* Fix is\_hostname\_safe for RFC compliance
* Enable pxe\_amt driver with localboot
* Improve backwards compat on API behaviour
* Use node UUID in logs instead of node ID
* Add IPA to enable drivers doc's page
* Top level unit tests: Use autospec=True for mocks
* DRAC: power on during reboot if powered off
* Update pythonseamicroclient package version
* A wrong variable format used in msg of ilo:
* Add documentation for Cleaning
* Explictly state that reboot is expected to work with powered off nodes
* Prevent updating the node's driver if console is enabled
* Agent driver: no-op heartbeat for maintenanced node
* Deploys post whole disk image deploy fails
* Allow node.instance\_uuid to be removed during cleaning
* Attach ilo\_boot\_iso only if node is active
* Ensure configdrive isn't mounted for ilo drivers
* Ensure configdrive isn't mounted for ipxe/elilo
* Correct update\_dhcp\_opts methods
* Fix broken unittests usage of sort()
* Add root device hints documentation
* Ensure configdrive isn't mounted in CoreOS ramdisks
* Add local boot with partition images documentation
* Add a return after saving node power state
* Fix formatting error in states\_to\_dot
* pxe partition image deploy fails in UEFI boot mode
* Updated from global requirements
* Fix common misspellings
* Ilo drivers sets capabilities:boot\_mode in node
* Add whole disk image support for iscsi\_ilo using agent ramdisk
* Fixed nits for secure boot support for iLO Drivers
* Fix typos in ironic/ironic/drivers/modules
* fix invalid asserts in tests
* Fail deploy if root uuid or disk id isn't available
* Hide new fields via single method
* Update "Ironic as a standalone service" documentation
* DRAC: add retry capability to wsman client operations
* Secure boot support for agent\_ilo driver
* Secure boot support for iscsi\_ilo driver
* Changes for secure boot support for iLO drivers

2015.1.0b3
----------

* follow up patch for ilo capabilities
* Support agent\_ilo driver to perform cleaning
* Implement cleaning/zapping for the agent driver
* Add Cleaning Operations for iLO drivers
* Automate uefi boot iso creation for iscsi\_ilo driver
* Generate keystone\_authtoken options in sample config file
* Use task.spawn\_after to maintain lock during cleaning
* is\_whole\_disk\_image might not exist for previous instances
* Hide inspection\_\*\_at fields if version < 1.6
* Disable cleaning by default
* Suppress urllib3.connection INFO level logging
* Allow periods (".") in hostnames
* iscsi\_ilo driver do not validate boot\_option
* Sync from oslo.incubator
* Common changes for secure boot support
* Add pxe\_irmc to the sending IPMI sensor data driver list
* iLO driver updates node capabilities during inspection
* iLO implementation for hardware inspection
* Address nits in uefi agent iscsi deploy commit
* Raise exception for Agent Deploy driver when using partition images
* Add uefi support for agent iscsi deploy
* Enable agent\_ilo for uefi-bios switching
* Fixup log message for discoverd
* Update unittests and use NamedTemporaryFile
* Rename \_continue\_deploy() to pass\_deploy\_info()
* Write documentation for hardware inspection
* Start using in-band inspection
* Log message is missing a blank space
* Address comments on cleaning commit
* IPA: Add support for root device hints
* Use Mock.patch decorator to handle patching amt management module
* iscsi\_ilo driver to support agent ramdisk
* Enhance AMT driver documentation, pt 2
* Implement execute clean steps
* Add missing exceptions to destroy\_node docstrings
* Force LANGUAGE=en\_US in test runs
* Add validations for root device hints
* Add localboot support for uefi boot mode
* ironic port deletion fails even if node is locked by same process
* Add whole disk image support in iscsi\_ilo driver
* Enhance AMT driver documentation
* Use oslo\_policy package
* Use oslo\_context package
* Adds support for deploying whole disk images
* Add AMT-PXE driver doc
* Fix two typos
* Add node UUID to deprecated log message
* Fix wrong chown command in deployment guide
* PXE driver: Deprecate pxe\_deploy\_{ramdisk, kernel}
* Add label to virtual floppy image
* Make sure we don't log the full content of the config drive
* Update API doc to reflect node uuid or name
* Fix typo agaist->against
* Use strutils from oslo\_utils
* Updated from global requirements
* Add AMT-PXE-Driver Power&Management&Vendor Interface
* Fix wrong log output in ironic/ironic/conductor/manager.py
* Refactor agent iscsi deploy out of pxe driver
* Tiny improvement of efficient
* Make try block shorter for \_make\_password\_file
* Add module for in-band inspection using ironic-discoverd
* Fix take over for agent driver
* Add server-supported min and max API version to HTTPNotAcceptable(406)
* Updated from global requirements
* Add tftp mapfile configuration in install-guide
* Fix nits in cleaning
* Fix nits for supporting non-glance images
* Follow-up patch for generic node inspection
* Add a note to dev-quickstart
* Add iter\_nodes() helper to the conductor manager
* Implement Cleaning in DriverInterfaces
* Update install-guide for Ubuntu 14.10 package changes
* Use mock instead of fixtures when appropriate
* Generic changes for Node Inspection
* Fix typo in "Enabling Drivers"
* Support for non-Glance image references
* Create new config for pecan debug mode
* Local boot support for IPA
* PXE drivers support for IPA
* Update documentation on VirtualBox drivers
* Add localboot support for iscsi\_ilo driver
* Improve last\_error for async exceptions
* Fix IPMI support documentation
* Root partition should be bootable for localboot
* Updated from global requirements
* Add iRMC Management module for iRMC Driver
* Spelling error in Comment
* Remove unused code from agent vendor lookup()
* Add documentation for VirtualBox drivers
* Implement Cleaning States
* Missing mock causing long tests
* Add support for 'latest' in microversion header
* Add tests for ilo\_deploy driver
* Fix reboot logic of iRMC Power Driver
* Update the states generator and regenerate the image
* Ensure state values are 15 characters or less
* Minor changes to InspectInterface
* INSPECTFAIL value is more readable
* Disable n-novnc, heat, cinder and horizon on devstack
* Return required properties for agent deploy driver
* Remove unused modules from ironic/openstack/common
* Use functions from oslo.utils
* Update Ilo drivers to use REST API interface to iLO
* Add dhcp-all-interfaces to get IP to NIC other than eth0
* Log exception on tear\_down failure
* Fix PEP8 E124 & E125 errors
* Mock sleep function for OtherFunctionTestCase
* Log node UUID rather than node object
* Updated from global requirements
* Add InspectInterface for node-introspection
* Correctly rebuild the PXE file during takeover of ACTIVE nodes
* Fix PEP8 E121 & E122 errors
* Add documentation for the IPMI retry timeout option
* Use oslo\_utils replace oslo.utils
* Avoid deregistering conductor following SIGUSR1
* Add states required for node-inspection
* For flake8 check, make the 'E12' ignore be more granular
* add retry logic to is\_block\_device function
* Imported Translations from Transifex
* Move oslo.config references to oslo\_config
* Add AMT-PXE-Driver Common Library
* Fix typos in documentation: Capabilities
* Removed unused image file
* Address final comments of a4cf7149fb
* Add concept of stable states to the state machine
* Fix ml2\_conf.ini settings
* Vendorpassthru doesn't get correct 'self'
* Remove docs in proprietary formats
* Fix file permissions in project
* Imported Translations from Transifex
* Updated from global requirements
* Remove deploy\_is\_done() from AgentClient
* AgentVendorInterface: Move to a common place
* Stop console at first if console is enabled when destroy node
* fixed typos from eligable to eligible and delition to deletion
* Add logical name support to Ironic
* Add support for local boot
* Fix chown invalid option -- 'p'
* ipmitool drivers fail with integer passwords
* Add the subnet creation step to the install guide

2015.1.0b2
----------

* improve iSCSI connection check
* Remove min and max from base.Version
* Add list of python driver packages
* Add policy show\_password to mask passwords in driver\_info
* Conductor errors if enabled\_drivers are not found
* Add MANAGEABLE state and associated transitions
* Raise minimum API version to 1.1
* Correct typo in agent\_client
* Fix argument value for work\_on\_disk() in unit test
* Documentation: Describe the 'spacing' argument
* update docstring for driver\_periodic\_task's parallel param
* Use prolianutils module for ilo driver tests
* Add documentation on parallel argument for driver periodic tasks
* Rename provision\_state to power\_state in test\_manager.py
* Refactor ilo.deploy.\_get\_single\_nic\_with\_vif\_port\_id()
* Update agent driver with new field driver\_internal\_info
* Updated from global requirements
* Add support for driver-specific periodic tasks
* Partial revert of 4606716 until we debug further
* Clean driver\_internal\_info when changes nodes' driver
* Add Node.driver\_internal\_info
* Move oslo.config references to oslo\_config
* Move oslo.db references to oslo\_db
* Revert "Do not pass PXE net config from bootloader to ramdisk"
* Bump oslo.rootwrap to 1.5.0
* Drop deprecated namespace for oslo.rootwrap
* Add VirtualBox drivers and its modules
* region missing in endpoint selection
* Add :raises: for Version constructor docstring
* Improve testing of the Node's REST API
* Rename NOSTATE to AVAILABLE
* Add support for API microversions
* Address final comments of edf532db91
* Add missing exceptions into function docstring
* Fix typos in commit I68c9f9f86f5f113bb111c0f4fd83216ae0659d36
* Add logic to store the config drive passed by Nova
* Do not POST conductor\_affinity in tests
* Add 'irmc\_' prefix to optional properties
* Actively check iSCSI connection after login
* Updated from global requirements
* Add iRMC Driver and its iRMC Power module
* Fix drivers.rst doc format error
* Improve test assertion for get\_glance\_image\_properties
* Do not pass PXE net config from bootloader to ramdisk
* Adds get\_glance\_image\_properties
* Fix filter\_query in drac/power interface
* Updated from global requirements
* Simplify policy.json
* Replace DIB installation step from git clone to pip
* Add a TODO file
* Updated from global requirements
* Fix function docstring of \_get\_boot\_iso\_object\_name()
* Improve ironic-dbsync help strings
* Clear locks on conductor startup
* Remove argparse from requirements
* Use oslo\_serialization replace oslo.serialization
* Agent driver fails with Swift Multiple Containers
* Add ipmitool to quickstart guide for Ubuntu
* Allow operations on DEPLOYFAIL'd nodes
* Allow associate an instance independent of the node power state
* Improve docstrings about TaskManager's spawning feature
* DracClient to handle ReturnValue validation
* Fix instance\_info parameters clearing
* DRAC: Fix wsman host verification
* Updated from global requirements
* Clean up ilo's parse\_driver\_info()
* Fix ssh \_get\_power\_status as it returned status for wrong node
* Fix RPCService and Ironic Conductor so they shut down gracefully
* Remove jsonutils from openstack.common
* Remove lockfile from dependencies
* Remove IloPXEDeploy.validate()
* Force glance recheck for kernel/ramdisk on rebuild
* iboot power driver: unbound variable error
* Remove unused state transitions
* PXE: Add configdrive support
* Rename localrc for local.conf
* DracClient to handle ClientOptions creation
* Ensure we don't have stale power state in database after power action
* Remove links autogenerated from module names
* Make DD block size adjustable
* Improve testing of state transitions
* Convert drivers to use process\_event()
* Update service.py to support graceful Service shutdown
* Ensure that image link points to the correct image
* Raise SSH failure messages to the error level
* Make 'method' explicit for VendorInterface.validate()
* Updated from global requirements
* Provided backward compat for enforcing admin policy
* Allow configuration of neutronclient retries
* Convert check\_deploy\_timeout to use process\_event
* Add requests to requirements.txt
* Enable async callbacks from task.process\_event()
* Document dependency on \`fuser\` for pxe driver
* Distinguish between prepare + deploy errors
* Avoid querying the power state twice
* Add state machine to documentation
* Updated from global requirements
* Adjust the help strings to better reflect usage
* Updated from global requirements
* Updated from global requirements
* Update etc/ironic/ironic.conf.sample
* Fix policy enforcement to properly detect admin
* Minor changes to state model
* Add documentation to create in RegionOne
* Delete unnecessary document files
* Updated from global requirements
* display error logging should be improved
* Refactor async helper methods in conductor/manager.py
* Hide oslo.messaging DEBUG logs by default
* add comments for NodeStates fields
* Stop conductor if no drivers were loaded
* Fix typo in install-guide.rst
* Reuse methods from netutils
* Use get\_my\_ipv4 from oslo.utils
* improve the neutron configuration in install-guide
* Refactoring for Ironic policy
* PXE: Pass root device hints via kernel cmdline
* Extend API multivalue fields
* Add a fsm state -> dot diagram generator
* Updated from global requirements
* Update command options in the Installation Guide

2015.1.0b1
----------

* Improve Agent deploy driver validation
* Add new enrollment and troubleshooting doc sections
* Begin using the state machine for node deploy/teardown
* Add base state machine
* Updated from global requirements
* Get rid of set\_failed\_state duplication
* Remove Python 2.6 from setup.cfg
* Updated from global requirements
* Update dev quick-start for devstack
* Updated from global requirements
* Correct vmware ssh power manager
* rename oslo.concurrency to oslo\_concurrency
* Remove duplicate dependencies from dev-quickstart docs
* Do not strip 'glance://' prefix from image hrefs
* Updated from global requirements
* Fix image\_info passed to IPA for image download
* Use Literal Blocks to write code sample in docstring
* Workflow documentation is now in infra-manual
* Add tests to iscsi\_deploy.build\_deploy\_ramdisk\_options
* Fix for broken deploy of iscsi\_ilo driver
* Updated from global requirements
* Add info on creating a tftp map file
* Add documentation for SeaMicro driver
* Fixed typo in Drac management driver test
* boot\_devices.PXE value should match with pyghmi define
* Add decorator that requires a lock for Drac management driver
* Remove useless deprecation warning for node-update maintenance
* Ilo tests refactoring
* Change some exceptions from invalid to missing
* Add decorator that requires a lock for Drac power driver
* Change methods from classmethod to staticmethod
* iLO Management Interface
* Improve docs for running IPA in Devstack
* Update 'Introduction to Ironic' document
* Avoid calling \_parse\_driver\_info in every test
* Updated from global requirements
* Correct link in user guide
* Minor fix to install guide for associating k&r to nodes
* Add serial console feature to seamicro driver
* Support configdrive in agent driver
* Add driver\_validate()
* Update drivers VendorInterface validate() method
* Adds help for installing prerequisites on RHEL
* Add documentation about Vendor Methods
* Make vendor methods discoverable via the Ironic API
* Fix PXEDeploy class docstring
* Updated from global requirements
* Vendor endpoints to support different HTTP methods
* Add ipmitool as dependency on RHEL/Fedora systems
* dev-quickstart.rst update to add required packages
* Add gendocs tox job for generating the documentation
* Add gettext to packages needed in dev quickstart
* Convert qcow2 image to raw format when deploy
* Update iLO driver documentation
* Disable IPMI timeout before setting boot device
* Updated from global requirements
* ConductorManager catches Exceptions
* Remove unused variable in agent.\_get\_interfaces()
* Enable hacking rule E265
* Add sync and async support for passthru methods
* Fix documentation on Standard driver interfaces
* Add a mechanism to route vendor methods
* Remove redundant FunctionalTest usage in API tests
* Use wsme.Unset as default value for API objects
* Fix traceback on rare agent error case
* Make \_send\_sensor\_data more cooperative
* Updated from global requirements
* Add logging to driver vendor\_passthru functions
* Support ipxe with Dnsmasq
* Correct "returns" line in PXE deploy method
* Remove all redundant setUp() methods
* Update install guide to install tftp
* Remove duplicated \_fetch\_images function
* Change the force\_raw\_image config usage
* Clear maintenance\_reason when setting maintenance=False
* Removed hardcoded IDs from "port" test resources
* Switch to oslo.concurrency
* Updated from global requirements
* Use docstrings for attributes in api/controllers
* Put nodes-related API in same section
* Fix get\_test\_node attributes set incorrectly
* Get new auth token for ramdisk if old will expire soon
* Delete unused 'use\_ipv6' config option
* Updated from global requirements
* Add maintenance to RESTful web API documentation
* Updated from global requirements
* Iterate over glance API servers
* Add API endpoint to set/unset the node maintenance mode
* Removed hardcoded IDs from "node" test resources
* Add maintenance\_reason when setting maintenance mode
* Add Node.maintenance\_reason
* Fix F811 error in pep8
* Improve hash ring value conversion
* Add SNMP driver for Aten PDU's
* Update node-validate error messages
* Store image disk\_format and container\_format
* Continue heartbeating after DB connection failure
* TestAgentVendor to use the fake\_agent driver
* Put a cap on our cyclomatic complexity
* More helpful failure for tests on noexec /tmp
* Update doc headers at end of Juno
* Fix E131 PEP8 errors

2014.2
------

* Add the PXE VendorPassthru interface to PXEDracDriver
* Add documentation for iLO driver(s)
* Enable E111 PEP8 check
* Updated from global requirements
* Fix F812 PEP8 error
* Enable H305 PEP8 check
* Enable H307 PEP8 check
* Updated from global requirements
* Enable H405 PEP8 check
* Enable H702 PEP8 check
* Enable H904 PEP8 check
* Migration to oslo.serialization
* Add the PXE VendorPassthru interface to PXEDracDriver
* Adds instructions for deploying instances on real hardware
* Fix pep8 test
* Add missing attributes to sample API objects
* Fix markup-related issues in documentation
* Add documentation for PXE UEFI setup

2014.2.rc2
----------

* Clear hash ring cache in get\_topic\_for\*
* Fix exceptions names and messages for Keystone errors
* Remove unused change\_node\_maintenance\_mode from rpcapi
* Imported Translations from Transifex
* Clear hash ring cache in get\_topic\_for\*
* Move database fixture to a separate test case
* KeyError from AgentVendorInterface.\_heartbeat()
* Validate the power interface before deployment
* Cleans up some Sphinx rST warnings in Ironic
* Remove kombu as a dependency for Ironic

2014.2.rc1
----------

* Make hash ring mapping be more consistent
* Add periodic task to rebuild conductor local state
* Open Kilo development
* Add "affinity" tracking to nodes and conductors
* ilo\* drivers to use only ilo credentials
* Update hacking version in test requirements
* Add a call to management.validate(task)
* Replace custom lazy loading by stevedore
* Updated from global requirements
* Remove useless variable in migration
* Use DbTestCase as test base when context needed
* For convention rename the first classmethod parameter to cls
* Always reset target\_power\_state in node\_power\_action
* Imported Translations from Transifex
* Stop running check\_uptodate in the pep8 testenv
* Add HashRingManager to wrap hash ring singleton
* Fix typo in agent validation code
* Conductor changes target\_power\_state before starting work
* Adds openSUSE support for developer documentation
* Updated from global requirements
* Remove untranslated PO files
* Update ironic.conf.sample
* Remove unneeded context initialization in tests
* Force the SSH commands to use their default language
* Add parameter to override locale to utils.execute
* Refactor PXE clean up tests
* Updated from global requirements
* Don't reraise Exceptions from agent driver
* Add documentation for ironic-dbsync command
* Do not return 'id' in REST API error messages
* Separate the agent driver config from the base localrc config
* pxe\_ilo driver to call iLO set\_boot\_device
* Remove redundant context parameter
* Update docs with new dbsync command
* Update devstack docs, require Ubuntu 14.04
* Do not use the context parameter on refresh()
* Pass ipa-driver-name to agent ramdisk
* Do not set the context twice when forming RPC objects
* Make context mandatory when instantiating a RPC object
* Neutron DHCP implementation to raise exception if no ports have VIF
* Do not cache auth token in Neutron DHCP provider
* Imported Translations from Transifex
* add\_node\_capability and rm\_node\_capability unable to save changes to db
* Updated from global requirements
* Handle SNMP exception error.PySnmpError
* Use standard locale in list\_partitions
* node\_uuid should not be used to create test port
* Revert "Revert "Search line with awk itself and avoid grep""
* Fix code error in pxe\_ilo driver
* Add unit tests for SNMPClient
* Check whether specified FS is supported
* Sync the doc with latest code
* Add a doc note about the vendor\_passthru endpoint
* Remove 'incubated' documentation theme
* Import modules for fake IPMINative/iBoot drivers
* Allow clean\_up with missing image ref
* mock.called\_once\_with() is not a valid method
* Fix Devstack docs for zsh users
* Fix timestamp column migration
* Update ironic states and documentation
* Stop using intersphinx
* Updated from global requirements
* Remove the objectify decorator
* Add reserve() and release() to Node object
* Add uefi boot mode support in IloVirtualMediaIscsiDeploy
* Don't write python bytecode while testing
* Support for setting boot mode in pxe\_ilo driver
* Remove bypassing of H302 for gettextutils markers
* Revert "Search line with awk itself and avoid grep"
* Search line with awk itself and avoid grep
* Add list\_by\_node\_id() to Port object
* Remove unused modules from openstack-common.conf
* Sync the document with the current implementation
* Unify the sensor data format
* Updated from global requirements
* Deprecate Ironic compute driver and sched manager
* Log ERROR power state in node\_power\_action()
* Fix compute\_driver and scheduler\_host\_manager in install-guide
* Use oslo.utils instead of ironic.openstack.common
* Use expected, actual order for PXE template test
* Fix agent PXE template
* Translator functions cleanup part 3
* Translator functions cleanup part 2
* Imported Translations from Transifex
* Updated from global requirements
* Remove XML from api doc samples
* Update ironic.conf.sample
* Fix race conditions running pxe\_utils tests in parallel
* Switch to "incubating" doc theme
* Minor fixes for ipminative console support
* Translator functions cleanup part 4
* Translator functions cleanup part 1
* Remove unnecessary mapping from Agent drivers
* mock.assert\_called\_once() is not valid method
* Use models.TimestampMixin from oslo.db
* Updated from global requirements

2014.2.b3
---------

* Driver merge review comments from 111425
* Nova review updates for \_node\_resource
* Ignore backup files
* IloVirtualMediaAgent deploy driver
* IloVirtualMediaIscsi deploy driver
* Unbreak debugging via testr
* Interactive console support for ipminative driver
* Add UEFI based deployment support in Ironic
* Adds SNMP power driver
* Control extra space for images conversion in image\_cache
* Use metadata.create\_all() to initialise DB schema
* Fix minor issues in the DRAC driver
* Add send-data-to-ceilometer support for pxe\_ipminative driver
* Reduce redundancy in conductor manager docstrings
* Fix typo in PXE driver docstrings
* Update installation guide for syslinux 6
* Updated from global requirements
* Imported Translations from Transifex
* Avoid deadlock when logging network\_info
* Implements the DRAC ManagementInterface for get/set boot device
* Rewrite images tests with mock
* Add boot\_device support for vbox
* Remove gettextutils \_ injection
* Make DHCP provider pluggable
* DRAC wsman\_{enumerate, invoke}() to return an ElementTree object
* Remove futures from requirements
* Script to migrate Nova BM data to Ironic
* Imported Translations from Transifex
* Updated from global requirements
* Fix unit tests with keystoneclient master
* Add support for interacting with swift
* properly format user guide in RST
* Updated from global requirements
* Fix typo in user-guide.rst
* Add console interface to agent\_ipmitool driver
* Add support for creating vfat and iso images
* Check ERROR state from driver in \_do\_sync\_power\_state
* Set PYTHONHASHSEED for venv tox environment
* Add iPXE Installation Guide documentation
* Add management interface for agent drivers
* Add driver name on driver load exception
* Take iSCSI deploy out of pxe driver
* Set ssh\_virt\_type to vmware
* Update nova driver's power\_off() parameters
* return power state ERROR instead of an exception
* handle invalid seamicro\_api\_version
* Imported Translations from Transifex
* Nova ironic driver review update requests to p4
* Allow rebuild of node in ERROR and DEPLOYFAIL state
* Use cache in node\_is\_available()
* Query full node details and cache
* Add in text for text mode on trusty
* Add Parallels virtualisation type
* IPMI double bridging functionality
* Add DracDriver and its DracPower module
* use MissingParameterValue exception in iboot
* Update compute driver macs\_for\_instance per docs
* Update DevStack guide when querying the image UUID
* Updated from global requirements
* Fix py3k-unsafe code in test\_get\_properties()
* Fix tear\_down a node with missing info
* Remove d\_info param from \_destroy\_images
* Add docs for agent driver with devstack
* Removes get\_port\_by\_vif
* Update API document with BootDevice
* Replace incomplete "ilo" driver with pxe\_ilo and fake\_ilo
* Handle all exceptions from \_exec\_ipmitool
* Remove objectify decorator from dbapi's {get, register}\_conductor()
* Improve exception handling in console code
* Use valid exception in start\_shellinabox\_console
* Remove objectify decorator from dbapi.update\_\* methods
* Add list() to Chassis, Node, Port objects
* Raise MissingParameterValue when validating glance info
* Mechanism to cleanup all ImageCaches
* Driver merge review comments from 111425-2-3
* Raise MissingParameterValue instead of Invalid
* Import fixes from the Nova driver reviews
* Imported Translations from Transifex
* Use auth\_token from keystonemiddleware
* Make swift tempurl key secret
* Add method for deallocating networks on reschedule
* Reduce running time of test\_different\_sizes
* Remove direct calls to dbapi's get\_node\_by\_instance
* Add create() and destroy() to Port object
* Correct \`op.drop\_constraint\` parameters
* Use timeutils from one place
* Add create() and destroy() to Chassis object
* Add iPXE support for Ironic
* Imported Translations from Transifex
* Add posix\_ipc to requirements
* backport reviewer comments on nova.virt.ironic.patcher
* Move the 'instance\_info' fields to GenericDriverFields
* Migration to oslo.utils library
* Fix self.fields on API Port object
* Fix self.fields on API Chassis object
* Sync oslo.incubator modules
* Updated from global requirements
* Expose {set,get}\_boot\_device in the API
* Check if boot device is persistent on ipminative
* Sync oslo imageutils, strutils to Ironic
* Add charset and engine settings to every table
* Imported Translations from Transifex
* Remove dbapi calls from agent driver
* Fix not attribute '\_periodic\_last\_run'
* Implements send-data-to-ceilometer
* Port iBoot PDU driver from Nova
* Log exception with translation
* Add ironic-python-agent deploy driver
* Updated from global requirements
* Imported Translations from Transifex
* Clean up calls to get\_port()
* Clean up calls to get\_chassis()
* Do not rely on hash ordering in tests
* Update\_port should expect MACAlreadyExists
* Imported Translations from Transifex
* Adding swift temp url support
* Push the image cache ttl way up
* Imported Translations from Transifex
* SSH virsh to use the new ManagementInterface
* Split test case in ironic.tests.conductor.test\_manager
* Tune down node\_locked\_retry\_{attempts,interval} config for tests
* Add RPC version to test\_get\_driver\_properties

2014.2.b2
---------

* Import fixes from the Nova driver reviews
* Generalize exception handling in Nova driver
* Fix nodes left in an incosistent state if no workers
* IPMINative to use the new ManagementInterface
* Backporting nova host manager changes into ironic
* Catch oslo.db error instead of sqlalchemy error
* Add a test case for DB schema comparison
* remove ironic-manage-ipmi.filters
* Implement API to get driver properties
* Add drivers.base.BaseDriver.get\_properties()
* Implement retry on NodeLocked exceptions
* SeaMicro to use the new ManagementInterface
* Import fixes from Nova scheduler reviews
* Rename/update common/tftp.py to common/pxe\_utils.py
* Imported Translations from Transifex
* Factor out deploy info from PXE driver
* IPMITool to use the new ManagementInterface
* Use mock.assert\_called\_once\_with()
* Add missing docstrings
* Raise appropriate errors on duplicate Node, Port and Chassis creation
* Add IloDriver and its IloPower module
* Add methods to ipmitool driver
* Use opportunistic approach for migration testing
* Use oslo.db library
* oslo.i18n migration
* Import a few more fixes from the Nova driver
* Set a more generous default image cache size
* Fix wrong test fixture for Node.properties
* Make ComputeCapabilitiesFilter work with Ironic
* Add more INFO logging to ironic/common/service.py
* Clean up nova virt driver test code
* Fix node to chassis and port to node association
* Allow Ironic URL from config file
* Imported Translations from Transifex
* Update webapi doc with link and console
* REST API 'limit' parameter to only accept positive values
* Update docstring for api...node.validate
* Document 'POST /v1/.../vendor\_passthru'
* ManagementInterface {set, get}\_boot\_device() to support 'persistent'
* Use my\_ip for neutron URL
* Updated from global requirements
* Add more INFO logging to ironic/conductor
* Specify rootfstype=ramfs deploy kernel parameter
* Add set\_spawn\_error\_hook to TaskManager
* Imported Translations from Transifex
* Updates the Ironic on Devstack dev documentation
* Simplify error handling
* Add gettextutils.\_L\* to import\_exceptions
* Fix workaround for the "device is busy" problem
* Allow noauth for Neutron
* Minor cleanups to nova virt driver and tests
* Update nova rebuild to account for new image
* Updated from global requirements
* pep8 cleanup of Nova code
* PEP fixes for the Nova driver
* Fix glance endpoint tests
* Update Nova's available resources at termination
* Fix the section name in CONTRIBUTING.rst
* Add/Update docstrings in the Nova Ironic Driver
* Update Nova Ironic Driver destroy() method
* Nova Ironic driver get\_info() to return memory stats in KBytes
* Updates Ironic Guide with deployment information
* Add the remaining unittests to the ClientWrapper class
* Wait for Neutron port updates when using SSHPower
* Fix 'fake' driver unable to finish a deploy
* Update "Exercising the Services Locally" doc
* Fixing hardcoded glance protocol
* Remove from\_chassis/from\_nodes from the API doc
* Prevent updating UUID of Node, Port and Chassis on DB API level
* Imported Translations from Transifex
* Do not delete pxe\_deploy\_{kernel, ramdisk} on tear down
* Implement security groups and firewall filtering methods
* Add genconfig tox job for sample config file generation
* Mock pyghmi lib in unit tests if not present
* PXE to pass hints to ImageCache on how much space to reclaim
* Add some real-world testing on DiskPartitioner
* Eliminate races in Conductor \_check\_deploy\_timeouts
* Use temporary dir for image conversion
* Updated from global requirements
* Move PXE instance level parameters to instance\_info
* Clarify doc: API is admin only
* Mock time.sleep for the IPMI tests
* Destroy instance to clear node state on failure
* Add 'context' parameter to get\_console\_output()
* Cleanup virt driver tests and verify final spawn
* Test fake console driver
* Allow overriding the log level for ironicclient
* Virt driver logging improvements
* ipmitool driver raises DriverLoadError
* VendorPassthru.validate()s call \_parse\_driver\_info
* Enforce a minimum time between all IPMI commands
* Remove 'node' parameter from the validate() methods
* Test for membership should be 'not in'
* Replace mknod() with chmod()
* Factoring out PXE and TFTP functions
* Let ipmitool natively retry commands
* Sync processutils from oslo code
* Driver interface's validate should return nothing
* Use .png instead of .gif images
* Fix utils.execute() for consistency with Oslo code
* remove default=None for config options

2014.2.b1
---------

* Stop ipmitool.validate from touching the BMC
* Set instance default\_ephemeral\_device
* Add unique constraint to instance\_uuid
* Add node id to DEBUG messages in impitool
* Remove 'node' parameter from the Console and Rescue interfaces
* TaskManager: Only support single node locking
* Allow more time for API requests to be completed
* Add retry logic to iscsiadm commands
* Wipe any metadata from a nodes disk
* Rework make\_partitions logic when preserve\_ephemeral is set
* Fix host manager node detection logic
* Add missing stats to IronicNodeState
* Update IronicHostManager tests to better match how code works
* Update Nova driver's list\_instance\_uuids()
* Remove 'fake' and 'ssh' drivers from default enabled list
* Work around iscsiadm delete failures
* Mock seamicroclient lib in unit tests if not present
* Cleanup mock patch without \`with\` part 2
* Add \_\_init\_\_.py for nova scheduler filters
* Skip migrations test\_walk\_versions instead of pass
* Improving unit tests for \_do\_sync\_power\_state
* Fix AttributeError when calling create\_engine()
* Reuse validate\_instance\_and\_node() Nova ironic Driver
* Fix the logging message to identify node by uuid
* Fix concurrent deletes in virt driver
* Log exceptions from deploy and tear\_down
* PXE driver to validate the requested image in Glance
* Return the HTTP Location for accepted requestes
* Return the HTTP Location for newly created resources
* Fix tests with new keystoneclient
* list\_instances() to return a list of instances names
* Pass kwargs to ClientWrapper's call() method
* Remove 'node' parameter from the Power interface
* Set the correct target versions for the RPC methods
* Consider free disk space before downloading images into cache
* Change NodeLocked status code to a client-side error
* Remove "node" parameter from methods handling power state in docs
* Add parallel\_image\_downloads option
* Synced jsonutils from oslo-incubator
* Fix chassis bookmark link url
* Remove 'node' parameter from the Deploy interface
* Imported Translations from Transifex
* Remove all mostly untranslated PO files
* Cleanup images after deployment
* Fix wrong usage of mock methods
* Using system call for downloading files
* Run keepalive in a dedicated thread
* Don't translate debug level logs
* Update dev quickstart guide for ephemeral testing
* Speed up Nova Ironic driver tests
* Renaming ironicclient exceptions in nova driver
* Fix bad Mock calls to assert\_called\_once()
* Cleanup mock patch without \`with\` part 1
* Corrects a typo in RESTful Web API (v1) document
* Updated from global requirements
* Clean up openstack-common.conf
* Remove non-existent 'pxe\_default\_format' parameter from patcher
* Remove explicit dependency on amqplib
* Pin RPC client version min == max
* Check requested image size
* Fix 'pxe\_preserve\_ephemeral' parameter leakage
* RPC\_API\_VERSION out of sync
* Simplify calls to ImageCache in PXE module
* Implement the reboot command on the Ironic Driver
* Place root partition last so that it can always be expanded
* Stop creating a swap partition when none was specified
* Virt driver change to use API retry config value
* Implement more robust caching for master images
* Decouple state inspection and availability check
* Updated from global requirements
* Fix ironic node state comparison
* Add create() and destroy() to Node
* Fix typo in rpcapi.driver\_vendor\_passthru
* Support serial console access
* Remove 'node' parameter from the VendorPassthru interface
* Updated from global requirements
* Synced jsonutils from oslo-incubator
* Fix chassis-node relationship
* Implement instance rebuild in nova.virt.driver
* Sync oslo logging
* Add ManagementInterface
* Clean oslo dependencies files
* Return error immediately if set\_console\_mode is not supported
* Fix bypassed reference to node state values
* Updated from global requirements
* Port to oslo.messaging
* Drivers may expose a top-level passthru API
* Overwrite instance\_exists in Nova Ironic Driver
* Update Ironic User Guide post landing for 41af7d6b
* Spawn support for TaskManager and 2 locking fixes
* Document ClusteredComputeManager
* Clean up calls to get\_node()
* nova.virt.ironic passes ephemeral\_gb to ironic
* Implement list\_instance\_uuids() in Nova driver
* Modify the get console API
* Complete wrapping ironic client calls
* Add worker threads limit to \_check\_deploy\_timeouts task
* Use DiskPartitioner
* Better handling of missing drivers
* Remove hardcoded node id value
* cleanup docstring for drivers.utils.get\_node\_mac\_addresses
* Update ironic.conf.sample
* Make sync\_power\_states yield
* Refactor sync\_power\_states tests to not use DB
* Add DiskPartitioner
* Some minor clean up of various doc pages
* Fix message preventing overwrite the instance\_uuid
* Install guide for Ironic
* Refactor the driver fields mapping
* Imported Translations from Transifex
* Fix conductor.manager test assertion order
* Overwriting node\_is\_available in IronicDriver
* Sync oslo/common/excutils
* Sync oslo/config/generator
* Cherry pick oslo rpc HA fixes
* Add Ironic User Guide
* Remove a DB query for get\_ports\_by\_node()
* Fix missed stopping of conductor service
* Encapsulate Ironic client retry logic
* Do not sync power state for new invalidated nodes
* Make tests use Node object instead of dict
* Sync object list stuff from Nova
* Fix Node object version
* Cleanup running conductor services in tests
* Factor hash ring management out of the conductor
* Replace sfdisk with parted
* Handling validation in conductor consistently
* JsonPatch add operation on existing property
* Updated from global requirements
* Remove usage of Glance from PXE clean\_up()
* Fix hosts mapping for conductor's periodic tasks
* Supports filtering port by address
* Fix seamicro power.validate() method definition
* Update tox.ini to also run nova tests
* Updated from global requirements
* Fix messages formatting for \_sync\_power\_states
* Refactor nova.virt.ironic.driver get\_host\_stats
* Use xargs -0 instead of --null
* Change admin\_url help in ironic driver
* Sync base object code with Nova's
* Add Node.instance\_info field
* Fix self.fields on API Node object
* Show maintenance field in GET /nodes
* Move duplicated \_get\_node(s)\_mac\_addresses()
* Fix grammar in error string in pxe driver
* Reduce logging output from non-Ironic libraries
* Open Juno development

2014.1.rc1
----------

* Fix spelling error in conductor/manager
* Improved coverage for ironic API
* Manually update all translated strings
* Check that all po/pot files are valid
* If no swap is specified default to 1MB
* Fix Nova rescheduling tear down problem
* Remove obsolete po entries - they break translation jobs
* Add note to ssh about impact on ci testing
* Adds exact match filters to nova scheduler
* Clean up IronicNodeStates.update\_from\_compute\_node
* ironic\_host\_manager was missing two stats
* Imported Translations from Transifex
* Fix seamicro validate() method definition
* Remove some obsolete settings from DevStack doc
* Raise unexpected exceptions during destroy()
* Start using oslosphinx theme for docs
* Provide a new ComputeManager for Ironic
* Nova Ironic driver to set pxe\_swap\_mb in Ironic
* Fix strings post landing for c63e1d9f6
* Run periodic\_task in a with a dynamic timer
* Update SeaMicro to use MixinVendorInterface
* Run ipmi power status less aggressively
* Avoid API root controller dependency on v1 dir
* Update Neutron if mac address of the port changed
* Replace fixtures with mock in test\_keystone.py
* Decrease running time of SeaMicro driver tests
* Remove logging of exceptions from controller's methods
* Imported Translations from Transifex
* Fix missed exception raise in \_add\_driver\_fields
* Speed up ironic tests
* Pass no arguments to \_wait\_for\_provision\_state()
* Adds max retry limit to sync\_power\_state task
* Updated from global requirements
* Imported Translations from Transifex
* Stop incorrectly returning rescue: supported
* Correct version.py and update current version string
* Documentation for deploying DevStack /w Ironic
* Hide rescue interface from validate() output
* Change set\_console\_mode() to use greenthreads
* Fix help string for a glance option
* Expose API for fetching a single driver
* Change JsonEncodedType.impl to TEXT
* Fix traceback hook for avoid duplicate traces
* Fix 'spacing' parameters for periodic tasks
* Permit passing SSH keys into the Ironic API
* Better instance-not-found handling within IronicDriver
* Make sure auth\_url exists and is not versionless
* Conductor de-registers on shutdown
* Change deploy validation exception handling
* Suppress conductor logging of expected exceptions
* Remove unused method from timeutils
* Add admin\_auth\_token option for nova driver
* Remove redundant nova virt driver test
* Process public API list as regular expressions
* Enable pep8 tests for the Nova Ironic Driver
* Fix typo tenet -> tenant
* Stop logging paramiko's DEBUG and INFO messages
* Set boot device to PXE when deploying
* Driver utils should raise unsupported method
* Delete node while waiting for deploy
* Check BMC availability in ipmitool 'validate' method
* SeaMicro use device parameter for set\_boot\_device
* Make the Nova Ironic driver to wait for ACTIVE
* Fix misspelled impi to ipmi
* Do not use \_\_builtin\_\_ in python3
* Use range instead xrange to keep python 3.X compatibility
* Set the database.connection option default value
* PXE validate() to fail if no Ironic API URL
* Improve Ironic Conductor threading & locks
* Generic MixinVendorInterface using static mapping
* Conductor logs better error if seamicroclient missing
* Add TaskManager lock on change port data
* Nova ironic driver to retry on HTTP 503
* Mark hash\_replicas as experimental
* do\_node\_deploy() to use greenthreads
* Move v1 API tests to separate v1 directory
* Pin iso8601 logging to WARN
* Only fetch node once for vif actions
* Fix how nova ironic driver gets flavor information
* Imported Translations from Transifex
* API: Add sample() method to remaining models
* Import Nova "ironic" driver
* Remove errors from API documentation
* Add libffi-dev(el) dependency to quickstart
* Updated from global requirements
* Remove redundant default value None for dict.get

2014.1.b3
---------

* Refactor vendor\_passthru to use conductor async workers
* Fix wrong exception raised by conductor for node
* Fix params order in assertEqual
* Sync the log\_handler from oslo
* Fix SeaMicro driver post landing for ba207b4aa0
* Implements SeaMicro VendorPassThru functionality
* Implement the SeaMicro Power driver
* Fix provision\_updated\_at deserialization
* Remove jsonutils from test\_rpcapi
* Do not delete a Node which is not powered off
* Add provision\_updated\_at to node's resource
* Prevent a node in maintenance from being deployed
* Allow clients to mark a node as in maintenance
* Support preserve\_ephemeral
* Updated from global requirements
* API: Expose a way to start/stop the console
* Add option to sync node power state from DB
* Make the PXE driver understand ephemeral disks
* Log deploy\_utils.deploy() erros in the PXE driver
* Removing get\_node\_power\_state, bumping RPC version
* Add timeout for waiting callback from deploy ramdisk
* Prevent GET /v1/nodes returning maintenance field
* Suggested improvements to \_set\_boot\_device
* Move ipminative \_set\_boot\_device to VendorPassthru
* Sync common db code from Oslo
* PXE clean\_up() to remove the pxe\_deploy\_key parameter
* Add support for custom libvirt uri
* Python 3: replace "im\_self" by "\_\_self\_\_"
* Fix race condition when deleting a node
* Remove extraneous vim configuration comments for ironic
* Do not allow POST ports and chassis internal attributes
* Do not allow POST node's internal attributes
* Unused 'pxe\_key\_data' & 'pxe\_instance\_name' info
* Add provision\_updated\_at field to nodes table
* Exclude nodes in DEPLOYWAIT state from \_sync\_power\_states
* Sync common config module from Oslo
* Get rid object model \`dict\` methods part 4
* Sync Oslo rpc module to Ironic
* Clarify and fix the dev-quickstart doc some more
* Do not use CONF as a default parameter value
* Simplify locking around acquiring Node resources
* Improve help strings
* Remove shebang lines from code
* Use six.moves.urllib.parse instead of urlparse
* Add string representation method to MultiType
* Fix test migrations for alembic
* Sync Oslo gettextutils  module to Ironic
* NodeLocked returns 503 error status
* Supports OPERATOR priv level for ipmitool driver
* Correct assertEqual order from patch e69e41c99fb
* PXE and SSH validate() method to check for a port
* Task object as paramater to validate() methods
* Fix dev-quick-start.rst post landing for 9d81333fd0
* API validates driver name for both POST and PATCH
* Sync Oslo service module to Ironic
* Move ipmitool \_set\_boot\_device to VendorPassthru
* Use six.StringIO/BytesIO instead of StringIO.StringIO
* Add JSONEncodedType with enforced type checking
* Correct PXEPrivateMethodsTestCase.setUp
* Don't raise MySQL 2013 'Lost connection' errors
* Use the custom wsme BooleanType on the nodes api
* Add wsme custom BooleanType type
* Fix task\_manager acquire post landing for c4f2f26ed
* Add common.service config options to sample
* Removes use of timeutils.set\_time\_override
* Replace assertEqual(None, \*) with assertIsNone in tests
* Replace nonexistent mock assert methods with real ones
* Log IPMI power on/off timeouts
* Remove None as default value for dict get()
* Fix autodoc formatting in pxe.py
* Fix race condition when changing node states
* Use StringType from WSME
* Add testing and doc sections to docs/dev-quickstart
* Implement \_update\_neutron in PXE driver
* Remove \_load\_one\_plugin fallback
* SSHPower driver support VMware ESXi
* Make ironic-api not single threaded
* Remove POST calls in tests for resource creation
* Add topic to the change\_node\_maintenance\_mode() RPC method
* Fix API inconsistence when changing node's states
* Add samples to serve API through Apache mod\_wsgi
* Add git dependency to quickstart docs
* Add get\_console() method
* Remove unnecessary json dumps/loads from tests
* Add parameter for filtering nodes by maintenance mode
* Rename and update ironic-deploy-helper rootwrap
* Remove tox locale overrides
* Updated from global requirements
* Move eventlent monkeypatch out of cmd/
* Fix misspellings in ironic
* Ensure parameter order of assertEqual correct
* Return correct HTTP response codes for create ops
* Fix broken doc links on the index page
* Allow to tear-down a node waiting to be deployed
* Improve NodeLocked exception message
* Expose 'reservation' field of a node via API
* Implement a multiplexed VendorPassthru example
* Fix log and test for NeutronAPI.update\_port\_dhcp\_opts
* Fix 'run\_as\_root' parameter check in utils
* Handle multiple exceptions raised by jsonpatch
* API tests to check for the return codes
* Imported Translations from Transifex
* Move test\_\_get\_nodes\_mac\_addresses
* Removed duplicated function to create a swap fs
* Updated from global requirements
* Add futures to requirements
* Fix missing keystone option in ironic.conf.sample
* Adds Neutron support to Ironic
* Replace CONF.set\_default with self.config
* Fix ssh\_port type in \_parse\_driver\_info() from ssh.py
* Improve handling of invalid input in HashRing class
* Sync db.sqlalchemy code from Oslo
* Add lockfile>=0.8 to requirements.txt
* Remove net\_config\_template options
* Remove deploy kernel and ramdisk global config
* Update docstrings in ssh.py
* SSHPower driver raises IronicExceptions
* mock's return value for processutils.ssh\_execute
* API: Add sample() method on Node
* Update method doc strings in pxe.py
* Minor documentation update
* Removed unused exceptions
* Bump version of sphinxcontrib-pecanwsme
* Add missing parameter in call to \_load\_one\_plugin
* Docstrings for ipmitool
* alembic with initial migration and tests
* Update RPC version post-landing for 9bc5f92fb
* ipmitool's \_power\_status raises IPMIFailure

2014.1.b2
---------

* Add [keystone\_authtoken] to ironic.conf.sample
* Updated from global requirements
* Add comment about node.instance\_uuid
* Run mkfs as root
* Remove the absolute paths from ironic-deploy-helper.filters
* PXE instance\_name is no longer mandatory
* Remove unused config option - pxe\_deploy\_timeout
* Delete the iscsi target
* Imported Translations from Transifex
* Fix non-unique tftp dir instance\_uuid
* Fix non-unique pxe driver 'instance\_name'
* Add missing "Filters" section to the ironic-images.filters
* Use oslo.rootwrap library instead of local copy
* Replace assertTrue with explicit assertIsInstance
* Disallow new provision for nodes in maintenance
* Add RPC method for node maintenance mode
* Fix keystone get\_service\_url filtering
* Use same MANAGER\_TOPIC variable
* Implement consistent hashing of nodes to conductors
* PXEAndSSH driver lacked vendor\_passthru
* Use correct auth context inside pxe driver
* sync\_power\_states handles missing driver info
* Enable $pybasedir value in pxe.py
* Correct SSHPowerDriver validate() exceptions
* API to check the requested power state
* Improve the node driver interfaces validation output
* Remove copyright from empty files
* Make param descriptions more consistent in API
* Imported Translations from Transifex
* Fix wrong message of pxe validator
* Remove unused dict BYTE\_MULTIPLIERS
* Implement API for provisioning
* API to validate UUID parameters
* Make chassis\_uuid field of nodes optional
* Add unit tests for get\_nodeinfo\_list
* Improve error handling in PXE \_continue\_deploy
* Make param names more consistent in API
* Sync config module from oslo
* Fix wrong message of MACAlreadyExists
* Avoid a race when associating instance\_uuid
* Move and rename ValidTypes
* Convert trycmd() to oslo's processutils
* Improve error handling in validate\_vendor\_action
* Passing nodes more consistently
* Add 'next' link when GET maximum number of items
* Check connectivity in SSH driver 'validate' method
* GET /drivers to show a list of active conductors
* Improve method to get list of active conductors
* Refactor /node/<uuid>/state
* Reworks Chassis validations
* Reworks Node validations
* Developer doc index page points to correct API docs
* Fix auto-generated REST API formatting
* Method to generate PXE options for Neutron ports
* Strip '/' from api\_url string for PXE driver
* Add driver interfaces validation
* Command call should log the stdout and stderr
* Add prepare, clean\_up, take\_over methods to deploy
* PEP8-ify imports in test\_ipmitool
* API: Add sample() method on Port and PortCollection
* API: Validate and normalize address
* Handle DBDuplicateEntry on Ports with same address
* Imported Translations from Transifex
* removed wrap\_exception method from ironic/common/exception.py
* Rework patch validation on Ports
* Add JsonPatchType class
* Change default API auth to keystone-based
* Clean up duplicated change-building code in objects
* Add -U to pip install command in tox.ini
* Updated from global requirements
* Add config option for # of conductor replicas
* Port StringType class from WSME trunk
* Add tools/conf/check\_uptodate to tox.ini

2014.1.b1
---------

* Correct error with unicode mac address
* Expose created\_at/updated\_at properties in the REST API
* Import heartbeat\_interval opt in API
* Add power control to PXE driver
* Implement sync\_power\_state periodic task
* Set the provision\_state to DEPLOYFAIL
* Save PKI token in a file for PXE deploy ramdisk
* API ports update for WSME 0.5b6 compliance
* Add heartbeat\_interval to new 'conductor' cfg group
* Add missing hash\_partition\_exponent config option
* If no block devices abort deployment
* Add missing link for drivers resource
* Apply comments to 58558/4 post-landing
* Replace removed xrange in Python3
* Imported Translations from Transifex
* Use addCleanup() in test\_deploy\_utils
* Allow Pecan to use 'debuginfo' response field
* Do not allow API to expose error stacktrace
* Add port address unique constraint for sqlite
* Implement consistent hashing common methods
* Sync some db changes from Oslo
* Bump required version of sqlalchemy-migrate
* Update ironic.conf.sample
* Import uuidutils unit tests from oslo
* Allow FakePower to return node objects power\_state
* Adds doc strings to API FunctionalTest class
* Use oslo's execute() and ssh\_execute() methods
* Remove openstack.common.uuidutils
* Sync common.context changes from olso
* Remove oslo uuidutils.is\_uuid\_like call
* Remove oslo uuidutils.generate\_uuid() call
* Add troubleshoot option to PXE template
* Imported Translations from Transifex
* Add tftp\_server pattern in ironic.conf
* Import HasLength object
* ipmitool SHOULD accept empty username/password
* Imported Translations from Transifex
* Add missing ConfigNotFound exception
* Imported Translations from Transifex
* Add hooks to auto-generate REST API docs
* Imported Translations from Transifex
* Redefined default value of allowed\_rpc\_exception\_modules
* Add last\_error usage to deploy and teardown methods
* Support building wheels (PEP-427)
* Import missing gettext \_ to fix Sphinx error
* sync common.service from oslo
* sync common.periodic\_task from oslo
* sync common.notifier.\* from oslo
* sync common.log from oslo
* sync common.local from oslo
* Sync common utils from Oslo
* Rename parameters
* Accessing a subresource that parent does not exist
* Imported Translations from Transifex
* Changes power\_state and adds last\_error field
* Update openstack/common/lockutils
* sync common.context from oslo
* sync common.config.generator from oslo
* Remove sqlalchemy-migrate 0.7.3 patching
* Fix integer division compatibility in middleware
* Fix node lock in PXE driver
* Imported Translations from Transifex
* Register API options under the 'api' group
* Supporting both Python 2 and Python 3 with six
* Supports get node by instance uuid in API
* Imported Translations from Transifex
* Check invalid uuid for get-by-instance db api
* Fix error handling in ssh driver
* Replace \_\_metaclass\_\_
* Supporting both Python 2 and Python 3 with six
* Pass Ironic API url to deploy ramdisk in PXE driver
* Remove 'basestring' from objects utils
* Allows unicode description for chassis
* Fix a typo in the name of logger method exception
* Don't use deprecated module commands
* Comply with new hacking requirements
* Improve the API doc spec for chassis
* Improve the API doc spec for node
* Updated from global requirements
* Fix i18N compliance
* Add wrapper for keystone service catalog
* Fix test node manager
* Expose /drivers on the API
* Update mailmap for Joe Gordon
* Add mailmap file
* Implement /nodes/UUID/vendor\_passthru in the API
* Add context to TaskManager
* Regenerate the sample config file
* Conductors maintan driver list in the DB
* Group and unify ipmi configurations
* Fix a few missing i18n
* Fix status codes in node controller
* Fix exceptions handling in controllers
* Updated from global requirements
* Support uniform MAC address with colons
* Remove redundant test stubs from conductor/manager
* Remove several old TODO messages
* Supports paginate query for two get nodes DB APIs
* Remove \_driver\_factory class attribute
* Fixes RootController to allow URL without version tag
* Don't allow deletion of associated node
* Remove duplicated db\_api.get\_instance() from tests
* Updated from global requirements
* Do not use string concatenation for localized strings
* Remove the NULL state
* Add DriverFactory
* Adjust native ipmi default wait time
* Be more patient with IPMI and BMC
* Implement db get\_[un]associated\_nodes
* Remove unused nova specific files
* Removes unwanted mox and fixture files
* Removes stubs from unit tests
* Remove unused class/file
* Remove driver validation on node update
* Consolidates TestCase and BaseTestCase
* Fix policies
* Improve error message for ssh
* Fix datetime format in FakeCache
* Fix power\_state set to python object repr
* Updated from global requirements
* Replaces mox with mock for test\_deploy\_utils
* Replaces mox with mock in api's unit tests
* Replaces mox with mock in objects' unit tests
* Replaces mox with mock for conductor unit tests
* fix ssh driver exec command issues
* Fix exceptions error codes
* Remove obsolete redhat-eventlet.patch
* Replaces mox with mock for test\_utils
* Replaces mox with mock for ssh driver unit tests
* Remove nested 'ipmi' dict from driver\_info
* Replace tearDown with addCleanup in unit tests
* Remove nested 'ssh' dict from driver\_info
* Remove nested 'pxe' dict from driver\_info
* Save and validate deployment key in PXE driver
* Implement deploy and tear\_down conductor methods
* Use mock to do unit tests for pxe driver
* Code clean in node controller
* Use mock to do unit tests for ipminative driver
* Replaces mox with mock for ipmitool driver unit tests
* Fix parameter name in wsexpose
* Rename start\_power\_state\_change to change\_node\_power\_state
* Mount iSCSI target and 'dd' in PXE driver
* Add tests for api/utils.py
* Check for required fields on ports
* Replace Cheetah with Jinja2
* Update from global requirements
* Upgrade tox to 1.6
* Add API uuid <-> id mapping
* Doc string and minor clean up for 41976
* Update error return code to match new Pecan release
* Add vendor\_passthru method to RPC API
* Integer types support in api
* Add native ipmi driver
* API GET to return only minimal data
* Fix broken links
* Collection named based on resource type
* Remove nova specific tests
* Changes documentation hyperlinks to be relative
* Replace OpenStack LLC with OpenStack Foundation
* Force textmode consoles
* Implemented start\_power\_state\_change In Conductor
* Updates documentation for tox use
* Drop setuptools\_git dependency
* Fix tests return codes
* Fix misused assertTrue in unit tests
* Prevent updates while state change is in progress
* Use localisation where user visible strings are used
* Update only the changed fields
* Improve parameters validate in PXE driver
* Rename ipmi driver to ipmitool
* Remove jsonutils from PXE driver
* Expose the vendor\_passthru resource
* Driver's validation during node update process implemented
* Public API
* Remove references for the 'task\_state' property
* Use 'provision\_state' in PXE driver
* Updating resources with PATCH
* Add missing unique constraint
* Fix docstring typo
* Removed  templates directory in api config
* Added upper version boundry for six
* Sync models with migrations
* Optimization reserve and release nodes db api methods
* Add missing foreign key
* Porting nova pxe driver to ironic
* API Nodes states
* Fix driver loading
* Move glance image service client from nova and cinder into ironic
* Implement the root and v1 entry points of the API
* Expose subresources for Chassis and Node
* Add checks locked nodes to db api
* Update the dev docs with driver interface description
* Add missing tests for chassis API
* Delete controller to make code easy to read and understood
* Disable deleting a chassis that contains nodes
* Update API documentation
* Add Pagination of collections across the API
* Fix typo in conductor manager
* Remove wsme validate decorator from API
* Add missing tests for ports API
* Modify is\_valid\_mac() for support unicode strings
* Add DB and RPC method doc strings to hook.py
* Delete unused templates
* Use fixture from Oslo
* Move "opportunistic" db migrations tests from Nova
* Build unittests for nodes api
* make api test code more readable
* Add links to API Objects
* Delete Ironic context
* Add tests for existing db migrations
* Add common code from Oslo for db migrations test
* Remove extra pep8/flake8/pyflakes requirements
* Sync requirements with OpenStack/requirements
* Fix up API tests before updating hacking checks
* Add RPC methods for updating nodes
* Run extract\_messages
* Keystone authentiation
* Add serializer param to RPC service
* Import serialization and nesting from Nova Objects
* Implement chassis api actions
* update requires to prevent version cap
* Change validate() to raise instead of returning T/F
* Add helpers for single-node tasks
* Implement port api action
* Modify gitignore to ignore sqlite
* Update resource manager for fixed stevedore issue
* Add dbapi functions
* Remove suds requirement
* Sync install\_venv\_common from oslo
* Move mysql\_engine option to [database] group
* Re-define 'extra' as dict\_or\_none
* Added Python-2.6 to the classifier
* Rename "manager" to "conductor"
* Port from nova: Fix local variable 'root\_uuid' ref
* Created a package for API controllers V1
* Sync requirements with OpenStack/requirements
* Remove unused APICoverage class
* Sync fileutils from oslo-incubator
* Sync strutils from oslo-incubator
* Add license header
* Update get\_by\_uuid function doc in chassis
* Fix various Python 2.x->3.x compat issues
* Improve unit tests for API
* Add Chassis object
* Add Chassis DB model and DB-API
* Delete associated ports after deleting a node
* Virtual power driver is superceded by ssh driver
* Add conf file generator
* Refactored query filters
* Add troubleshoot to baremetal PXE template
* Add err\_msg param to baremetal\_deploy\_helper
* Retry the sfdisk command up to 3 times
* Updated API Spec for new Drivers
* Improve IPMI's \_make\_password\_file method
* Remove spurious print statement from update\_node
* Port middleware error handler from ceilometer API
* Add support for GET /v1/nodes to return a list
* Add object support to API service
* Remove the unused plugin framework
* Improve tests for Node and Port DB objects
* SSH driver doesn't need to query database
* Create Port object
* Add uuid to Port DB model
* Delete Flask Dependence
* Writing Error: nodess to nodes
* Create the Node object
* Restructuring driver API and inheritance
* Remove explicit distribute depend
* Bump version of PBR
* Remove deleted[\_at] from base object
* Make object actions pass positional arguments
* Fix relative links in architecture doc
* Reword architecture driver description
* Remove duplication from README, add link to docs
* Port base object from Nova
* Fix ironic-rootwrap capability
* Add ssh power manager
* Prevent IPMI actions from colliding
* Add TaskManager tests and fix decorator
* Mocked NodeManager can load and mock real drivers
* Add docs for task\_manager and tests/manager/utils
* Fix one typo in index.rst
* Add missing 'extra' field to models.nodes
* More doc updates
* Remove the old README
* More doc updates
* Minor fixes to sphinx docs
* Added API v1 Specification
* Add initial sphinx docs, based on README
* Initial skeleton for an RPC layer
* Log configuration values on API startup
* Don't use pecan to configure logging
* Move database.backend option import
* Remove unused authentication CLI options
* Rename TestCase.flags() to TestCase.config()
* Copy the RHEL6 eventlet workaround from Oslo
* Sync new database config group from oslo-incubator
* Minor doc change for manager and resorce\_manager
* Add support for Sphinx Docs
* Update IPMI driver to work with resource manager
* Add validate\_driver\_info to driver classes
* Implement Task and Resource managers
* Update [reserve|release]\_nodes to accept a tag
* More updates to the README
* Reimplement reserve\_nodes and release\_nodes
* Rename the 'ifaces' table to 'ports'
* Change 'nodes' to use more driver-specific JSON
* Update driver names and base class
* Stop creating a new db IMPL for every request
* Fix double "host" option
* Sync safe changes from oslo-incubator
* Sync rpc changes from oslo-incubator
* Sync log changes from oslo-incubator
* Sync a rootwrap KillFilter fix from oslo-incubator
* Sync oslo-incubator python3 changes
* Add steps to README.rst
* Fix fake bmc driver
* move ironic docs to top level for ease of discovery
* Update the README file development section
* Add some API definitions to the README
* Update the distribute dependency version
* Add information to the project README
* Fixes test\_update\_node by testing updated node
* Fix pep8 errors and make it pass Jenkins tests
* Update IPMI driver for new base class
* Add new base and fake driver classes
* Delete old base and fake classes
* Add a few fixes for the API
* Move strong nova depenencies into temporary dir
* Update IPMI for new DB schema
* Add unit tests for DB API
* Remove tests for old DB
* Add tests for ironic-dbsync
* Remove ironic\_manage
* Implement GET /node/ifaces/<id> in API
* Update exception.py
* Update db models and API
* Implement skeleton for a new DB backend
* Remove the old db implementation
* Implement initial skeleton of a manager service
* Implement initial draft of a Pecan-based API
* Fix IPMI tests
* Move common things to ironic.common
* Fix failing db and deploy\_helper tests
* un-split the db backend
* Rename files and fix things
* Import add'l files from Nova
* update openstack-common.conf and import from oslo
* Added .testr.conf
* Renamed nova to ironic
* Fixed hacking, pep8 and pyflakes errors
* Added project infrastructure needs
* Fix baremetal get\_available\_nodes
* Improve Python 3.x compatibility
* Import and convert to oslo loopingcall
* baremetal: VirtualPowerDriver uses mac addresses in bm\_interfaces
* baremetal: Change input for sfdisk
* baremetal: Change node api related to prov\_mac\_address
* Remove "undefined name" pyflake errors
* Remove unnecessary LOG initialisation
* Define LOG globally in baremetal\_deploy\_helper
* Only call getLogger after configuring logging
* baremetal: Integrate provisioning and non-provisioning interfaces
* Move console scripts to entrypoints
* baremetal: Drop unused columns in bm\_nodes
* Remove print statements
* Delete tests.baremetal.util.new\_bm\_deployment()
* Adds Tilera back-end for baremetal
* Change type of ssh\_port option from Str to Int
* Virtual Power Driver list running vms quoting error
* xenapi: Fix reboot with hung volumes
* Make bm model's deleted column match database
* Correct substring matching of baremetal VPD node names
* Read baremetal images from extra\_specs namespace
* Compute manager should remove dead resources
* Add ssh port and key based auth to VPD
* Add instance\_type\_get() to virt api
* Don't blindly skip first migration
* BM Migration 004: Actually drop column
* Update OpenStack LLC to Foundation
* Sync nova with oslo DB exception cleanup
* Fix exception handling in baremetal API
* BM Migrations 2 & 3: Fix drop\_column statements
* Remove function redefinitions
* Move some context checking code from sqlalchemy
* Baremetal driver returns accurate list of instance
* Identify baremetal nodes by UUID
* Improve performance of baremetal list\_instances
* Better error handling in baremetal spawn & destroy
* Wait for baremetal deploy inside driver.spawn
* Add better status to baremetal deployments
* Use oslo-config-2013.1b4
* Delete baremetal interfaces when their parent node is deleted
* VirtualPowerDriver catches ProcessExecutionError
* Don't modify injected\_files inside PXE driver
* Remove nova.db call from baremetal PXE driver
* Add a virtual PowerDriver for Baremetal testing
* Recache or rebuild missing images on hard\_reboot
* Use oslo database code
* Fixes 'not in' operator usage
* Make sure there are no unused import
* Enable N302: Import modules only
* Correct a format string in virt/baremetal/ipmi.py
* Add REST api to manage bare-metal nodes
* Baremetal/utils should not log certain exceptions
* PXE driver should rmtree directories it created
* Add support for Option Groups in LazyPluggable
* Remove obsolete baremetal override of MAC addresses
* PXE driver should not accept empty kernel UUID
* Correcting improper use of the word 'an'
* Export the MAC addresses of nodes for bare-metal
* Break out a helper function for working with bare metal nodes
* Keep self and context out of error notification payload
* Tests for PXE bare-metal provisioning helper server
* Change ComputerDriver.legacy\_nwinfo to raise by default
* fix new N402 errors
* Remove unused baremetal PXE options
* Move global service networking opts to new module
* Fix N402 for nova/virt
* Cope better with out of sync bm data
* Fix baremetal VIFDriver
* CLI for bare-metal database sync
* attach/detach\_volume() take instance as a parameter
* Convert short doc strings to be on one line
* Check admin context in bm\_interface\_get\_all()
* Provide a PXE NodeDriver for the Baremetal driver
* Refactor periodic tasks
* Add helper methods to nova.paths
* Move global path opts in nova.paths
* Removes unused imports
* Improve baremetal driver error handling
* baremetal power driver takes \*\*kwargs
* Implement IPMI sub-driver for baremetal compute
* Fix tests/baremetal/test\_driver.py
* Move baremetal options to [BAREMETAL] OptGroup
* Remove session.flush() and session.query() monkey patching
* Remove unused imports
* Removed unused imports
* Parameterize database connection in test.py
* Baremetal VIF and Volume sub-drivers
* New Baremetal provisioning framework
* Move baremetal database tests to fixtures
* Add exceptions to baremetal/db/api
* Add blank nova/virt/baremetal/\_\_init\_\_.py
* Move sql options to nova.db.sqlalchemy.session
* Use CONF.import\_opt() for nova.config opts
* Remove nova.config.CONF
* remove old baremetal driver
* Remove nova.flags
* Fix a couple uses of FLAGS
* Added separate bare-metal MySQL DB
* Switch from FLAGS to CONF in tests
* Updated scheduler and compute for multiple capabilities
* Switch from FLAGS to CONF in nova.virt
* Make ComputeDrivers send hypervisor\_hostname
* Introduce VirtAPI to nova/virt
* Migrate to fileutils and lockutils
* Remove ComputeDriver.update\_host\_status()
* Rename imagebackend arguments
* Move ensure\_tree to utils
* Keep the ComputeNode model updated with usage
* Don't stuff non-db data into instance dict
* Making security group refresh more specific
* Use dict style access for image\_ref
* Remove unused InstanceInfo class
* Remove list\_instances\_detail from compute drivers
* maint: remove an unused import in libvirt.driver
* Fixes bare-metal spawn error
* Refactoring required for blueprint xenapi-live-migration
* refactor baremetal/proxy => baremetal/driver
* Switch to common logging
* Make libvirt LoopingCalls actually wait()
* Imports cleanup
* Unused imports cleanup (folsom-2)
* convert virt drivers to fully dynamic loading
* cleanup power state (partially implements bp task-management)
* clean-up of the bare-metal framework
* Added a instance state update notification
* Update pep8 dependency to v1.1
* Alphabetize imports in nova/tests/
* Make use of openstack.common.jsonutils
* Alphabetize imports in nova/virt/
* Replaces exceptions.Error with NovaException
* Log instance information for baremetal
* Improved localization testing
* remove unused flag: baremetal\_injected\_network\_template baremetal\_uri baremetal\_allow\_project\_net\_traffic
* Add periodic\_fuzzy\_delay option
* HACKING fixes, TODO authors
* Add pybasedir and bindir options
* Only raw string literals should be used with \_()
* Remove unnecessary setting up and down of mox and stubout
* Remove unnecessary variables from tests
* Move get\_info to taking an instance
* Exception cleanup
* Backslash continuations (nova.tests)
* Replace ApiError with new exceptions
* Standardize logging delaration and use
* remove unused and buggy function from baremetal proxy
* Backslash continuations (nova.virt.baremetal)
* Remove the last of the gflags shim layer
* Implements blueprint heterogeneous-tilera-architecture-support
* Deleting test dir from a pull from trunk
* Updated to remove built docs
* initial commit
